#!/usr/local/bin/perl
use strict;
#use warnings;
use utf8;
use open ":utf8";
use open ":std";
use CGI::Carp qw(fatalsToBrowser);
use Encode;

my $ver = '1.12';

our %in; my %out; our %co;

require './config.cgi';

### モード判別 ###
&_decode;
if($in{'mode'} eq 'view'){ 
  &member('');
  &view;
  exit;
}
elsif($in{'mode'} eq 'topic') {
  &member('');
}
elsif($in{'mode'} eq 'regist'){
  if($in{'comm'} eq ' '){ $in{'comm'} = '&nbsp;'; }
  ## ダイス
  if($in{'act'} =~ /DICE/i){
    $in{'act'} =~ s/(DICE)([0-9]+)//g;
    my $num = $2; my $chk = $in{'dc'.($num)}; my $sp; my $plural;
    $in{'dh'.($num)} = '//2' if $in{'dh'.($num)};
    $in{'da'.($chk)} =~ s/[:：]([0-9]*)$/$plural=$1; ''/e;
    if($in{"da".($chk)} =~ /^[@＠]/){ $sp = $in{"da".($chk)}; }
    $plural = 1 if !$plural;
    if($in{'dq'.($num)}*$plural > 200 && $plural > 1) {
      $out{'dice'} = 'ダイスの総数が100を超えてはいけません';
    } else {
      if($sp){ require './pl/dice/special.pl'; }
      else   { require './pl/dice/dice.pl'; }
      for (my $i = 0; $i < $plural; $i++) {
        if($sp){ $sp =~ s/^[@＠]//; $out{'dice'} .= &dice_sp::dice_sp($num,$sp,$i,$plural); }
        else   { $out{'dice'} .= &dice::dice($num,undef,$i,$plural); }
      }
    }
    &regist('');
  }
  ## 威力表
  elsif($in{'act'} =~ /RATE/i) {
    require './pl/dice/sw2.pl';
    $in{'act'} =~ s/(RATE)([0-9]+)//g;
    my $num = $2;
    $in{"rh".($num)} = '//2' if $in{"rh".($num)};
    $out{'dice'} = &sw2::rate($2);
    &regist('');
  }
  ## DX判定
  elsif($in{'act'} =~ /DX/i) {
    require './pl/dice/dx3.pl';
    $in{'act'} =~ s/(DX)([0-9]+)//g;
    my $num = $2;
    $out{'dice'} = &dx3::dxdc($num);
    &regist('');
  }
  ## S=F判定
  elsif($in{'act'} =~ /S=F/i) {
    require './pl/dice/s-f.pl';
    $in{'act'} =~ s/(S=F)([0-9]+)//g;
    my $num = $2;
    $out{'dice'} = &s_f::sfdc($num);
    &regist('');
  }
  ## 天羅／エンゼルギア／ドラゴンアームズ判定
  elsif($in{'act'} =~ /AG/i) {
    require './pl/dice/ag.pl';
    $in{'act'} =~ s/(AG)([0-9]+)//g;
    my $num = $2;
    $out{'dice'} = &ag::agdc($num);
    &regist('');
  }
  ## ゲヘナ判定
  elsif($in{'act'} =~ /gehenna/i) {
    require './pl/dice/gehenna.pl';
    $in{'act'} =~ s/(gehenna)([0-9]+)//g;
    my $num = $2;
    $out{'dice'} = &gehenna::gedc($num);
    &regist('');
  }
  ## クッキー
  elsif($in{'act'} eq 'cookie'){ &cookie_set; if($in{'comm'}){ &regist(''); } }
  ## 通常発言
  elsif($in{'comm'}){
    my $dice_mode;
    ## ダイス
    my $sp; my $plural;
    if   ($in{'comm'} =~ s/\[((?:[\+\-\*\/]?[0-9()]+?)*)D([0-9]+?)((?:[\+\-\*\/][0-9()]+?)*)((?:(?:(?:\/\/)|(?:\*\*))[0-9]*)?)((?:[\+\-\*\/][0-9()]+?)*?)(?:[@＠]([0-9]+(?:[\+\-][0-9]+)*?))?(#.*?)?\](?:[:：]([0-9]*))?//i
       || $in{'comm'} =~  s/^((?:[\+\-\*\/]?[0-9()]+?)*)D([0-9]+?)((?:[\+\-\*\/][0-9()]+?)*)((?:(?:(?:\/\/)|(?:\*\*))[0-9]*)?)((?:[\+\-\*\/][0-9()]+?)*?)(?:[@＠]([0-9]+(?:[\+\-][0-9]+)*?))?(#.*?)?(?:[:：]([0-9]*))?(?: |$)//i){
      $dice_mode = 'dice'; $in{'dc0'} = 0; $in{'dq0'} = $1; $in{'df0'} = $2; $in{'da0'} = $3; $in{'dh0'} = $4; $in{'dp0'} = $5; $in{'dv0'} = $6; $in{'do0'} = $7; $plural = $8;
    }
    
    ## ソードワールド
    if(!$dice_mode && $in{'game'} eq 'sw2'){
      if   ($in{'comm'} =~ s/\[([0-9]+(?:[\+\-][0-9]+)*?)R([0-9]+)((?:[\+\-\*\/][0-9()]+?)*)((?:(?:(?:\/\/)|(?:\*\*))[0-9]*)?)((?:[\+\-\*\/][0-9()]+?)*?)(?:[>\$＞＄]([0-9]+))?(#.*?)?\](?:[:：]([0-9]*))?//i
         || $in{'comm'} =~  s/^([0-9]+(?:[\+\-][0-9]+)*?)R([0-9]+)((?:[\+\-\*\/][0-9()]+?)*)((?:(?:(?:\/\/)|(?:\*\*))[0-9]*)?)((?:[\+\-\*\/][0-9()]+?)*?)(?:[>＞]([0-9]+))?(?:[\$＄]([0-9]+))?(#.*?)?(?:[:：]([0-9]*))?(?: |$)//i){
        $dice_mode = 'rate'; $in{'rt0'} = $2; $in{'cr0'} = $1; $in{'ra0'} = $3; $in{'rh0'} = $4; $in{'rp0'} = $5; $in{'ca0'} = $6; $in{'cy0'} = $7; $in{'rs0'} = $8; $plural = $9;
      }
      elsif($in{'comm'} =~ s/\[[RK]([0-9]+)((?:[\+\-\*\/][0-9()]+?)*)((?:(?:(?:\/\/)|(?:\*\*))[0-9]*)?)((?:[\+\-\*\/][0-9()]+?)*?)(?:[@＠]([0-9]+(?:[\+\-][0-9]+)*?))?(?:[>＞]([0-9]+))?(?:[\$＄]([0-9]+))?(#.*?)?\](?:[:：]([0-9]*))?//i
         || $in{'comm'} =~  s/^[RK]([0-9]+)((?:[\+\-\*\/][0-9()]+?)*)((?:(?:(?:\/\/)|(?:\*\*))[0-9]*)?)((?:[\+\-\*\/][0-9()]+?)*?)(?:[@＠]([0-9]+(?:[\+\-][0-9]+)*?))?(?:[>＞]([0-9]+))?(?:[\$＄]([0-9]+))?(#.*?)?(?:[:：]([0-9]*))?(?: |$)//i){
        $dice_mode = 'rate'; $in{'rt0'} = $1; $in{'cr0'} = $5; $in{'ra0'} = $2; $in{'rh0'} = $3; $in{'rp0'} = $4; $in{'ca0'} = $6; $in{'cy0'} = $7; $in{'rs0'} = $8; $plural = $9;
      }
      elsif($in{'comm'} =~ s/^((?:[\+\-\*\/]?[0-9()]+?)*)[@＠](histB?|経歴B?|job|一般技能)(?: |$)//i){
        $dice_mode = 'dice'; $in{'dc0'} = 0; $in{'dq0'} = $1; $sp = $2;
      }
    }
    ## ダブルクロス
    elsif(!$dice_mode && $in{'game'} eq 'dx3'){
      if   ($in{'comm'} =~ s/\[((?:[\+\-\*\/]?[0-9()]+?)*)(?:R|DX)\(([0-9\+\-\*\/()]*?)\)((?:[\+\-\*\/][0-9()]+?)*)\]//i
         || $in{'comm'} =~  s/^((?:[\+\-\*\/]?[0-9()]+?)*)(?:R|DX)\(([0-9\+\-\*\/()]*?)\)((?:[\+\-\*\/][0-9()]+?)*)(?: |$)//i
         || $in{'comm'} =~ s/\[((?:[\+\-\*\/]?[0-9()]+?)*)(?:R|DX)([0-9]*?)((?:[\+\-\*\/][0-9()]+?)*)\]//i
         || $in{'comm'} =~  s/^((?:[\+\-\*\/]?[0-9()]+?)*)(?:R|DX)([0-9]*?)((?:[\+\-\*\/][0-9()]+?)*)(?: |$)//i){
        $dice_mode = 'dxdc'; $in{'dxr0'} = 0; $in{'dxq0'} = $1; $in{'dxc0'} = $2; $in{'dxa0'} = $3;
      }
      elsif($in{'comm'} =~ s/\[((?:[\+\-\*\/]?[0-9()]+?)*)(?:R|DX)((?:[\+\-\*\/]?[0-9()]+?)*)[@＠]((?:[\+\-\*\/]?[0-9()]+?)*)\]//i
         || $in{'comm'} =~  s/^((?:[\+\-\*\/]?[0-9()]+?)*)(?:R|DX)((?:[\+\-\*\/]?[0-9()]+?)*)[@＠]((?:[\+\-\*\/]?[0-9()]+?)*)(?: |$)//i){
        $dice_mode = 'dxdc'; $in{'dxr0'} = 0; $in{'dxq0'} = $1; $in{'dxc0'} = $3; $in{'dxa0'} = $2;
      }
      elsif($in{'comm'} =~ s/^[@＠](emo[P|N]?|感情[P|N]?)(?: |$)//i){
        $dice_mode = 'dice'; $in{'dc0'} = 0; $in{'dq0'} = ''; $sp = $1;
      }
    }
    ## セブン＝フォートレス
    elsif(!$dice_mode && $in{'game'} eq 's-f'){
      if   ($in{'comm'} =~ s/\[SF((?:[\+\-\*\/][0-9()]+?)*)?(?:[@＠]([0-9,，、]+?))?(?:[#＃]([0-9,，、]+?))?\]//i
         || $in{'comm'} =~  s/^SF((?:[\+\-\*\/][0-9()]+?)*)?(?:[@＠]([0-9,，、]+?))?(?:[#＃]([0-9,，、]+?))?(?: |$)//i
         || $in{'comm'} =~ s/\[SF((?:[\+\-\*\/][0-9()]+?)*)?([@＠][0-9@＠]+?)?([#＃][0-9#＃]+?)?\]//i
         || $in{'comm'} =~  s/^SF((?:[\+\-\*\/][0-9()]+?)*)?([@＠][0-9@＠]+?)?([#＃][0-9#＃]+?)?(?: |$)//i){
        $dice_mode = 'sfdc'; $in{'sfr0'} = 0; $in{'sfc0'} = $2; $in{'sff0'} = $3; $in{'sfa0'} = $1;
      }
    }
    ## 天羅／エンゼルギア／ドラゴンアームズ
    elsif(!$dice_mode && $in{'game'} eq 'ang'){
      if   ($in{'comm'} =~ s/\[((?:[\+\-\*\/]?[0-9()]+?)*)(?:C|AG)\(([0-9\+\-\*\/()]*?)\)((?:[\+\-\*\/][0-9()]+?)*)\]//i
         || $in{'comm'} =~  s/^((?:[\+\-\*\/]?[0-9()]+?)*)(?:C|AG)\(([0-9\+\-\*\/()]*?)\)((?:[\+\-\*\/][0-9()]+?)*)(?: |$)//i
         || $in{'comm'} =~ s/\[((?:[\+\-\*\/]?[0-9()]+?)*)(?:C|AG)([0-9]*?)((?:[\+\-\*\/][0-9()]+?)*)\]//i
         || $in{'comm'} =~  s/^((?:[\+\-\*\/]?[0-9()]+?)*)(?:C|AG)([0-9]*?)((?:[\+\-\*\/][0-9()]+?)*)(?: |$)//i){
        $dice_mode = 'agdc'; $in{'agr0'} = 0; $in{'agq0'} = $1; $in{'ags0'} = $2; $in{'aga0'} = $3;
      }
    }
    ## ゲヘナ
    elsif(!$dice_mode && $in{'game'} eq 'geh'){
      if   ($in{'comm'} =~ s/\[((?:[\+\-\*\/]?[0-9()]+?)*)(?:G|GE)\(([0-9\+\-\*\/()]*?)\)((?:[\+\-\*\/][0-9()]+?)*)\]//i
         || $in{'comm'} =~  s/^((?:[\+\-\*\/]?[0-9()]+?)*)(?:G|GE)\(([0-9\+\-\*\/()]*?)\)((?:[\+\-\*\/][0-9()]+?)*)(?: |$)//i
         || $in{'comm'} =~ s/\[((?:[\+\-\*\/]?[0-9()]+?)*)(?:G|GE)([0-9]*?)((?:[\+\-\*\/][0-9()]+?)*)\]//i
         || $in{'comm'} =~  s/^((?:[\+\-\*\/]?[0-9()]+?)*)(?:G|GE)([0-9]*?)((?:[\+\-\*\/][0-9()]+?)*)(?: |$)//i){
        $dice_mode = 'gehe'; $in{'ger0'} = 0; $in{'geq0'} = $1; $in{'geb0'} = $2; $in{'gea0'} = $3;
      }
    }
    ## その他
    if(!$dice_mode){
      if   ($in{'comm'} =~ s/\[((?:[\+\-\*\/]?[0-9()]+?)*)[\$＄]((?:.+?)[,、](?:.+?))\]//i
         || $in{'comm'} =~  s/^((?:[\+\-\*\/]?[0-9()]+?)+)[\$＄]((?:.+?)[,、](?:.+?))(?: |$)//i){
        $dice_mode = 'dice'; $in{'dc0'} = 0; $in{'dq0'} = $1; $in{'df0'} = $2;
      }
      elsif($in{'comm'} =~ s/\[((?:[\+\-\*\/]?[0-9()]+?)*)[@＠](.+?)\]//i
         || $in{'comm'} =~  s/^((?:[\+\-\*\/]?[0-9()]+?)+)[@＠](.+?)(?: |$)//i){
        $dice_mode = 'dice'; $in{'dc0'} = 0; $in{'dq0'} = $1; $sp = $2;
      }
      ## 四則演算
      elsif($in{'comm'} =~ s/\[([0-9\.\+\-\*\/%\(\)%]+?)[=＝]?\]//i
         || $in{'comm'} =~ s/^([0-9\.\+\-\*\/%\(\)%]+?)[=＝](?: |$)//i){
        $out{'dice'} = $1.' = <b>'.eval($1).'</b>';
      }
    }
    
    if($dice_mode eq 'dice'){
      $plural = 1 if !$plural;
      if($in{'dq0'}*$plural > 200 && $plural > 1) {
        $out{'dice'} = 'ダイスの総数が200を超えてはいけません';
      } else {
        if($sp){ require './pl/dice/special.pl'; }
        else   { require './pl/dice/dice.pl'; }
        for (my $i = 0; $i < $plural; $i++) {
          if($sp){ $out{'dice'} .= &dice_sp::dice_sp(0,$sp,$i,$plural); }
          else   { $out{'dice'} .= &dice::dice(0,undef,$i,$plural); }
        }
      }
    }
    elsif($dice_mode eq 'rate') {
      $plural =  1 if !$plural;
      $plural = 10 if $plural > 10;
      require './pl/dice/sw2.pl';
      for (my $i = 0; $i < $plural; $i++) {
        $out{'dice'} .= &sw2::rate(0);
        $out{'dice'} .= '<br>' if $i < $plural;
      }
    }
    elsif($dice_mode eq 'dxdc') {
      require './pl/dice/dx3.pl';
      $out{'dice'} = &dx3::dxdc(0);
    }
    elsif($dice_mode eq 'sfdc') {
      require './pl/dice/s-f.pl';
      $out{'dice'} = &s_f::sfdc(0);
    }
    elsif($dice_mode eq 'agdc') {
      require './pl/dice/ag.pl';
      $out{'dice'} = &ag::agdc(0);
    }
    elsif($dice_mode eq 'gehe') {
      require './pl/dice/gehenna.pl';
      $out{'dice'} = &gehenna::gedc(0);
    }
    &regist('');
  }
  &member('');
}
elsif($in{'mode'} eq 'entrance'){ &cookie_get; &entrance; exit; }
elsif($in{'mode'} eq 'enter')   {
  &regist('enter');
  &form;
  exit;
}
elsif($in{'mode'} eq 'leave')   { &regist('leave'); &member('leave'); &leave; exit; }
print "Content-type: text/html;\n\n";
exit;

### エントランス ###
sub entrance { require './pl/entrance.pl'; }

### 発言フォーム ###
sub form { require './pl/form.pl'; }

### 退室画面 ###
sub leave { require './pl/leave.pl'; }

### クッキー保存 ###
sub cookie_set { require './pl/cookie_set.pl'; }

### クッキー取得 ###
sub cookie_get { require './pl/cookie_get.pl'; %co = %::co; }

### ログ表示 ###
sub view {
  cookie_get;
  my @font_sizes = split(/,/, $set::font_sizes);
  if($co{'font'} && !$in{'font'}) {
    $in{'font'} = $co{'font'};
  } elsif ($in{'font'}) {
    $in{'font'} = $in{'font'};
  } else {
    $in{'font'} = $set::font_sizes_def;
  }
  if(!$co{'fami'}) {
    $in{'fami'} = '"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro","メイリオ","Meiryo","ＭＳ Ｐゴシック","MS PGothic",sans-serif';
  } else {
    $in{'fami'} = $co{'fami'};
  }
  print "Content-type: text/html\n\n";
  print <<"HTML";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>$set::title</title>
<link rel="stylesheet" type="text/css" href="./css/chat.css">
<style type="text/css">
body {
  background-color:$set::color_back;
  color:$set::color_font;
  font-size:$in{'font'};
  font-family:$in{'fami'};
}
strong.em { color:@{[ ($set::color_strong ? $set::color_strong : $set::color_dice_crit) ]}; }
span.hide { color:$set::color_back; }
span.text-em {
  -webkit-text-emphasis: dot filled;
          text-emphasis: dot filled;
}
a        { color:$set::color_a_link; }
a:visited{ color:$set::color_a_visited; }
a:hover  { color:$set::color_a_hover; }
hr,
#footer,
.line { border-color:$set::color_hr; }
.line dt:after { color:$set::color_font; }
.line .date { color:$set::color_date; }
.line .dice { color:$set::color_dice; }
.line .dice:before { border-left-color:$set::color_dice; }
.supp { color:$set::color_supp; }
.status,
.status th,
.status td {
  border-color:$set::color_hr;
}
.status {
  background-color:$set::color_back;
  text-shadow:0px 1px 1px $set::color_back;
}
input,
select {
  border-color:$set::color_hr;
  background-color:$set::color_back;
  color:$set::color_font;
}
#header {
  background-color:$set::color_topic_bar;
  color:$set::color_topic_button;
  text-shadow:0px 1px 1px $set::color_topic_shadow;
}
td#set_button {
  border-color:$set::color_topic_bar;
  color:$set::color_topic_button;
}
div#topic {
  background-color:$set::color_back;
  color:$set::color_topic_text;
}
.button {
  border-color:$set::color_topic_bar;
  color:$set::color_topic_button;
  text-shadow:0px 1px 1px $set::color_topic_shadow;
}
#topic_bar .blank_l,
#topic_bar .blank_r {
  border-color:$set::color_topic_bar;
}
#setting_bar {
  border-color:$set::color_topic_bar;
  background-color:$set::color_topic_bar;
  color:$set::color_topic_button;
}
#setting_bar hr {
  border-color:$set::color_topic_bar;
}
#setting_bar table,
#setting_bar table tr {
  border-color:$set::color_topic_bar;
}
#footer_bar {
  background-color:$set::color_topic_bar;
  color:$set::color_topic_button;
  text-shadow:0px 1px 1px $set::color_topic_shadow;
}
#footer_bar a {
  border-color:$set::color_topic_bar;
  color:$set::color_topic_button;
}
#blink { opacity: 0; }
</style>
<script language="JavaScript">
  var Name = "$in{'name'}";
  var EncoName = encodeURIComponent(Name);
  var chat_path = '$set::chat';
  var CheckTimeMem = $set::check_time_mem * 1000;
  var CheckTimeRom = $set::check_time_rom * 1000;
  var MemTimeMem = $set::check_time_mem;
  var MemTimeRom = $set::check_time_rom;
  var TopicValue = "$out{'topic'}";
  var DiceColor = "color:$set::color_dice";
  var RateColor = "color:$set::color_rate";
  var SettingOn = 0;
  var NewBottom = @{[ $in{'nb'} ? 1 : 0 ]};
function setting_on(){
  if(SettingOn == 0) {
    self.document.getElementById("setting_bar").style.zIndex = 10;
    self.document.getElementById("setting_bar").style.visibility = "visible";
    self.document.getElementById("setting_bar").style.margin = "0px 0px 0px";
    self.document.getElementById("setting_bar").style.opacity = 1;
    SettingOn = 1;
  } else {
    self.document.getElementById("setting_bar").style.zIndex = 0;
    self.document.getElementById("setting_bar").style.visibility = "hidden";
    self.document.getElementById("setting_bar").style.margin = "-20px 0px 0px";
    self.document.getElementById("setting_bar").style.opacity = 0;
    SettingOn = 0;
  }
}
</script>
</head>
<body>
<form name="send" method="POST" action="$set::chat" target="submit"><input type="hidden" name="name" value="$in{'name'}"></form>
<div id="header">
<table id="topic_bar">
  <tr>
    <td class="blank_l">&nbsp;</td>
    <th style="width:55px;" id="topic_t" title="TOPICの送信">TOPIC</th>
    <th style="width:22px;" id="topic_e" onClick="topic_on()" title="TOPIC編集モードのON/OFF">&#x270E;</th>
    <td id="topic_td"><div id="topic">$out{'topic'}</div><input type="hidden" id="topic_check" value="0"></td>
    <td id="set_button" onClick="setting_on()">設定</td>
    <td class="blank_r">&nbsp;</td>
  </tr>
</table>
<div id="setting_bar">
  <table>
HTML
  print '    <tr><th>文字</th><td>:';
  print '<select id="font_size" onChange="font_size_change(this)" onkeyup="font_size_change(this)" style="height:1.6em;font-size:11px;">';
  print "<option value='$_'" , ($_ eq $in{'font'})?' selected':'' , ">$_</option>" for (@font_sizes);
  print '</select>';
  if(@set::font_family) {
    print '<select id="font_family" onChange="font_family_change(this)" onkeyup="font_family_change(this)" style="height:1.6em;font-size:11px;">';
    print '<option value="">指定なし</option>';
    print "<option value='@$_[1]'" , (@$_[1] eq $co{'fami'})?' selected':'' , ">@$_[0]</option>" for (@set::font_family);
    print '</select>',"\n";
  }
  if($in{'name'} ne ''){
  print <<"HTML";
      </td>
    </tr>
    <tr><th>システム</th>
      <td>
        : 
        <select id="gamesystem" onChange="parent.form.gamechange()" style="height:1.6em;font-size:12px;">
        <option>なし</option>
        <option value="sw2" @{[ $in{'game'} eq 'sw2' ? 'selected' : '' ]}>ソードワールド2.0</option>
        <option value="dx3" @{[ $in{'game'} eq 'dx3' ? 'selected' : '' ]}>ダブルクロス3rd</option>
        <option value="s-f" @{[ $in{'game'} eq 's-f' ? 'selected' : '' ]}>セブンフォートレス</option>
        <option value="ang" @{[ $in{'game'} eq 'ang' ? 'selected' : '' ]}>エンゼルギアなど</option>
        <option value="geh" @{[ $in{'game'} eq 'geh' ? 'selected' : '' ]}>ゲヘナ</option>
        </select>
      </td>
    </tr>
    <tr><th>ダイス</th><td>
      : 追加<a onClick="parent.form.diceins(1)">*1</a> <a onClick="parent.form.diceins(2)">*2</a> <a onClick="parent.form.diceins(3)">*3</a> <a onClick="parent.form.diceins(4)">*4</a> <a onClick="parent.form.diceins(5)">*5</a>/<a onClick="parent.form.dicedel()">削除</a><hr>
      : <a onClick="parent.form.diceinput(1)">テキストへ保存</a>/<a onClick="parent.form.diceinput(0)">テキストから読込</a>
      <div id="dicedata_area"></div>
      </td>
    </tr>
    <tr><th>専用ダイス</th><td>: <a onClick="parent.form.rateins()">追加</a>/<a onClick="parent.form.ratedel()">削除</a></td></tr>
    <tr><th>NPC</th>
      <td>
        : <a onClick="parent.form.npc_on()">表示／非表示</a>/<a onClick="parent.form.npcins()">追加</a>/<a onClick="parent.form.npcdel()">削除</a><hr>
        : <a onClick="parent.form.npcinput(1)">テキストへ保存</a>/<a onClick="parent.form.npcinput(0)">テキストから読込</a>
        <div id="npcdata_area"></div>
      </td>
    </tr>
    <tr><th>ステータス</th><td>: <a onClick="parent.form.status_on()">表示／非表示</a></td></tr>
    <tr><th>メモ1</th> <td>: <a onClick="parent.form.memo1_on()">表示／非表示</a>/<a onClick="parent.form.memo_size(1,1)">大きく</a>/<a onClick="parent.form.memo_size(1,0)">小さく</a></td></tr>
    <tr><th>メモ2</th> <td>: <a onClick="parent.form.memo2_on()">表示／非表示</a>/<a onClick="parent.form.memo_size(2,1)">大きく</a>/<a onClick="parent.form.memo_size(2,0)">小さく</a></td></tr>
    <tr><th>レイアウト</th>
      <td>
        : <a onClick="parent.form.position_change(10)">【1A】</a> <a onClick="parent.form.position_change(11)">【1B】</a> <a onClick="parent.form.position_change(12)">【1C】</a> <a onClick="parent.form.position_change(13)">【1D】</a><hr>
        : <a onClick="parent.form.position_change(20)">【2A】</a> <a onClick="parent.form.position_change(21)">【2B】</a> <a onClick="parent.form.position_change(22)">【2C】</a> <a onClick="parent.form.position_change(23)">【2D】</a>
    </td></tr>
    <tr><td colspan="2"><a onClick="parent.form.upper_lower();">通常版 ⇔ ダイスコード版</a></td>
    <tr>
      <td colspan="2">
        <a onClick="parent.logs.cookie_submit();">Cookie保存</a>
        <input type="checkbox" id="cc_name" checked>名前 <input type="checkbox" id="cc_color" checked>名前色 <input type="checkbox" id="cc_mode" checked>入室モード
      </td>
    </tr>
HTML
  }
  print <<"HTML";
  </table>
</div>
</div>
<table id="topic_bar_h">
  <tr>
    <td class="blank_l">&nbsp;</td>
    <th style="width:55px;">&nbsp;</th>
    <th style="width:22px;"></th>
    <td id="topic_td_h"><div id="topic_h">$out{'topic'}</div></td>
    <td id="set_button_h">&nbsp;</td>
    <td class="blank_r">&nbsp;</td>
  </tr>
</table>
<div id="status"></div>
<div id="log"></div>
<script src="./js/chat.js" type="text/javascript"></script>
<p id="footer" style="text-align:center;font-size:13px">
  ゆとチャⅡ／ぬる ver${ver} - <a href="http://yutorize.2-d.jp/" target="_blank">ゆとらいず工房</a>
</p>
<div id="footer_bar">
  <div id="rom">ROM:<span id="rom_num"> </span></div>
  <a href="#" title="一番上へ">▲</a>
  <a href="./help.html" target="_blank" title="取扱説明書">取説</a>
  <a href="./$set::log_cgi" target="_blank" title="過去ログ">過去ログ</a>
  <a href="./$set::cou_cgi" target="_blank" title="ダイス統計">Ｄ</a>
  <a href="./$set::mem_cgi" target="_blank" title="参加者一覧">Ｍ</a>
</div>
</body>
</html>
HTML
}

### 書き込み処理 ###
sub regist {
  if ($ENV{'REQUEST_METHOD'} ne "POST") { return; }
  my $npc;
  foreach(%in) {
    $in{$_} =~ s/</&lt;/g;
    $in{$_} =~ s/>/&gt;/g;
    $in{$_} =~ s/\r\n/<br>/g;
    $in{$_} =~ s/\r/<br>/g;
    $in{$_} =~ s/\n/<br>/g;
    $in{$_} =~ s/\\/&#92;/g;
    if ($set::tag_on && $_[0] ne 'topic') {
      foreach my $tag ('b','s','i','u','tt','strike','em','strong','big','small','del','center','sup','sub'){
        1 while $in{$_} =~ s/&lt;$tag&gt;(.*?)&lt;\/$tag&gt;/<$tag>$1<\/$tag>/gi;
      }
      foreach my $tag ('ruby','rb','rp','rt'){
        $in{$_} =~ s/&lt;$tag&gt;(.*?)&lt;\/$tag&gt;/<$tag>$1<\/$tag>/gi;
      }
      $in{$_} =~ s/&lt;br&gt;/<br>/g;
      1 while $in{$_} =~ s/&lt;font size="(.{0,2}?)"&gt;(.*?)&lt;\/font&gt;/<font size="$1">$2<\/font>/gi;
      1 while $in{$_} =~ s/&lt;font color="([0-9a-zA-Z#]*?)"&gt;(.*?)&lt;\/font&gt;/<span style="color:$1">$2<\/span>/gi;
      1 while $in{$_} =~ s/&lt;left&gt;(.*?)&lt;\/left&gt;/<div style="text-align:left">$1<\/div>/gi;
      1 while $in{$_} =~ s/&lt;right&gt;(.*?)&lt;\/right&gt;/<div style="text-align:right">$1<\/div>/gi;
      1 while $in{$_} =~ s/&lt;c:([0-9a-zA-Z#]*?)&gt;(.*?)&lt;\/c&gt;/<span style="color:$1">$2<\/span>/gi;
      1 while $in{$_} =~ s/&lt;fs:([0-9]{0,3}?px)&gt;(.*?)&lt;\/fs&gt;/<span style="font-size:$1">$2<\/span>/gi;
      1 while $in{$_} =~ s/&lt;ff:([0-9a-z \-']+)&gt;(.*?)&lt;\/ff&gt;/<span style="font-family:$1">$2<\/span>/gi;
      $in{$_} =~ s/&lt;rb:(.*?)&gt;(.*?)&lt;\/rb&gt;/<ruby>$2<rp>(<\/rp><rt>$1<\/rt><rp>)<\/rp><\/ruby>/gi;
      $in{$_} =~ s/[|｜](.+?)《(.*?)》/<ruby>$1<rp>(<\/rp><rt>$2<\/rt><rp>)<\/rp><\/ruby>/gi;
      $in{$_} =~ s/《《(.+?)》》/<span class="text-em">$1<\/span>/gi;
      $in{$_} =~ s/&lt;&lt;(.+?)&gt;&gt;/<strong class="em">$1<\/strong>/gi;
      $in{$_} =~ s/\{\{(.+?)\}\}/<span class="hide">$1<\/span>/gi;
      $in{$_} =~ s/(―+)/<span class="dash">$1<\/span>/gi;
      
      $in{$_} =~ s|(https?://[^\s\<]+)|<a href="$1" target="_blank">$1</a>|gi; # 自動リンク
    }
  }
#  my $plug; my $arg;
#  if($in{'comm'} =~ s/#([0-9a-zA-Z_]+)(\((.*?)\))?/$plug=$1; $arg=$3; "#$1$2"/e){
#    my $thr;
#    eval { $thr = require "./pl/plug_${plug}.pl"; };
#    if($thr){
#      my $code = "&${plug}::${plug}('$arg');";
#      $in{'comm'} =~ s/#$plug(?:\((.*?)\))?/eval $code;/e;
#    }
#  }
  if($_[0] eq 'enter') {
    if($in{'name'} eq ''){ $in{'name'} = $set::no_name; }
    my @messages;
    if($set::private_enter{$in{'name'}}){ @messages = @{$set::private_enter{$in{'name'}}}; } else { @messages = @set::enter_messages; }
    my $rand = rand(@messages);
    $out{'name'} = $messages[$rand][0]; $out{'color'} = $messages[$rand][1]; $out{'comm'} = $messages[$rand][2]; $npc = '*';
    $out{'comm'} =~ s/\[name\]/<b style="color:$in{'color'}">$in{'name'}<\/b>/;
  }
  elsif($_[0] eq 'leave') {
    my @messages;
    if($set::private_leave{$in{'name'}}){ @messages = @{$set::private_leave{$in{'name'}}}; } else { @messages = @set::leave_messages; }
    my $rand = rand(@messages);
    $out{'name'} = $messages[$rand][0]; $out{'color'} = $messages[$rand][1]; $out{'comm'} = $messages[$rand][2]; $npc = '*';
    $out{'comm'} =~ s/\[name\]/<b style="color:$in{'color'}">$in{'name'}<\/b>/;
  }
  elsif($_[0] eq 'topic') {
    $out{'name'} = 'TOPIC'; $out{'color'} = $set::color_topic; $out{'comm'} = "<span style=\"color:$set::color_topic_text;font-size:83%\">$in{'topic'}</span> <span class=\"supp\">by $in{'name'}</span>"; $npc = '*';
  }
  else {
    if($in{'n_check'}) {
      $npc = $in{'n_check'};
      $out{'name'} = $in{"n_name$npc"}; $out{'color'}= $in{"n_color$npc"};
    }
    else {
      $out{'name'} = $in{'name'}; $out{'color'}= $in{'color'}; $npc = '0';
    }
    $out{'comm'} = $in{'comm'}; $out{'supp'} = $in{'supp'};
    if($in{'tarea'}) { $out{'comm'} = '<br>'.$out{'comm'}; }
    if($in{'hp'} ne '' || $in{'mp'} ne '' || $in{'gp'} ne '' || $in{'pp'} ne '' || $in{'st'} ne '') {
      if   ($in{'game'} eq 'sw2'){ $out{'supp'} = "(HP:$in{'hp'} MP:$in{'mp'} 防:$in{'gp'} $in{'st'}) $in{'supp'}"; }
      elsif($in{'game'} eq 'dx3'){ $out{'supp'} = "(HP:$in{'hp'} 行動:$in{'mp'} 侵蝕:$in{'gp'} $in{'st'}) $in{'supp'}"; }
      elsif($in{'game'} eq 's-f'){ $out{'supp'} = "(HP:$in{'hp'} MP:$in{'mp'} プラーナ:$in{'gp'} 行動:$in{'pp'} $in{'st'}) $in{'supp'}"; }
      else { $out{'supp'} = "(HP:$in{'hp'} MP:$in{'mp'} 他:$in{'gp'} $in{'st'}) $in{'supp'}"; }
    }
  }
  
  if($out{'color'} =~ /random/i){
    my @cst = ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
    $out{'color'} = '#' . $cst[int(rand(16))] . $cst[int(rand(16))] . $cst[int(rand(16))] . $cst[int(rand(16))] . $cst[int(rand(16))] . $cst[int(rand(16))];
  }
  else { $out{'color'} =~ s/[^0-9a-fA-F#]//gi; }

  my @alldir;
  if($out{'comm'} =~ s|^/all[ 　]||){
    return if !$out{'comm'};
    @alldir = @set::alldir;
    $out{'comm'} = '<span style="color:#FFAA00;">'.$out{'comm'}.'</span>';
  }
  foreach my $dir('',@alldir){
    open(my $LOG, ">>", $dir.'./log_all.dat') or &error('./log_all.datが開けません');
    print $LOG $out{'date'},'<>',$out{'name'},'<>',$out{'comm'},'<>',$out{'supp'},'<>',$out{'dice'},'<>',$out{'color'},'<>',$out{'host'},'<>',$npc,'<>',"\n";
    close($LOG);
  }
  
  $out{'date'} = substr($out{'date'}, 11);
  if($npc eq '*') {
    $out{'comm'} = "<span style=\"color:$set::color_sys_text\">$out{'comm'}</span>" if ($_[0] ne 'topic');
  }
  else {
    if($npc && $set::npc_mark_on){ $out{'name'} = "$set::npc_mark$out{'name'}$set::npc_mark2"; }
  }
  
  foreach my $dir ('',@alldir){
    open(my $NM, "+<:utf8", $dir.'./num.dat') or &error("./num.datが開けません");
    flock($NM, 2);
    my $counter = <$NM>;
    seek($NM, 0, 0);
    
    $counter++;
    if($counter > 1000){ $counter = 1; }
    
    my $line = $counter.'<>'.$out{'date'}.'<>'.$out{'name'}.'<>'.$out{'comm'}.'<>'.$out{'supp'}.'<>'.$out{'dice'}.'<>'.$out{'color'}.'<>'.$npc.'<>';
    
    open(my $FH, "+<:utf8", $dir.'./log_pre.dat') or &error("./log_pre.datが開けません");
    flock($FH, 2);
    my @lines = <$FH>;
    seek($FH, 0, 0);
    unshift (@lines,"$line\n");
    for (0 .. $set::log_lines-1) {
      print $FH $lines[$_];
    }
    truncate($FH, tell($FH));
    close($FH);
    
    print $NM $counter;
    truncate($NM, tell($NM));
    close($NM);
  }
}

### 参加者チェック ###
sub member {
  my $time = time;
  my $over;
  my $newadd;
  foreach('name','hp','mp','gp','pp','topic') {
    $in{$_} =~ s/</&lt;/g;
    $in{$_} =~ s/>/&gt;/g;
    $in{$_} =~ s/\r//g;
    $in{$_} =~ s/\n//g;
    $in{$_} =~ s/\\/&#92;/g;
    $in{$_} =~ s/"/&quot;/g;
  }
  open(my $FH, "+<:utf8", './mem_list.dat') or &error('./mem_list.datが開けません');
  flock($FH, 2);
  my $i = 0;
  while(my $line = <$FH>) {
    if(!$i) {
      chomp($line);
      if($in{'name'} && $in{'mode'} eq 'topic' && $line ne $in{'topic'}){ $line = $in{'topic'}; &regist('topic'); }
      $out{'topic'} = $line;
      $i++;
      next;
    }
    my($date,$name,$host,$hp,$mp,$gp,$pp) = split(/<>/, $line);
    my $host_c = &host_cut($host);
    if($time-300 > $date) { next; }
    if($name eq $in{'name'} && $host_c eq $out{'host_c'}) {
      $newadd = 1;
      if($_[0] eq 'leave') { next; }
      if($in{'mode'} ne 'topic'){ $hp = $in{'hp'}; $mp = $in{'mp'}; $gp = $in{'gp'}; $pp = $in{'pp'}; }
      $line = "$time<>$name<>$host<>$hp<>$mp<>$gp<>$pp<>\n";
    }
    $over .= $line;
  }
  if(!$newadd){
    $over .= "$time<>$in{'name'}<>$out{'host'}<>$in{'hp'}<>$in{'mp'}<>$in{'gp'}<>$in{'pp'}<>\n";
  }
  seek($FH, 0, 0);
  print $FH $out{'topic'},"\n",$over;
  truncate($FH, tell($FH));
  close($FH);
}

### デコード処理 ###
sub _decode {
  my $buf;
  if ($ENV{'REQUEST_METHOD'} eq "POST") {
    read(STDIN, $buf, $ENV{'CONTENT_LENGTH'});
  }
  else { $buf = $ENV{'QUERY_STRING'}; }
  my @pairs = split(/&/, $buf);
  foreach (@pairs) {
    my ($name,$value) = split(/=/, $_);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $in{$name} = Encode::decode('utf8', $value);
  }
  ## ホスト(IP)取得
  $out{'host'} = $ENV{'REMOTE_HOST'};
  if(!$out{'host'}){ $out{'host'} = $ENV{'REMOTE_ADDR'}; }
  $out{'host_c'} = &host_cut($out{'host'});
  ## 日時取得
  my ($sec,$min,$hour,$day,$mon,$year) = (localtime(time))[0..5];
  $out{'date'} = sprintf("%04d/%02d\/%02d\-%02d\:%02d\:%02d",$year+1900,$mon+1,$day,$hour,$min,$sec);
  ## 補足
  if(!$in{'sup_on1'}){ $in{'supp1'} = '' }
  if(!$in{'sup_on2'}){ $in{'supp2'} = '' }
  $in{'supp'} = $in{'supp1'}.$in{'supp2'};
  if(!$in{'stt_on'}) { $in{'hp'} = ''; $in{'mp'} = ''; $in{'gp'} = ''; $in{'pp'} = ''; $in{'st'} = ''; }
  ## 
  if(!$in{'n_check'}){ $in{'n_check'} = 0; }
}

sub host_cut {
  my $host_in = shift; my $host_out;
  if   ($host_in =~ /(.*)\.([0-9]+?)$/)       { $host_out = "$1\.*"; }
  elsif($host_in =~ /(.*)\.(.*)\.(.*)\.(.*)$/){ $host_out = "\*\.$2\.$3\.$4"; }
  elsif($host_in =~ /(.*)\.(.*)\.(.*)$/)      { $host_out = "\*\.$2\.$3"; }
  return $host_out;
}

### エラー ###
sub error {
  print "Content-type: text/html\n\n";
  print <<"HTML";
<html>
<head><meta http-equiv="Content-type" content="text/html; charset=Shift_JIS"><title>エラー</title></head>
<body text="$set::color_font" bgcolor="$set::color_back"><b>$_[0]</b><br><a href="javascript:history.back();">戻る</a></body>
</html>
HTML
  exit;
}

