### 設定 ###
#use strict;
use utf8;
package set;

our $chat     = './chat.cgi'; #CGI本体
our $url_frame= './'; #チャットのTOPページ('./'でForbiddenエラー等になる場合index.cgiにすること)

our $url_home = 'http://yutorize.2-d.jp/'; #[HOME]から飛ぶページ

our $password = '1234'; #管理用パス ※変更必須

our $gamesystem = 'sw2'; #デフォルトで選択するゲームシステム
    # sw2 : ソードワールド2.0
    # dx3 : ダブルクロス3rd
    # s-f : セブン＝フォートレス
    # ang : 天羅万象／エンジェルギア／ドラゴンアームズ
    # geh : ゲヘナ

our $title       = 'ゆとチャⅡ／ぬる'; #チャットのタイトル
our $color_title = '#ffffff'; #タイトル色

our $mem_cgi  = './member.cgi'; #メンバー一覧CGI
our $cou_cgi  = './count.cgi'; #ダイス統計CGI
our $col_cgi  = './color.cgi'; #色一覧ログCGI

our $log_cgi  = './logs.cgi'; #過去ログCGI
our $log_dir  = './log/'; #過去ログ格納ディレクトリ
our $log_end  = ''; #過去ログファイルの末尾文字(日付の後に付く)
our $log_yeardir = 1; #過去ログを年毎にディレクトリを分ける(=1)or分けない(=0)
our $dice_record = 1; #ダイス統計を過去ログに出力する(=1)orしない(=0)
our $dice_logfile = 'log_reco.dat'; #過去ダイス総計記録ファイル
our $comm_record = 1; #発言統計を過去ログに出力する(=1)orしない(=0)
our $log_del_pre = 'checked'; #過去ログ作成時の現行ログ(最新)の初期化チェックの初期値
our $log_tpi_pre = 'checked'; #過去ログ作成時のTOPICと参加者リストの初期化チェックの初期値

our $cookie_name = 'ytchat2'; #Cookieの名前。同じサイトで複数ゆとチャを設置した際、Cookieを別々に保存させたい場合に変更

our $log_lines = 30; #現行ログ表示数

our $check_time_mem = 2; #入室者がログの更新をチェックする間隔(単位:秒) ※初期値2 入室者が多いなら少し増やした方がいいかも
our $check_time_rom = 10; #ROMがログの更新をチェックする間隔(単位:秒) ※初期値10 ROMが多いならもっと増やしていいかも

our $no_name = '名無し'; #無記入で入室した際の名前

our $npc_mark_on = 1; #NPCマークの表示(=1)or非表示(=0)
our $npc_mark    = '#'; #NPCマーク（先頭）
our $npc_mark2   = ''; #NPCマーク（末尾）

our $tag_on = 1; #タグの使用(許可=1, 不許可=0)

our $dice_faces    = '2,3,4,5,6,8,10,12,20,30,50,100'; #ダイスの種類
our $dice_quan_def = 2; #ダイス数デフォルト (システムを選択しない場合)
our $dice_face_def = 6; #ダイス種デフォルト (システムを選択しない場合)

our $critical_max = 20; #威力表におけるクリティカル限界数
our $critical_text= 'クリティカル!'; #威力表クリティカル時のテキスト
our $fumble_text  = 'ファンブル...'; #威力表1ゾロ時のテキスト
our $critical_max_text = 'クリティカル限界オーバー!!'; #威力表クリティカル限界時のテキスト

our $font_sizes     = '20px,19px,18px,17px,16px,15px,14px,13px,12px,11px'; #ログ表示文字サイズ
our $font_sizes_def = '14px'; #ログ表示文字サイズ(デフォルト)

our @font_family = ( # フォントの種類
  # '表示名', 'フォントの名前'
  [ 'メイリオ',     '"メイリオ","Meiryo"' ],
  [ 'メイリオUI',   '"Meiryo UI"' ],
  [ 'MS Pゴシック', '"ＭＳ Ｐゴシック","MS PGothic"' ],
  [ 'MS P明朝', '"ＭＳ Ｐ明朝","MS PMincho"' ],
  [ 'ヒラギノ角ゴ', '"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro"' ],
  [ 'ヒラギノ丸ゴ', '"ヒラギノ丸ゴ Pro W4","Hiragino Maru Gothic Pro"' ],
  [ 'Osaka',        'Osaka' ],
);

# ダイス欄の行数  'ゲームシステム' => [通常ダイス, 専用ダイス],
our %lines_def = (
  'sw2' => [3, 2],
  'dx3' => [2, 3],
  'ang' => [2, 3],
  'geh' => [2, 3],
  's-f' => [1, 4],
  'non' => [4, 0],
);
our $npc_lines_def  = 5; #NPC行数(デフォルト)

our $color_name_def  = '#FFFFFF'; #名前色選択のデフォルト

our $color_font      = '#cccccc'; #文字色
our $color_back      = '#000000'; #背景色
our $color_supp      = '#9999bb'; #補足色
our $color_date      = '#444444'; #日時色
our $color_hr        = '#444455'; #罫線色

our $color_strong    = '#ee9900'; #文字色(強調：<<>>)

our $color_dice      = '#ee0000'; #ダイス色
our $color_dice_crit = '#ee9900'; #ダイス色(クリティカル)
our $color_dice_half = '#bb6666'; #ダイス色(半減)
our $color_dice_mult = '#ee5555'; #ダイス色(倍化)
our $color_dice_fumb = '#888888'; #ダイス色(ファンブル)

our $color_rate      = '#ff4500'; #威力表色(結果)
our $color_ratings   =            #威力表色(式) (クリティカル毎に色変更(半角カンマで区切る))
  '#f4a460,#f49155,#f37f4a,#f26d40,#f25b35,#f1492b,#f03720,#f02516,#ef130b,#ee0000';
our $color_rate_half = '#94b460'; #威力表色(半減)
our $color_rate_mult = '#f4c020'; #威力表色(倍化)
our $color_rate_fumb = '#999088'; #威力表色(ファンブル)

our $color_dxdc      = '#aa00ff'; #DXダイス(結果)
our $color_dxdc_crit =            #DXダイス(式) (クリティカル毎に色変更(半角カンマで区切る))
  '#7777FF,#7A73FF,#7C70FF,#7F6DFF,#8269FF,#8465FF,#8762FF,#895EFF,#8C5AFF,#8F57FF,#9253FF,#9450FF,#974CFF,#9A49FF,#9C45FF,#9F42FF,#A23EFF,#A43AFF,#A737FF,#AA33FF';
our $color_dxdc_fumb = '#8899aa'; #DXダイス色(ファンブル)

our $color_sfdc      = '#ee2200'; #S=Fダイス(結果)
our $color_sfdc_crit =            #S=Fダイス(式) (クリティカル毎に色変更(半角カンマで区切る))
  '#eea900,#ee9c00,#ee8f00,#ee8200,#ee7500,#ee6700,#ee5a00,#ee4d00,#ee3f00,#ee3200';
our $color_sfdc_fumb = '#aaaa88'; #S=Fダイス色(ファンブル)

our $color_agdc      = '#00aa55'; #AGダイス(結果)
our $color_agdc_form = '#449966'; #AGダイス(式)

our $color_gedc      = '#ee2200'; #ゲヘナダイス(結果)
our $color_gedc_form = '#dd5533'; #ゲヘナダイス(式)

our $color_a_link    = '#8888ff'; #リンク色(未読)
our $color_a_visited = '#aa88aa'; #リンク色(既読)
our $color_a_hover   = '#88ffff'; #リンク色(マウスオーバー)

our $color_topic     = '#ee2222'; #TOPIC名前色
our $color_topic_text= '#77bb99'; #TOPIC文字色
our $color_topic_bar    = '#222533'; #TOPICバー背景色
our $color_topic_button = '#ffffff'; #TOPICバー文字色
our $color_topic_shadow = '#000000'; #TOPICバー文字の影色

our $color_sys_text  = '#88bbaa'; #入退室メッセージ色

#入退室メッセージ(ランダム) ['名前','名前色','メッセージ([name]に入退室者の名前)'],
our @enter_messages = (
  ['SYSTEM','#ffffff','[name]様が入室しました。'],
  #['','','やせいの　[name]　が　とびだしてきた！'], #ポ○モン風。
  #['','','[name]'],
);
our @leave_messages = (
  ['SYSTEM','#ffffff','[name]様が退室しました。'],
  #['','','やせいの　[name]　は　にげだした！'], #ポ○モン風。
  #['','','[name]'],
);

our @alldir = ();

1;