#!/usr/local/bin/perl
#use strict;
#use warnings;
use utf8;
use open ":utf8";
use open ":std";
use CGI qw/:cgi/;
#use CGI::Carp qw(fatalsToBrowser);

require './config.cgi';

my %list; my %out; my $dice_all;
open(my $FH, "<:utf8", './log_all.dat');
while (<$FH>) {
  my ($name, $dice, $npc) = (split /<>/, $_)[1,4,7];
  next if(!$dice);
  next if($dice !~ /2D6/ && $dice !~ /威力/ || $dice =~ /GF/ || $dice =~ /closed/);
  if($npc){ $name = "他(NPC)";}
  push @{$list{$name}},$dice;
  $dice_all .= $dice;
}
close ($FH);

my @dicelist = (
  '1 \+ 1','1 \+ 2','1 \+ 3','1 \+ 4','1 \+ 5','1 \+ 6',
  '2 \+ 1','2 \+ 2','2 \+ 3','2 \+ 4','2 \+ 5','2 \+ 6',
  '3 \+ 1','3 \+ 2','3 \+ 3','3 \+ 4','3 \+ 5','3 \+ 6',
  '4 \+ 1','4 \+ 2','4 \+ 3','4 \+ 4','4 \+ 5','4 \+ 6',
  '5 \+ 1','5 \+ 2','5 \+ 3','5 \+ 4','5 \+ 5','5 \+ 6',
  '6 \+ 1','6 \+ 2','6 \+ 3','6 \+ 4','6 \+ 5','6 \+ 6',
  );

print "Content-type: text/html\n\n";
print <<"HTML";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="ja">
<head>
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <title>2d6分布表 : $set::title</title>
  <style type="text/css">
  body  { padding:10px; color:$set::color_font; background-color:$set::color_back; }
  table.count { float:left; border:1px solid $set::color_hr; border-collapse:collapse; margin:5px; }
  .count td   { border:dotted #555566; border-width:1px 0px; padding:1px 3px; text-align:right; font-size:12px; }
  .count th   { border-top:1px solid #555566; padding:1px 3px;t ext-align:right; font-size:12px; }
  </style>
</head>
<body>
HTML
my $all_total;
### 個人統計 ###
print '<table class="count">',"\n";
foreach my $name (sort keys %list) {
  print '<tr><th colspan="3">',$name,'</th></tr>',"\n";
  my $indiv = "@{$list{$name}}";
  foreach (@dicelist) {
    my $dice = $_;
    my $indiv_count = ($indiv =~ s/$dice/$dice/g); $dice =~ s/\\//g;
    my $equal = eval($dice);
    $out{"indiv_eq$equal"} += $indiv_count;
  }
  my $indiv_total = 0; my $result_total = 0;
  for(2 .. 12){
    $indiv_total += $out{"indiv_eq$_"};
    $result_total += $_ * $out{"indiv_eq$_"};
    print '<tr><td>',$_,'</td><td>',$out{"indiv_eq$_"},'回</td><td><div style="width:',($out{"indiv_eq$_"} * 7),'px;height:7px;background-color:#772255;"></div></td></tr>',"\n";
    $out{"indiv_eq$_"} = 0;
  }
  print '<tr><td><b>計</b></td><td><b>',$indiv_total,'回</b></td><td><b>平均',sprintf("%.3f",($result_total / $indiv_total)),'</b></td></tr>',"\n",'</tr>',"\n";
  $all_total += $indiv_total;
}
print '</table>',"\n";

### 全体統計 ###
if($all_total){
  print '<table class="count">',"\n";
  print '<tr><th colspan="4">2d6分布</th></tr>',"\n";
  foreach (@dicelist) {
    my $dice = $_;
    my $all_count = ($dice_all =~ s/$dice/$dice/g); $dice =~ s/\\//g;
    my $equal = eval($dice);
    print '<tr><td style="text-align:left;">',$dice,' = ',$equal,'</td><td>',$all_count,'回</td><td><div style="width:',sprintf("%.0f", ($all_count * 1000 / ($all_total+3))),'px;height:7px;background-color:#775522;">','</div></td><td>',sprintf("%.2f", ($all_count * 100 / $all_total)),'%</td></tr>',"\n";
    $out{"all_eq$equal"} += $all_count;
    for(my $i = 1; $i <= 6; $i++){
      if($_ =~ /$i +/){ $out{"onedice$i"} += $all_count; }
      if($_ =~ /\+ $i/){ $out{"onedice$i"} += $all_count; }
    }
  }
  my $a_result_total = 0;
  for(2 .. 12){ $a_result_total += $_ * $out{"all_eq$_"}; }
  print '<tr><td><b>合計</b></td><td><b>',$all_total,'回</b></td><td><b>平均',sprintf("%.3f",($a_result_total / $all_total)),'</b></td><td><b></b></td></tr>',"\n";
  print '<tr><th colspan="4">2d6合計分布</th></tr>',"\n";
  for(2 .. 12){
    print '<tr><td>',$_,'</td><td>',$out{"all_eq$_"},'回</b></td><td><div style="width:',sprintf("%.0f", ($out{"all_eq$_"} * 500 / ($all_total+1))),'px;height:7px;background-color:#227755;"></div></td><td>',sprintf("%.2f", ($out{"all_eq$_"} * 100 / $all_total)),'%</td></tr>',"\n";
  }
  print "<tr><th colspan=\"4\">1/2d6分布</th></tr>\n";
  for(1 .. 6){
    print '<tr><td>',$_,'</td><td>',$out{"onedice$_"},'回</b></td><td><div style="width:',sprintf("%.0f", ($out{"onedice$_"} * 250 / $all_total)),'px;height:7px;background-color:#225577;"></div></td><td>',sprintf("%.2f", ($out{"onedice$_"} * 100 / $all_total)),'%</td></tr>',"\n";
  }
  print '</table>',"\n";
}

### 過去統計 ###
my $old_total; my @old_list;
print '<table class="count">',"\n";
print '<tr><th colspan="4">2d6分布(過去)</th></tr>',"\n";
open(my $DC, "<:utf8", $set::dice_logfile);
$old_total = 0;
while (<$DC>) {
  my ($dice, $count) = (split /<>/, $_)[0..1];
  if($count eq ""){ $count = "0"; }
  $old_total += $count;
  my $equal = eval($dice);
  push @old_list,"$dice,$count";
  $out{"aeqa$equal"} += $count;
  for(1..6){
    if($dice =~ /$_ +/){ $out{"arokud$_"} += $count; }
    if($dice =~ /\+ $_/){ $out{"arokud$_"} += $count; }
  }
}
close($DC);
foreach (@old_list){
  my @value = split( /,/, $_);
  print '<tr><td style="text-align:left;">',$value[0],' = ',eval($value[0]),'</td><td>',$value[1],'回</td><td><div style="width:',sprintf("%.0f", ($value[1] * 1000 / ($old_total+3))),'px;height:7px;background-color:#775522;"></div></td><td>',sprintf("%.2f", ($value[1] * 100 / $old_total)),'%</td></tr>',"\n";
}
print '<tr><td><b>合計</b></td><td><b>',$old_total,'回</b></td><td><b></b></td><td><b></b></td></tr>',"\n";
print '<tr><th colspan="4">2d6合計分布(過去)</th></tr>',"\n";
if($old_total eq "0"){ $old_total = 1;}
for(2 .. 12){
  print '<tr><td>',$_,'</td><td>',$out{"aeqa$_"},'回</b></td><td><div style="width:',sprintf("%.0f", ($out{"aeqa$_"} * 500 / ($old_total+1))),'px;height:7px;background-color:#227755;"></div></td><td>',sprintf("%.2f", ($out{"aeqa$_"} * 100 / $old_total)),'%</td></tr>',"\n";
}
print '<tr><th colspan="4">1/2d6分布(過去)</th></tr>',"\n";
for(1 .. 6){
  print '<tr><td>',$_,'</td><td>',$out{"arokud$_"},'回</b></td><td><div style="width:',sprintf("%.0f", ($out{"arokud$_"} * 250 / $old_total)),'px;height:7px;background-color:#225577;"></div></td><td>',sprintf("%.2f", ($out{"arokud$_"} * 100 / $old_total)),'%</td></tr>',"\n";
}
print '</table>',"\n";
print <<'HTML';
<br style="clear:both;">
</body>
</html>
HTML

