#!/usr/local/bin/perl
#use strict;
#use warnings;
use utf8;
use open ":utf8";
use open ":std";
use CGI qw/:cgi/;
#use CGI::Carp qw(fatalsToBrowser);
use Encode;

my %in;

require './config.cgi';

$set::title = "過去ログ : $set::title";

my @font_sizes = split(/,/, $set::font_sizes);
my $log_head = <<"HTML";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>$set::title</title>
<style TYPE="text/css">
  body  {
    margin-top:5px;
    font-size:13px;
    line-height:1.3;
    color:$set::color_font;
    background-color:$set::color_back;
    word-wrap:break-word;
  }
  select{
    margin:0px;
    border:1px solid $set::color_hr;
    background-color:$set::color_back;
    color:$set::color_font;
  }
  strong.em { color:@{[ ($set::color_strong ? $set::color_strong : $set::color_dice_crit) ]}; }
  span.hide { color:$set::color_back; }
  span.text-em {
    -webkit-text-emphasis: dot filled;
            text-emphasis: dot filled;
  }
  a {
   text-decoration:none;
   -webkit-transition: all 0.2s ease-out;
      -moz-transition: all 0.2s ease-out;
       -ms-transition: all 0.2s ease-out;
        -o-transition: all 0.2s ease-out;
           transition: all 0.2s ease-out;
  }
  a:link    { color:$set::color_a_link; }
  a:visited { color:$set::color_a_visited; }
  a:hover   { color:$set::color_a_hover; }
  body,select{
    font-family:"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro","メイリオ","Meiryo","ＭＳ Ｐゴシック","MS PGothic",sans-serif;
  }
  textarea,tt {
    font-family:"ＭＳ ゴシック","MS Gothic","Osaka－等幅","Osaka-Mono",monospace;
  }
  table {
    border-collapse:collapse;
  }
  th,td {
    padding:0px;
    font-size:13px;
  }
  hr {
    height:1px;
    border:none;
    background-color:$set::color_hr;
    color:$set::color_hr;
  }
  .dash {
    font-family: "メイリオ","Meiryo","筑紫A丸ゴシック","ＭＳ Ｐゴシック","MS PGothic",sans-serif;
  }
  h1 {
    margin:0px;
    padding:6px 0px;
    border-top:1px solid $set::color_hr;
    font-size:24px;
    font-weight:bold;
    font-family:"Iskoola Pota","Times New Roman","ヒラギノ明朝 ProN W3","Hiragino Mincho ProN","ＭＳ Ｐ明朝","MS PMincho",fantasy;
  }
  .line {
    margin:0px;
    padding:3px 0px 0px;
    position:relative;
    border-top:1px solid $set::color_hr;
    overflow:hidden;
    word-wrap:break-word;
  }
  .line dt {
    font-weight:bold;
  }
  .line dt.day {
    font-size:116%;
    font-weight:normal;
  }
  .line dt.day:before {
    content:"◆";
    opacity:0.5;
  }
  .line dt.day:after {
    content:"";
  }
  .line dt a {
    display:block;
    position:absolute;
    top:0px;
    right:0px;
    line-height:1;
    font-size:170%;
    font-family:"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro","メイリオ","Meiryo","ＭＳ Ｐゴシック","MS PGothic",sans-serif;
    visibility:hidden;
    opacity:0;
  }
  .line:hover dt a {
    visibility:visible;
    opacity:0.6;
  }
  .line dd {
    margin:0px 0px 3px .8em;
    overflow:hidden;
  }
  .line.system dt {
    float:left;
  }
  .line.system dt:after {
    content:">";
    margin:0px .4em;
    font-weight:normal;
    color:$set::color_font;
  }
  .line.system dt.noname:after {
    content:"";
  }
  .line.system dd {
    color:$set::color_sys_text;
  }
  .line dd.date {
    font-size:83%;
    color:$set::color_date;
    float:right;
  }
  .line .supp {
    font-size:83%;
    color:$set::color_supp;
  }
  .line .dice {
    padding-left:.7em;
    color:$set::color_dice;
  }
  .line .dice:before {
    display:block;
    content:"";
    position:relative;
    width:0;
    height:0;
    top:.2em;
    left:-.6em;
    margin-bottom:-.6em;
    border-width:.3em 0em .3em .5em; 
    border-style:solid;
    border-color:transparent;
    border-left-color:$set::color_dice;
    opacity:0.5;
  }
  table.count {
    float:left;
    border:1px solid $set::color_hr;
    margin:5px;
  }
  .count td   {
    padding:1px 3px;
    border:dotted #555566;
    border-width:1px 0px;
    text-indent:0em;
    text-align:right;
    font-size:12px;
  }
  .count th   {
    border-top:1px solid #555566;
    padding:1px 3px; text-indent:0em;
    text-align:center; font-size:12px;
  }
  #footer {
    margin:0px;
    padding:6px 0px;
    border-top:1px solid $set::color_hr;
  }
</style>
<script type="text/javascript">
  function font_size_change(Select) {
    self.document.body.style.fontSize = Select.options[Select.selectedIndex].value;
  }
  function font_family_change(Select) {
    self.document.body.style.fontFamily = Select.options[Select.selectedIndex].value;
  }
</script>
<base target="_top">
</head>
<body>
HTML
$log_head .= '<div style="z-index:10;position:fixed;top:1px;right:1px;text-align:right;font-size:10px;">文字:<select onchange="font_size_change(this)" onkeyup="font_size_change(this)" style="height:1.6em;font-size:11px;">';
for (@font_sizes) {
  $log_head .= "<option value='$_'".(($_ eq '13px')?' selected':'').">$_</option>";
  }
$log_head .= '</select>';
if(@set::font_family) {
  $log_head .= '<select id="font_family" onchange="font_family_change(this)" onkeyup="font_family_change(this)" style="height:1.6em;font-size:11px;">';
  $log_head .= '<option value="">指定なし</option>';
  $log_head .= "<option value='@$_[1]'>@$_[0]</option>" for (@set::font_family);
  $log_head .= '</select>',"\n";
}
$log_head .= '</div>'."\n";


### モード判別 ###
&decode;
if   ($in{'mode'} eq 'list'){ &loglist; }
elsif($in{'mode'} eq 'view'){ &logview; }
elsif($in{'mode'} eq 'make'){ &logmake; }
else { &frame; }

### 過去ログ一覧 ###
sub loglist {
  my @stdata = stat('./log_all.dat');
  my $byte = int($stdata[7] / 1024 + 0.999);
  print "Content-type: text/html\n\n";
  print <<"HTML";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>$set::title</title>
<style TYPE="text/css">
body  { font-size:13px; margin-top:15px; color:$set::color_font; background-color:$set::color_back; }
table { border-collapse:collapse; }
th,td { padding:0px; font-size:13px; }
hr    { border:none; height:1px; color:$set::color_hr; background-color:$set::color_hr; }
input { font-size:13px; }
input[type="text"],input[type="password"],select { border:1px solid $set::color_hr; border-radius:3px; }
body  { font-family:"ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro","メイリオ","Meiryo","Verdana","Arial","Helvetica","ＭＳ Ｐゴシック","MS PGothic","Osaka",sans-serif; line-height:1; }
input,
select{ font-family:"Verdana","Arial","Helvetica","ＭＳ Ｐゴシック","MS PGothic","Osaka"; }
a:link   { color:$set::color_a_link; text-decoration:none; }
a:visited{ color:$set::color_a_visited; text-decoration:none; }
a:hover  { color:$set::color_a_hover; }
.name{ padding:0px 5px 5px 0px; }
.byte{ padding:0px 0px 5px 0px; text-align:right; }
</style>
<base target="oldlogs">
</head>
<body>
<table style="width:100%;">
<tr><td class="name"><a href="$set::log_cgi?mode=view">現行ログ</a></td><td class="byte"><small>$byte KB</small></td></tr>
<tr><td style="height:10px;"></td></tr>
HTML
  if($in{'dir'}){
    $in{'dir'} = Encode::decode('utf8', $in{'dir'});
    $set::log_dir .= "$in{'dir'}/";
    print '<tr><td><a href="',$set::log_cgi,'?mode=list" target="_self">../</a></td></tr>',"\n",'<tr><td style="height:10px;"></td></tr>',"\n";
    print '<tr><td>',$in{'dir'},'/</td></tr>',"\n",'<tr><td style="height:5px;"></td></tr>',"\n";
  }
  opendir(my $DIR,"$set::log_dir");
  my @loglist = readdir($DIR);
  closedir($DIR);
  my @folder;
  foreach(reverse sort @loglist) {
    if ($_ !~ /\./) {
      $_ = Encode::decode('utf8', $_);
      print '<tr><td class="name"><a href="',$set::log_cgi,'?mode=list&dir=',$_,'" target="_self">',$_,'/</a></td></tr>',"\n";
      push(@folder, $_);
    }
  }
  foreach(reverse sort @loglist) {
    if ($_ =~ /\.htm/) {
      my @stdata = stat("$set::log_dir$_");
      my $byte = int($stdata[7] / 1024 + 1.5);
      my $name = $_;
         $name = s/\.(htm|html)$//; my $ext = '.'.$1;
      print '<tr><td class="name"><a href="',$set::log_dir,$_,$ext,'">',$_,'</a></td>';
      print '<td class="byte"><small>',$byte,' KB</small></td></tr>',"\n";
    }
  }
  my $filedate; my $log_year;
  if($in{'password'} eq $set::password){
    open(my $FH, "<:utf8", './log_all.dat') or &error('./log_all.datが開けません');
    my $line = <$FH>;
    close($FH);
    my $year = substr($line, 0, 4);
    my $mon  = substr($line, 5, 2);
    my $day  = substr($line, 8, 2);
    $filedate = "$year$mon$day$set::log_end".'_';
    if($set::log_yeardir){
      $set::log_dir .= "$year/";
      $log_year = $year;
    }
    opendir(my $DIR,"$set::log_dir");
    my @loglist = readdir($DIR);
    closedir($DIR);
    my $i = 0;
    foreach (@loglist) {
      if ($_ =~ /$filedate/) { $i++; }
    }
    $filedate = $filedate.$i;
    print <<"HTML";
<form name="send" method="POST" action="$set::log_cgi">
<tr><td colspan="2" style="padding-top:20px;">
  <div style="text-align:center;"><hr>現行ログのバックアップ<hr>
  <input type="hidden" name="mode" value="make">
  <input type="hidden" name="password" value="$in{'password'}">
  格納フォルダ<br>
  <table style="margin:auto;text-align:left;"><tr><td>
  <input type="radio" name="folder_make" value="0" checked><select name="log_folder">
  <option value="">なし</option>
HTML
  my $new_year = 1;
  for (@folder) {
    print "<option value='$_'" , ($set::log_dir && $_ eq $log_year)?' selected':'' , ">$_</option>";
    if($set::log_dir && $_ eq $log_year){ $new_year = 0; }
  }
  print "<option value='$log_year' selected>$log_year</option>" if $new_year && $log_year;
  print <<"HTML";
</select><br>
  <input type="radio" name="folder_make" value="1"><input type="text" name="new_folder" style="width:100px;">
  </td></tr></table><br>
  ファイル名<br><input type="text" name="filename" value="${filedate}" style="width:100px;">.html<br><br>
  <input type="checkbox" name="log_del" value="1" checked>現行ログ(全体)を初期化<br><br>
  <input type="checkbox" name="pre_del" value="1" $set::log_del_pre>現行ログ(最新)を初期化<br><br>
  <input type="checkbox" name="topic_del" value="1" $set::log_tpi_pre>TOPIC&amp;参加者初期化<br><br>
  <input type="submit" value="作成"></div>
</td></tr>
</form>
HTML
  }
  else {
    print <<"HTML";
<form name="send" method="POST" action="$set::log_cgi" target="_self">
<tr><td colspan="2" style="padding-top:20px;">
  <hr>
  <div style="text-align:center;padding-top:20px;">
    <input type="hidden" name="mode" value="list">
    <input type="password" name="password" style="width:90px;">
    <input type="submit" value="管理用">
  </div>
</td></tr>
</form>
HTML
  }
  print <<"HTML";
</table>
</body>
</html>
HTML
}

### ログ表示 ###
sub logview {
  print "Content-type: text/html\n\n";
  print $log_head;
  print '<div style="height:10px;"></div>',"\n";
  open(my $FH, "<:utf8", './log_all.dat') or &error('./log_all.datが開けません');
  my @lines = <$FH>;
  close($FH);
  my $num = 0;
  my ($prename, $precolor, $prenpc, $presupp, $preday, $prehost);
  foreach (0..$#lines) {
    my ($date,$name,$comm,$supp,$dice,$color,$host,$npc) = split(/<>/, $lines[$_]);
    my($day, $date) = split(/-/, $date);
    my $same = ($prehost eq $host && $prename eq $name && $precolor eq $color && $prenpc eq $npc && $npc ne '*') ? 1 : 0;
    if($day ne $preday){
      print '</dl>',"\n" if $_;
      print '<dl class="line" id="d',$day,'">';
      print '<dt class="day">',$day,'<a href="#d',$day,'">&#x25E5;</a></dt>';
      $same = 0;
    }
    if(!$same){
      print '</dl>',"\n";
      $num++;
      print '<dl class="line',($npc eq '*' ? ' system' : ''),'" id="n',$num,'">',"\n";
      if ($name || $npc ne '*')
           { print '  <dt style="color:',$color,'">',($npc && $set::npc_mark_on && $npc ne '*' ? $set::npc_mark.$name.$set::npc_mark2 : $name); }
      else { print '  <dt class="noname">'; }
      print '<a href="#n',$num,'">&#x25E5;</a></dt>',"\n";
    }
    print '  <dd class="date">',$date,'</dd>';
    print '<dd>';
    print '',$comm, if $comm ne '';
    print ' <span class="supp">',$supp,'</span>' if $supp ne '' && (!$same || ($same && $presupp ne $supp));
    print '<div class="dice">',$dice,'</div>' if $dice ne '';
    print '</dd>',"\n";
    $prename = $name; $precolor = $color; $prenpc = $npc; $presupp = $supp; $preday = $day; $prehost = $host;
  }
  print '</dl>',"\n" if $num;
  print <<'HTML';
  <p id="footer" style="text-align:center;font-size:13px;clear:both;">
    ゆとチャⅡ／ぬる - <a href="http://yutorize.2-d.jp/" target="_blank">ゆとらいず工房</a>
  </p>
</body>
</html>
HTML
}

### バックアップ作成 ###
sub logmake {
  use Fcntl;
  
  my $mask = umask 0; # umask値変更＆保存

  if($set::password ne $in{'password'}) { &error("パスワードが違います"); }

  my $year;
  if($in{'folder_make'})
      { $year = $in{'new_folder'}; }
  else{ $year = $in{'log_folder'}; }
  my $log_dir = $set::log_dir; my $filename;
  if($year){ $filename = "$log_dir$year/$in{'filename'}.html"; $log_dir .= "$year/"; }
  else     { $filename = "$log_dir$in{'filename'}.html"; }

  if ($filename =~ /^([\w\.\/\-]+)$/) { $filename; }
  else { &error("ファイル名を変更してください"); }

  if(!-d "$log_dir"){ mkdir "$log_dir"; } 
  opendir(my $LOG, $log_dir) or &error("ディレクトリが開けません");
  my @loglist = readdir($LOG);
  closedir($LOG);
  foreach (@loglist) {
    $_ = $log_dir.$_;
    if ($_ =~ /$filename/) { &error("そのファイル名は既に使われています"); }
  }

  my $mask = umask 0;
  sysopen(my $BU, $filename, O_WRONLY | O_EXCL | O_CREAT, 0666) or &error("${filename}の作成に失敗しました");
  print $BU $log_head;
  print $BU '<h1>',$in{'filename'},'</h1>',"\n";
  open(my $FH, "<:utf8", './log_all.dat') or &error('ログファイルが開けません');
  my @lines = <$FH>;
  close($FH);
  my $num = 0;
  my ($prename, $precolor, $prenpc, $presupp, $preday, $prehost);
  foreach (0..$#lines) {
    my ($date,$name,$comm,$supp,$dice,$color,$host,$npc) = split(/<>/, $lines[$_]);
    my($day, $date) = split(/-/, $date);
    my $same = ($prehost eq $host && $prename eq $name && $precolor eq $color && $prenpc eq $npc && $npc ne '*') ? 1 : 0;
    if($day ne $preday){
      print $BU '</dl>',"\n" if $_;
      print $BU '<dl class="line" id="d',$day,'">';
      print $BU '<dt class="day">',$day,'<a href="#d',$day,'">&#x25E5;</a></dt>';
      $same = 0;
    }
    if(!$same){
      print $BU '</dl>',"\n";
      $num++;
      print $BU '<dl class="line',($npc eq '*' ? ' system' : ''),'" id="n',$num,'">',"\n";
      if ($name || $npc ne '*')
           { print $BU '  <dt style="color:',$color,'">',($npc && $set::npc_mark_on && $npc ne '*' ? $set::npc_mark.$name.$set::npc_mark2 : $name); }
      else { print $BU '  <dt class="noname">'; }
      print $BU '<a href="#n',$num,'">&#x25E5;</a></dt>',"\n";
    }
    print $BU '  <dd class="date">',$date,'</dd>';
    print $BU '<dd>';
    print $BU '',$comm, if $comm ne '';
    print $BU ' <span class="supp">',$supp,'</span>' if $supp ne '' && (!$same || ($same && $presupp ne $supp));
    print $BU '<div class="dice">',$dice,'</div>' if $dice ne '';
    print $BU '</dd>',"\n";
    $prename = $name; $precolor = $color; $prenpc = $npc; $presupp = $supp; $preday = $day; $prehost = $host;
  }
  print $BU '</dl>',"\n" if $num;
  print $BU '<dl class="line" id="stat">',"\n";
  print $BU ' <dt class="noname"><a href="#stat">&#x25E5;</a></dt>',"\n";
  print $BU ' <dd>',"\n";

  ## ダイス記録
  my $dice_all;
  my @dicelist = (
    '1 \+ 1','1 \+ 2','1 \+ 3','1 \+ 4','1 \+ 5','1 \+ 6',
    '2 \+ 1','2 \+ 2','2 \+ 3','2 \+ 4','2 \+ 5','2 \+ 6',
    '3 \+ 1','3 \+ 2','3 \+ 3','3 \+ 4','3 \+ 5','3 \+ 6',
    '4 \+ 1','4 \+ 2','4 \+ 3','4 \+ 4','4 \+ 5','4 \+ 6',
    '5 \+ 1','5 \+ 2','5 \+ 3','5 \+ 4','5 \+ 5','5 \+ 6',
    '6 \+ 1','6 \+ 2','6 \+ 3','6 \+ 4','6 \+ 5','6 \+ 6',
  );
  if($set::dice_record) {
    my %list; my %out;
    open(my $FH, "<:utf8", './log_all.dat');
    while (<$FH>) {
      my ($name, $dice, $npc) = (split /<>/, $_)[1,4,7];
      next if(!$dice);
      next if($dice !~ /2D6/ && $dice !~ /威力/ || $dice =~ /GF/ || $dice =~ /closed/);
      if($npc){ $name = "他(NPC)";}
      push @{$list{$name}},$dice;
      $dice_all .= $dice;
    }
    close ($FH);
  
    my $all_total;
    ## 個人統計
    print $BU "<table class=\"count\">\n";
    foreach my $name (sort keys %list) {
      print $BU "<tr><th colspan=\"3\">$name</th></tr>\n";
      my $indiv = "@{$list{$name}}";
      foreach (@dicelist) {
        my $dice = $_;
        my $indiv_count = ($indiv =~ s/$dice/$dice/g); $dice =~ s/\\//g;
        my $equal = eval($dice);
        $out{"indiv_eq$equal"} += $indiv_count;
      }
      my $indiv_total = 0; my $result_total = 0;
      for(2 .. 12){
        $indiv_total += $out{"indiv_eq$_"};
        $result_total += $_ * $out{"indiv_eq$_"};
        print $BU "<tr><td>$_</td><td>".$out{"indiv_eq$_"}."回</td><td><div style=\"width:".($out{"indiv_eq$_"} * 7)."px;height:7px;background-color:#772255;\"></div></td></tr>\n";
        $out{"indiv_eq$_"} = 0;
      }
      print $BU "<tr><td><b>計</b></td><td><b>${indiv_total}回</b></td><td><b>平均",sprintf("%.3f",($result_total / $indiv_total)),"</b></td></tr>\n</tr>\n";
      $all_total += $indiv_total;
    }
    print $BU "</table>\n";
    
    ## 全体統計
    if($all_total){
      print $BU "<table class=\"count\">";
      print $BU "<tr><th colspan=\"4\">2d6分布</th></tr>\n";
      foreach (@dicelist) {
        my $dice = $_;
        my $all_count = ($dice_all =~ s/$dice/$dice/g); $dice =~ s/\\//g;
        my $equal = eval($dice);
        print $BU "<tr><td style=\"text-align:left;\">$dice = $equal</td><td>${all_count}回</td><td><div style=\"width:".sprintf("%.0f", ($all_count * 1000 / ($all_total+3)))."px;height:7px;background-color:#775522;\"></div></td><td>".sprintf("%.2f", ($all_count * 100 / $all_total))."%</td></tr>\n";
        $out{"all_eq$equal"} += $all_count;
        for(my $i = 1; $i <= 6; $i++){
          if($_ =~ /$i +/){ $out{"onedice$i"} += $all_count; }
          if($_ =~ /\+ $i/){ $out{"onedice$i"} += $all_count; }
        }
      }
      my $a_result_total = 0;
      for(2 .. 12){ $a_result_total += $_ * $out{"all_eq$_"}; }
      print $BU '<tr><td><b>合計</b></td><td><b>',$all_total,'回</b></td><td><b>平均',sprintf("%.3f",($a_result_total / $all_total)),'</b></td><td><b></b></td></tr>',"\n";
      print $BU "<tr><th colspan=\"4\">2d6合計分布</th></tr>\n";
      if($all_total eq "0"){ $all_total = 1;}
      for(2 .. 12){
        print $BU "<tr><td>$_</td><td>".$out{"all_eq$_"}."回</b></td><td><div style=\"width:".sprintf("%.0f", ($out{"all_eq$_"} * 500 / ($all_total+1)))."px;height:7px;background-color:#227755;\"></div></td><td>".sprintf("%.2f", ($out{"all_eq$_"} * 100 / $all_total))."%</td></tr>\n";
      }
      print $BU "<tr><th colspan=\"4\">1/2d6分布</th></tr>\n";
      for(1 .. 6){
        print $BU "<tr><td>$_</td><td>".$out{"onedice$_"}."回</b></td><td><div style=\"width:".sprintf("%.0f", ($out{"onedice$_"} * 250 / $all_total))."px;height:7px;background-color:#225577;\"></div></td><td>".sprintf("%.2f", ($out{"onedice$_"} * 100 / $all_total))."\%</td></tr>\n";
      }
      print $BU "</table>\n";
    }
  }
  ## 発言統計
  if($set::comm_record) {
    print $BU "<table class=\"count\">\n";
    print $BU "\t<tr><th colspan=\"5\">発言統計</th></tr>\n";
    my %list; my %color;
    open(my $CO, "<:utf8", './log_all.dat');
    while (<$CO>) {
      my ($name, $comm, $color, $npc) = (split /<>/, $_)[1,2,5,7];
      if($npc eq '*'){ next; }
      if($comm eq ""){ next; }
      if($npc ne '0' && $set::npc_mark_on){ $name = "その他(NPC)"; }
      push @{$list{$name}},$comm;
      $color{$name} = $color;
    }
    close($CO);
    my $total_comm; my $total_chara; my @pl;
    foreach my $name (sort keys %list) {
      my $count = @{$list{$name}} ; $total_comm += $count ;
      if ($name ne ""){ 
        my $byte_num = (join '', @{$list{$name}});
        my $char_num = length $byte_num; $total_chara += $char_num;
        push(@pl, "$name,$count,$char_num");
      }
    }
  
    my @tmp = map {(split /,/)[2]} @pl;
    @pl = @pl[sort {$tmp[$b] <=> $tmp[$a]} 0 .. $#tmp];
    foreach ( @pl ){
      my @data = split( /,/, $_);
      my $comm_p = sprintf("%.1f", ($data[1] * 100 / $total_comm));
      my $char_p = sprintf("%.1f", ($data[2] * 100 / $total_chara)); 
      print $BU "\t<tr><td><b style=\"color:".$color{$data[0]}.";\" nowrap>$data[0]</b></td><td nowrap>$data[1]回</td><td nowrap>$comm_p%</td><td nowrap>$data[2]文字</td><td nowrap>$char_p%</td></tr>\n";
    }
  
    print $BU "\t<tr><td><b>合計</b></td><td colspan=\"2\"><b>${total_comm}回</b></td><td colspan=\"2\"><b>${total_chara}文字</b></td></tr>\n</table>\n";
  }
  print $BU ' </dd>',"\n";
  print $BU '</dl>',"\n";
  print $BU <<'HTML';
  <p id="footer" style="text-align:center;font-size:13px;clear:both;">
    ゆとチャⅡ／ぬる - <a href="http://yutorize.2-d.jp/" target="_blank">ゆとらいず工房</a>
  </p>
</body>
</html>
HTML
  close($BU);
  umask $mask;

  ## 過去統計追加
  if($set::dice_record && $dice_all ne '' && $in{'log_del'}){
    open(my $DC, "+<:utf8", $set::dice_logfile) or &error("記録ファイルが開けません");
    while (<$DC>) {
      my ($dice, $count) = (split /<>/, $_)[0..1];
      my $i = 1;
      while($i <= $count){ $dice_all .= "($dice)"; $i++; }
    }
    $dice_all =~ s/\\//g;
    flock($DC, 2);
    seek($DC, 0, 0);
    foreach (@dicelist) {
      my $dice = $_;
      my $count = ($dice_all =~ s/$dice/$dice/g); $dice =~ s/\\//g;
      if($count eq ""){ $count = 0; }
      print $DC "$dice<>$count<>\n";
    }
    truncate($DC, tell($DC));
    close($DC);
  }

  ## ログ消去
  if($in{'log_del'}) {
    open(my $DEL, ">", './log_all.dat') or &error("全体ログの初期化に失敗しました");
    close($DEL);
  }
  if($in{'pre_del'}) {
    open(my $DEL, ">", './log_pre.dat') or &error("最新ログの初期化に失敗しました");
    close($DEL);
  }
  if($in{'topic_del'}) {
    open(my $DEL, ">", './mem_list.dat') or &error("参加者一覧の初期化に失敗しました");
    close($DEL);
  }
  if($in{'pre_del'}) {
    open(my $DEL, ">", './num.dat') or &error("./num.datの初期化に失敗しました");
    print $DEL 0;
    close($DEL);
  }

  print "Content-type: text/html\n\n";
  print <<"HTML";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <title>$set::title</title>
  <style TYPE="text/css">
  body  { font-size:16px; margin-top:25px; color:$set::color_font; background-color:$set::color_back; }
  a:link   { color:$set::color_a_link; text-decoration:none; }
  a:visited{ color:$set::color_a_visited; }
  a:hover  { color:$set::color_a_hover; }
  </style>
  <base target="oldlogs">
</head>
<body>
  <p style="text-align:center"><a href="$filename">$filename</a>を作成しました。</a>
</body>
</html>
HTML
}

### トップページ ###
sub frame {
  print "Content-type: text/html\n\n";
  print <<"HTML";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">
<html lang="ja">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <title>$set::title</title>
  </head>
  <frameset  cols="200, *">
    <frame src="$set::log_cgi?mode=list" name="loglist">
    <frame src="$set::log_cgi?mode=view" name="oldlogs">
    <noframes>
    <body>
      フレーム非対応ブラウザでは利用できません。
    </body>
    </noframes>
  </frameset>
</html>
HTML
}

### デコード ###
sub decode {
  for (param()) { $in{$_} = param($_); }
}

### エラー ###
sub error {
  print "Content-type: text/html\n\n";
  print <<"EOM";
<html>
<head>
  <meta http-equiv="Content-type" content="text/html; charset=utf-8">
  <title>エラー</title>
</head>
<body text="$set::color_font" bgcolor="$set::color_back">
  <b>$_[0]</b><br>
  <a href="javascript:history.back();">戻る</a>
</body>
</html>
EOM
  exit;
}

1;