#!/usr/local/bin/perl
#use strict;
#use warnings;
use utf8;
use open ":utf8";
use open ":std";

require './config.cgi';

print "Content-type: text/html\n\n";
print <<"HTML";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <title>参加者一覧 : $set::title</title>
  <style TYPE="text/css">
  body { padding:15px; font-family:"ＭＳ Ｐゴシック","MS PGothic","ヒラギノ角ゴ Pro W3","Hiragino Kaku Gothic Pro"; color:$set::color_font; background-color:$set::color_back; }
  table{ border:1px solid $set::color_font; border-collapse:collapse; }
  th,td{ text-align:center; font-size:16px; line-height:16px; padding:3px 10px; border-bottom:1px solid $set::color_font; }
  .rom th, .rom td
       { text-align:center; font-size:13px; line-height:16px; font-weight:normal; }
  </style>
<head>
<body>
  <table style="margin:5px auto;">
    <th colspan="2">参加者一覧</th>
HTML
  my $now = time;
  open(my $FH, "<:utf8", './mem_list.dat') or print('<tr><th colspan="2">./mem_list.datが開けません</td></tr>');
  my $i = 0; my $rom;
  while(<$FH>){
    my $status;
    if(!$i){ $i++; next; }
    my($date,$name,$host,$hp,$mp,$gp,$pp) = (split(/<>/, $_))[0..2];
    my $host_c = &host_cut($host);
    $date = $now - $date;
    if($date > 300) { next; }
    if($date > 150) { $status = '△'; }
    else { $status = '○'; }
    if(!$name){ $rom .= "\t\t".'<tr class="rom"><th>R.O.M.</th><td>'.$status.'<!-- '.$host_c.' --></td></tr>'."\n"; }
    else      { print "\t\t",'<tr><th>',$name,'</th><td>',$status,'<!-- ',$host_c,' --></td></tr>',"\n"; }
    $i++;
  }
  close($FH);
  print $rom;
print <<'HTML';
  </table>
</body>
</html>
HTML

sub host_cut {
  my $host_in = shift; my $host_out;
  if   ($host_in =~ /(.*)\.(\d+?)$/)          { $host_out = "$1\.*"; }
  elsif($host_in =~ /(.*)\.(.*)\.(.*)\.(.*)$/){ $host_out = "\*\.$2\.$3\.$4"; }
  elsif($host_in =~ /(.*)\.(.*)\.(.*)$/)      { $host_out = "\*\.$2\.$3"; }
  return $host_out;
}