#use strict;
#use warnings;
use utf8;

our @colors = (
  ['#FFFFFF','white'],
  ['#EEEEEE','mercury'],
  ['#CCCCCC','silver'],
  ['#AAAAAA','moon stone'],
  ['#888888','gray'],
  ['#666666','gargoyle'],
  ['#444444','hurricane'],
  ['#222222','graphite'],
  ['#000000','black'],
  ['#56002B','chianti'],
  ['#812B56','claret'],
  ['#81002B','burgundy'],
  ['#AB002B','fez'],
  ['#AB0056','fuchsia'],
  ['#AB2B56','crimson'],
  ['#AB5681','aristoteles'],
  ['#D581AB','cosmos'],
  ['#D55681','azalee'],
  ['#D52B56','carmine'],
  ['#D52B81','rosario'],
  ['#D5002B','dress to empress'],
  ['#D50056','velvet'],
  ['#FF002B','sevillan rot'],
  ['#FF0056','christ rose'],
  ['#FF0081','peonia'],
  ['#FF2B56','cosmos pink'],
  ['#FF2B81','bougainvillaea'],
  ['#FF5681','rose'],
  ['#FF56AB','hot pink'],
  ['#FF81AB','happy bithday'],
  ['#FFABD5','baby pink'],
  ['#FFD5D5','powder pink'],
  ['#FFABAB','sardonyx'],
  ['#FF8181','light coral'],
  ['#FFAB81','salmon pink'],
  ['#FF5656','vermilion'],
  ['#FF8156','sunset sky'],
  ['#FF2B2B','scarlet'],
  ['#FF562B','marigold'],
  ['#FF812B','soleil'],
  ['#FF0000','red'],
  ['#FF2B00','ecarlate'],
  ['#FF5600','valencia'],
  ['#D50000','phoenix red'],
  ['#D52B00','grenadier'],
  ['#D55600','island sun'],
  ['#D52B2B','coup de foudre'],
  ['#D5562B','carrot'],
  ['#D55656','royal rose'],
  ['#D58156','raw sienna'],
  ['#D58181','burnt sugar'],
  ['#D5ABAB','mist mauve'],
  ['#AB8181','rose gray'],
  ['#AB5656','russet'],
  ['#AB2B2B','fire brick'],
  ['#AB562B','burnt sienna'],
  ['#AB0000','volkan'],
  ['#AB2B00','ox blood'],
  ['#810000','garnet'],
  ['#812B00','terra rosa'],
  ['#812B2B','cardinal'],
  ['#815656','heather'],
  ['#562B2B','burnt umber'],
  ['#560000','maroon'],
  ['#2B0000','ivory black'],
  ['#562B00','coffee'],
  ['#81562B','raw umber'],
  ['#815600','golden ochre'],
  ['#AB8100','natural ochre'],
  ['#AB5600','stil de grain yellow'],
  ['#AB812B','hot toddy'],
  ['#AB8156','cafe au lait'],
  ['#D5AB81','honey sweet'],
  ['#D5AB56','khaki'],
  ['#D5AB2B','golden rod'],
  ['#D5812B','calcutta curry'],
  ['#D5AB00','ancient gold'],
  ['#D58100','brown gold'],
  ['#FFD500','gold'],
  ['#FFAB00','orange'],
  ['#FF8100','flush orange'],
  ['#FFD52B','auripigment'],
  ['#FFAB2B','sunlight yellow'],
  ['#FFD556','mimosa'],
  ['#FFAB56','crescent gold'],
  ['#FFD581','yellow buff'],
  ['#FFD5AB','flesh'],
  ['#FFFFD5','edelweiss'],
  ['#FFFFAB','light yellow'],
  ['#FFFF81','canary yellow'],
  ['#D5FF81','honeysuckle'],
  ['#FFFF56','lemon yellow'],
  ['#D5FF56','light citron'],
  ['#FFFF2B','sulphar yellow'],
  ['#D5FF2B','lemon'],
  ['#ABFF2B','green yellow'],
  ['#FFFF00','yellow'],
  ['#D5FF00','flesh green'],
  ['#ABFF00','campus green'],
  ['#D5D500','renoncule'],
  ['#ABD500','chartreuse'],
  ['#81D500','rainette'],
  ['#D5D52B','dormant gold'],
  ['#ABD52B','acid green'],
  ['#D5D556','sparkle green'],
  ['#ABD556','spring green'],
  ['#D5D581','citrus yellow'],
  ['#D5D5AB','mellow yellow'],
  ['#ABAB81','citron gray'],
  ['#ABAB56','dark khaki'],
  ['#ABAB2B','olivine green'],
  ['#81AB2B','pickles green'],
  ['#ABAB00','jena'],
  ['#81AB00','willow green'],
  ['#818100','olive'],
  ['#568100','mugwort'],
  ['#81812B','terra'],
  ['#818156','clay creek'],
  ['#56562B','dark olive green'],
  ['#565600','cranach'],
  ['#2B2B00','taupe'],
  ['#2B5600','avenue green'],
  ['#56812B','leaf green'],
  ['#2B8100','windsor green'],
  ['#2BAB00','apple green'],
  ['#56AB00','vert libellule'],
  ['#56AB2B','meadow green'],
  ['#81AB56','grass green'],
  ['#ABD581','sprout'],
  ['#81D556','vivid lime green'],
  ['#56D52B','muscat green'],
  ['#81D52B','linden green'],
  ['#2BD500','lucky green'],
  ['#56D500','rayon vert'],
  ['#2BFF00','green flash'],
  ['#56FF00','lovebird'],
  ['#81FF00','lawn green'],
  ['#56FF2B','bright green'],
  ['#81FF2B','gremlin green'],
  ['#81FF56','isle of wight'],
  ['#ABFF56','light lawn green'],
  ['#ABFF81','lime light'],
  ['#D5FFAB','reef'],
  ['#D5FFD5','ice green'],
  ['#ABFFAB','pale green'],
  ['#81FF81','light paris green'],
  ['#81FFAB','aphrodite'],
  ['#56FF56','peterpan'],
  ['#56FF81','puritan green'],
  ['#2BFF2B','harlequin'],
  ['#2BFF56','azurite green'],
  ['#2BFF81','beryl green'],
  ['#00FF00','lime'],
  ['#00FF2B','signal green'],
  ['#00FF56','canton green'],
  ['#00D500','middle green'],
  ['#00D52B','peridot'],
  ['#00D556','vigorous green'],
  ['#2BD52B','lime green'],
  ['#2BD556','surf green'],
  ['#56D556','beaumarchais'],
  ['#56D581','descartes'],
  ['#ABD5AB','lush green'],
  ['#81AB81','herbe'],
  ['#56AB56','greenwich'],
  ['#56AB81','celadon'],
  ['#2BAB2B','veronese green'],
  ['#2BAB56','spring note'],
  ['#00AB00','medium green'],
  ['#00AB2B','sunshine green'],
  ['#008100','green'],
  ['#00812B','chrome green'],
  ['#2B812B','chive'],
  ['#568156','foliage'],
  ['#2B562B','terre verte'],
  ['#005600','ever green'],
  ['#002B00','dark green'],
  ['#00562B','dragon'],
  ['#2B8156','malachite green'],
  ['#008156','viridian'],
  ['#00AB81','oriental green'],
  ['#00AB56','emerald green'],
  ['#2BAB81','beans green'],
  ['#81D5AB','winter green'],
  ['#81D581','primavera'],
  ['#56D5AB','coral green'],
  ['#2BD5AB','blue zircon'],
  ['#2BD581','aqua green'],
  ['#00D5AB','opal green'],
  ['#00D581','talisman green'],
  ['#00FFD5','aqua'],
  ['#00FFAB','cleopatra'],
  ['#00FF81','light turquoise'],
  ['#2BFFD5','mint blue'],
  ['#2BFFAB','medici blue'],
  ['#56FFD5','aquamarine'],
  ['#56FFAB','light spring green'],
  ['#81FFD5','wateau'],
  ['#ABFFD5','spring stream'],
  ['#D5FFFF','powder aqua'],
  ['#ABFFFF','horizon blue'],
  ['#81FFFF','light cyan'],
  ['#81D5FF','sky blue'],
  ['#56FFFF','west country'],
  ['#56D5FF','myosotis'],
  ['#2BFFFF','italian blue'],
  ['#2BD5FF','cornwall'],
  ['#2BABFF','trade wind'],
  ['#00FFFF','cyan'],
  ['#00D5FF','deep sky blue'],
  ['#00ABFF','process cyan'],
  ['#00D5D5','aqua mint'],
  ['#00ABD5','atlantic blue'],
  ['#0081D5','cerulean blue'],
  ['#2BD5D5','flesh blue'],
  ['#2BABD5','clear sky'],
  ['#56D5D5','viking'],
  ['#56ABD5','comet blue'],
  ['#81D5D5','arcardia'],
  ['#ABD5D5','fairy land'],
  ['#81ABAB','venezia'],
  ['#56ABAB','verona'],
  ['#2BABAB','rouen'],
  ['#2B81AB','delphia blue'],
  ['#00ABAB','turquoise green'],
  ['#0081AB','arabesque tag'],
  ['#008181','dark cyan'],
  ['#005681','triton'],
  ['#2B8181','venit'],
  ['#568181','vert de gris'],
  ['#2B5656','dark slate gray'],
  ['#005656','hyuaran'],
  ['#002B2B','bottle green'],
  ['#002B56','prussian blue'],
  ['#2B5681','dark ocean'],
  ['#002B81','luxor'],
  ['#002BAB','strato blue'],
  ['#0056AB',"cote d'azur"],
  ['#2B56AB','cadiz blue'],
  ['#5681AB','cadet blue'],
  ['#81ABD5','southern cross'],
  ['#5681D5','academy blue'],
  ['#2B56D5','azurite'],
  ['#2B81D5','zenith blue'],
  ['#002BD5','iliad blue'],
  ['#0056D5','bleu acide'],
  ['#002BFF','goethe'],
  ['#0056FF','regatta blue'],
  ['#0081FF','symphony blue'],
  ['#2B56FF','vermeer'],
  ['#2B81FF','morning glory'],
  ['#5681FF','cornflower blue'],
  ['#56ABFF','forget me not'],
  ['#81ABFF','lavender blue'],
  ['#ABD5FF','light blue'],
  ['#D5D5FF','alice blue'],
  ['#ABABFF','hermes blue'],
  ['#8181FF','menuetto'],
  ['#AB81FF','tanzanite'],
  ['#5656FF','hyacinth blue'],
  ['#8156FF','hyacinth purple'],
  ['#2B2BFF','sapphire'],
  ['#562BFF','bermude'],
  ['#812BFF',"bishop's violet"],
  ['#0000FF','blue'],
  ['#2B00FF','madinne blau'],
  ['#5600FF','blue magenta'],
  ['#0000D5','medium blue'],
  ['#2B00D5','gentiane'],
  ['#5600D5','electric violet'],
  ['#2B2BD5','autumn azure'],
  ['#562BD5','purple heart'],
  ['#5656D5','smalt'],
  ['#8156D5','blue violet'],
  ['#8181D5','wistaria'],
  ['#ABABD5','day dream'],
  ['#8181AB','echo blue'],
  ['#5656AB','slate blue'],
  ['#2B2BAB','ultramarine'],
  ['#562BAB','daisy bush'],
  ['#0000AB','lapis lazuli'],
  ['#2B00AB','dark slate blue'],
  ['#000081','dark blue'],
  ['#2B0081','helio blue redish'],
  ['#2B2B81','midnight blue'],
  ['#565681','blue gray'],
  ['#2B2B56',"marine d'hiver"],
  ['#000056','stratos'],
  ['#00002B','sorcerer'],
  ['#2B0056','purple navy'],
  ['#562B81','violet'],
  ['#560081','neptune'],
  ['#5600AB','romanesque'],
  ['#8100AB','iris purple'],
  ['#812BAB','amethyst'],
  ['#8156AB','deluge'],
  ['#AB81D5','lilac'],
  ['#AB56D5','midium orchid'],
  ['#812BD5','dark violet'],
  ['#AB2BD5','erica'],
  ['#8100D5','deep purple'],
  ['#AB00D5','deep violet'],
  ['#8100FF','vivid purple'],
  ['#AB00FF','sindbad purple'],
  ['#D500FF','vivid fuchsia'],
  ['#AB2BFF','purple magenta'],
  ['#D52BFF','spanish rose'],
  ['#AB56FF','heliotrope'],
  ['#D556FF','lampone'],
  ['#D581FF','pastel cosmos'],
  ['#D5ABFF','soft lavender'],
  ['#FFD5FF','powder purple'],
  ['#FFABFF','light magenta'],
  ['#FF81FF','mallow'],
  ['#FF81D5','pastel pink'],
  ['#FF56FF','pink flamingo'],
  ['#FF56D5','radiant pink'],
  ['#FF2BFF','fiesta rose'],
  ['#FF2BD5','razzle dazzle rose'],
  ['#FF2BAB','persian rose'],
  ['#FF00FF','magenta'],
  ['#FF00D5','carmen coral'],
  ['#FF00AB','process magenta'],
  ['#D500D5','renaissance'],
  ['#D500AB','cherry pop'],
  ['#D50081','ruby'],
  ['#D52BD5','deep magenta'],
  ['#D52BAB','azalea pink'],
  ['#D556D5','peony purple'],
  ['#D556AB','chelsea rose'],
  ['#D581D5','fairy pink'],
  ['#D5ABD5','old orchid'],
  ['#AB81AB','aster hou'],
  ['#AB56AB','orchid'],
  ['#AB2BAB','tyrian purple'],
  ['#AB2B81','daphne'],
  ['#AB00AB','dark magenta'],
  ['#AB0081','dahlia purple'],
  ['#810081','purple'],
  ['#810056','mayfair rose'],
  ['#812B81','royal purple'],
  ['#815681','slate purple'],
  ['#562B56','heath'],
  ['#560056','charles de jem'],
  ['#2B002B','misty purple'],
);

1;