#use strict;
#use warnings;
use utf8;
use open ":utf8";
use open ":std";
use Encode;

package dice;

### 通常ダイス(nDx) ###
sub dice {
  my $out_dice;
  
  my $quant = $::in{"dq".($_[0])};
  my $faces = $::in{"df".($_[0])};
  my $check = $::in{"dc".($_[0])};
  my $half  = $::in{"dh".($_[0])};
  my $add   = $::in{"da".($check)};
  my $add2  = $::in{"dp".($_[0])};
  my $opt   = $::in{"do".($_[0])};
  my $crit  = $::in{"dv".($_[0])};
  my $rep   = $_[2];
  my $plural= $_[3];
  my $code;
  
  if($quant ne ''){ $quant =~ s/^\+//; $quant =~ s/[^0-9\.\+\-\*\/\(\)]//g; $quant =~ tr/\.\+\-\*\///s; } else { $quant = 1; }
  my $or_quant = $quant;
  my $quant = eval($quant);
  if(!$add2 && $add =~ s/\@([0-9]+)//){ $crit = $1; }
  if(!$add2 && $add =~ s!(.*?)((?:\/\/|\*\*)(?:[0-9]*))(.*)!!){ $half = $2; $add = $1; $add2 = $3; }
  
  ### 自由記入
  if((!$add && $faces =~ /[,、]/) || $add =~ /[,、]/) {
    $faces = $add if ($faces !~ /[,、]/);
    if ($quant < 1 || $quant > 200) { return $or_quant.'D... → 1～200Dの間に収めてください' }
    
    my @line = split(/[,、]/, $faces);
    if(@line > 100){ return $or_quant.'D... → 項目が多すぎます' }
    my @result;
    for (1..$quant) {
      my $num = int(rand(@line));
      push(@result, $line[$num]);
    }
    if(!$rep){
      $code = '('.join(' , ',@line).')';
      $code .= "×$plural" if $plural > 1;
      $code .= " →";
    }
    $out_dice = '<span style="font-size:83%;">' if(!$rep);
    $out_dice .= $code.' ['.join(' , ',@result).']';
    $out_dice .= '</span>' if($rep+1 == $plural);
  }
  ### 通常
  else {
    my $amount = 0;
    my $amount2;
    my $formula;
    my $total;
    my $gf; my $cl;
    
    if ($quant < 1 || $quant > 200) { return $or_quant.'D'.$faces.' → 1～200Dの間に収めてください' }
    elsif($faces < 2 || $faces > 1000){ return $or_quant.'D'.$faces.' → D2～1000の間に収めてください' }
    if ($crit && $crit <= $or_quant){ return $or_quant.'D'.$faces.'@'.$crit.' → ∞' }
    
    if($add =~ /gf/i || $add2 =~ /gf/i || $opt =~ /gf/i){ $gf = '<small>GF</small>'; }
    if($add =~ /cl/i || $add2 =~ /cl/i || $opt =~ /cl/i){ $cl = '(closed)'; }
    if($add) { $add  =~ s/^\+//; $add  =~ s/[^0-9\.\+\-\*\/\(\)]//g; $add  =~ tr/\.\+\-\*\///s; } else { $add = 0; }
    if($add2){ $add2 =~ s/^\+//; $add2 =~ s/[^0-9\.\+\-\*\/\(\)]//g; $add2 =~ tr/\.\+\-\*\///s; } else { $add2 = 0; }
    
    if(!$rep){
      $code = "${or_quant}D${faces}$gf";
      $code .= "\@$crit" if $crit;
      $code .= "×$plural" if $plural > 1;
      $code .= " →";
      $code = "<big>$code</big>" if $plural > 1;
    }
    
    for (my $j = 0; $j < $set::critical_max; $j++) {
      ## グレイテストフォーチュン
      if($gf) {
        my $number = int(rand($faces)) + 1;
        $amount = $number * $quant;
        $formula .= "$number * $quant";
      }
      ## $quant個の$faces面ダイスを振る
      else {
        my $number_total = 0;
        for (my $i = 0; $i < $quant; $i++) {
          my $number = int(rand($faces)) + 1;
          $number_total += $number;
          if ($i == 0) { $formula .= $number; }
          else { $formula .= " + $number"; }
        }
        $amount += $number_total;
        if ($crit && $number_total >= $crit){
          $formula .= " <small><b>${set::critical_text}</b></small> + ";
          next;
        }
      }
      last;
    }
    ## 半減,倍化処理
    if($half){
      $amount += eval($add);
      if($add){ $formula .= " + 【$add】"; }
      if($add2){ $amount2 = " + 【$add2】"; }
      if($cl){ $formula = $cl; }
      if($half =~ s/^\/\/([0-9]*)$/$1/){
        $half = 2 if !$half;
        use POSIX qw/ceil/;
        $total = ceil($amount / $half) + eval($add2);
        $out_dice = "<span style=\"color:$set::color_dice_half;\">$code [$formula = <b>$amount</b>] / $half$amount2 = </span>";
      }
      if($half =~ s/^\*\*([0-9]*)$/$1/){
        $half = 2 if !$half;
        $total = $amount * $half + eval($add2);
        $out_dice = "<span style=\"color:$set::color_dice_mult;\">$code [$formula = <b>$amount</b>] * $half$amount2 = </span>";
      }
    }
    ## 通常処理
    else {
      $amount += eval($add);
      if($add){ $formula .= " + 【$add】"; }
      if($cl){ $formula = $cl; }
      $total = $amount;
      $out_dice = "$code $formula = ";
    }
    if($plural > 1){ $out_dice = "<small>$out_dice</small><b>$total</b>"; } else { $out_dice = "$out_dice<b>$total</b>"; }
    if(!$cl && $amount == $quant*$faces + eval($add)){ $out_dice = "<span style=\"color:$set::color_dice_crit;\">$out_dice</span>"; } #クリティカル
    elsif(!$cl && $amount == $quant + eval($add))    { $out_dice = "<span style=\"color:$set::color_dice_fumb;\">$out_dice</span>"; } #ファンブル
    $out_dice .= ' ,' if ($rep+1 < $plural);
  }
  return $out_dice;
}

1;