#use strict;
#use warnings;
use utf8;
use open ":utf8";
use open ":std";
use Encode;

package dice_sp;

my $color_jan = "#4488ff"; #じゃんけん
my $color_tru = "#dd6688"; #トランプ
my $color_tar = "#8877ff"; #タロット
my $color_run = "#aa77dd"; #ルーン
my $color_hisA= "#44aa77"; #経歴
my $color_hisB= "#77aa44"; #経歴BT
my $color_job = "#aa8844"; #一般技能
my $color_emo = "#6666ff"; #感情表

### 特殊ダイス(n@x) ###
sub dice_sp {
  my $out_dice;
  
  my $game  = $::in{'game'};
  
  my $quant = $::in{'dq'.($_[0])};
  my $faces = $::in{'df'.($_[0])};
  my $check = $::in{'dc'.($_[0])};
  my $add   = $::in{'da'.($check)};
  my $spec  = $_[1];
  
  if($quant ne ''){ $quant =~ s/^\+//; $quant =~ s/[^0-9\.\+\-\*\/\(\)]//g; $quant =~ tr/\.\+\-\*\///s; } else { $quant = 1; }
  my $or_quant = $quant;
  my $quant = eval($quant);
  
  if($spec =~ /[,、]/){
    return &free($quant,$spec);
  }
  elsif($spec =~ /^(jan|じゃん|ジャン)/i){
    return &janken;
  }
  elsif($spec =~ /^(tarot|タロット|アルカナ)/i){
    return &tarot($quant);
  }
  elsif($spec =~ /^(trump|トランプ)/i){
    return &trump($quant);
  }
  elsif($spec =~ /^(rune|ルーン)/i){
    return &rune($quant);
  }
  elsif($game eq 'sw2' && $spec =~ /^(histB|経歴B)/i){
    return &sw2_historyBT($quant);
  }
  elsif($game eq 'sw2' && $spec =~ /^(hist|経歴)/i){
    return &sw2_history($quant);
  }
  elsif($game eq 'sw2' && $spec =~ /^(job|一般技能)/i){
    return &sw2_job($quant);
  }
  elsif($game eq 'dx3' && $spec =~ /^(emo|感情)/i){
    return &dx3_emo($spec);
  }
  elsif(!$spec || $spec =~ /^[0-9]+$/){
    return &number($or_quant,$quant,$spec);
  }
}

sub free {
  my($quant, $spec) = @_;
  my $out;
  my @line = split(/[,、]/, $spec);
  @line = &shuffle(@line);
  $out = '<span style="font-size:83%;">';
  for (0..@line) {
    if($_ < $quant) { $out .= "<b>$line[$_]</b>"; }
    else { $out .= '<span style="color:'.$set::color_dice_fumb.';">'.$line[$_].'</span>'; }
    last if $_+1 >= @line;
    $out .= ' , ';
  }
  $out .= '</span>';
  return $out;
}

sub janken {
  my $number = int(rand(3));
  my @line = ('グー','チョキ','パー');
  return '<span style="color:'.$color_jan.';">'.$line[$number].'</span>';
}

sub tarot {
  my $quant = $_[0];
  $quant = 1 if(!$quant);
  my @line = (
    "0 愚者",
    "I 魔術師",   "II 女教皇",  "III 女帝",
    "IV 皇帝",    "V 法皇",     "VI 恋人",
    "VII 戦車",   "VIII 力",    "IX 隠者",
    "X 運命の輪", "XI 正義",    "XII 吊された男",
    "XIII 死神",  "XIV 節制",   "XV 悪魔",
    "XVI 塔",     "XVII 星",    "XVIII 月",
    "XIX 太陽",   "XX 審判",    "XXI 世界",
  );
  my @result;
  if($quant > @line) { $quant = @line; }
  for (my $i=0; $i < $quant; $i++) {
    my $number = int(rand(@line));
    if (!$line[$number]) { $i--; }
    else {
      my $rev = int(rand(2));
      if($rev) { push(@result, "$line[$number]の正位置"); }
      else     { push(@result, "$line[$number]の逆位置"); }
      $line[$number] = '';
    }
  }
  return '<span style="color:'.$color_tar.';font-size:83%;">'.join(' , ',@result).'</span>';
}

sub trump {
  my $quant = $_[0];
  $quant = 1 if(!$quant);
  my @line = (
    '&spades;A','&spades;2','&spades;3','&spades;4','&spades;5','&spades;6','&spades;7','&spades;8','&spades;9','&spades;10','&spades;J','&spades;Q','&spades;K',
    '&hearts;A','&hearts;2','&hearts;3','&hearts;4','&hearts;5','&hearts;6','&hearts;7','&hearts;8','&hearts;9','&hearts;10','&hearts;J','&hearts;Q','&hearts;K',
     '&clubs;A', '&clubs;2', '&clubs;3', '&clubs;4', '&clubs;5', '&clubs;6', '&clubs;7', '&clubs;8', '&clubs;9', '&clubs;10', '&clubs;J', '&clubs;Q', '&clubs;K',
     '&diams;A', '&diams;2', '&diams;3', '&diams;4', '&diams;5' ,'&diams;6', '&diams;7', '&diams;8', '&diams;9', '&diams;10', '&diams;J', '&diams;Q', '&diams;K',
    'joker','joker',
  );
  my @result;
  if($quant > @line) { $quant = @line; }
  for (my $i=0; $i < $quant; $i++) {
    my $number = int(rand(@line));
    if (!$line[$number]) { $i--; }
    else {
      push(@result, $line[$number]);
      $line[$number] = '';
    }
  }
  return '<span style="color:'.$color_tru.';">'.join(' , ',@result).'</span>';
}

sub rune {
  my $quant = $_[0];
  $quant = 1 if(!$quant);
  my @line = (
    "[a]アンサズ",
    "[b]ベルカナ",
    "[d]ダガズ",
    "[e]エワズ",
    "[f]フェイフュー",
    "[g]ゲーボ",
    "[h]ハガラズ",
    "[i]イサ",
    "[j]ジュラ",
    "[k]カノ",
    "[l]ラグズ",
    "[m]マンナズ",
    "[n]ナウズ",
    "[o]オシラ",
    "[p]パース",
    "[r]ライゾ",
    "[s]ソウイル",
    "[t]テイワズ",
    "[u]ウルズ",
    "[w]ウンジョー",
    "[z]アルジズ",
    "[&#305;]エイワズ",
    "[&#331;]イングワズ",
    "[&#254;]スリサズ",
    "[&nbsp;]ウィアド",
  );
  my @result;
  if($quant > @line) { $quant = @line; }
  for (my $i=0; $i < $quant; $i++) {
    my $number = int(rand(@line));
    if (!$line[$number]) { $i--; }
    else {
      if($line[$number] !~ /\[(d|g|i|j|s|&#305;|&#331;|&nbsp;)\]/) {
        my $rev = int(rand(2));
        if($rev) { push(@result, "$line[$number]（正）"); }
        else     { push(@result, "$line[$number]（逆）"); }
      }
      else { push(@result, $line[$number]); }
      $line[$number] = '';
    }
  }
  return '<span style="color:'.$color_run.';font-size:83%;">'.join(' , ',@result).'</span>';
}

sub sw2_history {
  my $quant = $_[0];
  $quant = 1 if(!$quant);
  my @line = (
    '%E5%A4%A7%E6%81%8B%E6%84%9B%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E5%91%BD%E3%82%92%E6%95%91%E3%82%8F%E3%82%8C%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E5%AD%90%E4%BE%9B%E3%81%AE%E9%A0%83%E3%81%AB%E5%AE%B6%E5%87%BA%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E7%A0%B4%E7%94%A3%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E7%BD%AA%E3%82%92%E7%8A%AF%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E6%86%A7%E3%82%8C%E3%82%8B%E5%86%92%E9%99%BA%E8%80%85%E3%81%8C%E3%81%84%E3%82%8B',
    '%E8%87%A8%E6%AD%BB%E4%BD%93%E9%A8%93%E3%82%92%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E8%A3%95%E7%A6%8F%E3%81%AA%E5%AE%B6%E3%81%AB%E7%94%9F%E3%81%BE%E3%82%8C%E3%81%9F',
    '%E8%82%B2%E3%81%A6%E3%81%AE%E8%A6%AA%E3%81%AB%E6%8B%BE%E3%82%8F%E3%82%8C%E3%81%9F',
    '%E5%AE%B6%E6%97%8F%E3%81%AB%E7%95%B0%E7%A8%AE%E6%97%8F%E3%81%8C%E3%81%84%E3%82%8B',
    '%E3%81%8B%E3%81%A4%E3%81%A6%E3%81%AF%E8%B2%B4%E6%97%8F%E3%81%A0%E3%81%A3%E3%81%9F',
    '%E5%A4%A7%E5%A4%B1%E6%81%8B%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E5%A4%A7%E6%80%AA%E6%88%91%E3%82%92%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E4%B8%80%E5%AE%9A%E6%9C%9F%E9%96%93%E3%81%AE%E8%A8%98%E6%86%B6%E3%81%8C%E3%81%AA%E3%81%84',
    '%E5%A5%87%E5%A6%99%E3%81%AA%E4%BA%88%E8%A8%80%E3%82%92%E3%81%95%E3%82%8C%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E6%9C%AC%E6%9D%A5%E3%81%A8%E3%81%AF%E7%95%B0%E3%81%AA%E3%82%8B%E6%80%A7%E5%88%A5%E3%81%A8%E3%81%97%E3%81%A6%E8%82%B2%E3%81%A6%E3%82%89%E3%82%8C%E3%81%9F',
    '%E8%A8%B1%E5%A9%9A%E3%81%8C%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E5%A4%A7%E3%81%8D%E3%81%AA%E6%8C%AB%E6%8A%98%E3%82%92%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E6%8A%95%E7%8D%84%E3%81%95%E3%82%8C%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E8%A3%8F%E5%88%87%E3%82%89%E3%82%8C%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E5%BF%98%E3%82%8C%E3%82%89%E3%82%8C%E3%81%AA%E3%81%84%E6%81%90%E6%80%96%E3%82%92%E4%BD%93%E9%A8%93%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E4%B8%A1%E8%A6%AA%E3%81%AB%E6%84%9B%E3%81%95%E3%82%8C%E3%81%A6%E8%82%B2%E3%81%A3%E3%81%9F',
    '%E8%AA%B0%E3%81%8B%E3%82%92%E6%95%91%E3%81%A3%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E6%9C%89%E5%90%8D%E4%BA%BA%E3%81%AE%E5%8F%8B%E9%81%94%E3%81%8C%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E5%A4%A7%E3%81%8D%E3%81%AA%E9%81%BA%E8%B7%A1%E3%82%92%E7%99%BA%E8%A6%8B%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E3%81%BE%E3%81%A0%E6%81%8B%E3%82%92%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%AA%E3%81%84',
    '%E6%95%85%E9%83%B7%E3%81%AE%E5%A0%B4%E6%89%80%E3%82%92%E7%9F%A5%E3%82%89%E3%81%AA%E3%81%84',
    '%E3%81%AE%E3%82%81%E3%82%8A%E8%BE%BC%E3%82%80%E8%B6%A3%E5%91%B3%E3%81%8C%E3%81%82%E3%82%8B',
    '%E6%89%8D%E8%83%BD%E3%82%92%E7%B5%B6%E8%B3%9B%E3%81%95%E3%82%8C%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E3%82%AC%E3%82%AD%E5%A4%A7%E5%B0%86%E3%81%A0%E3%81%A3%E3%81%9F',
    '%E7%A5%9E%E3%81%AE%E5%A3%B0%E3%82%92%E8%81%9E%E3%81%84%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B%EF%BC%88%E3%81%A8%E4%BF%A1%E3%81%98%E3%81%A6%E3%81%84%E3%82%8B%EF%BC%89',
    '%E6%BA%BA%E3%82%8C%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E4%BA%88%E7%9F%A5%E5%A4%A2%E3%82%92%E8%A6%8B%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E8%BA%AB%E4%BD%93%E3%81%AE%E3%81%A9%E3%81%93%E3%81%8B%E3%81%AB%E5%88%BA%E9%9D%92%E3%81%8C%E3%81%82%E3%82%8B',
    '%E8%A1%80%E7%B8%81%E8%80%85%E3%81%A8%E6%AD%BB%E5%88%A5%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E5%BD%B9%E3%81%AB%E7%AB%8B%E3%81%9F%E3%81%AA%E3%81%84%E7%9F%A5%E8%AD%98%E3%82%92%E6%8C%81%E3%81%A3%E3%81%A6%E3%81%84%E3%82%8B',
    '%E5%A4%A7%E3%81%8D%E3%81%AA%E5%A4%B1%E6%95%97%E3%82%92%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E5%B8%AB%E3%81%A8%E5%91%BC%E3%81%B9%E3%82%8B%E4%BA%BA%E7%89%A9%E3%81%8C%E3%81%84%E3%82%8B',
    '%E7%95%B0%E7%A8%AE%E6%97%8F%E3%81%AE%E5%8F%8B%E4%BA%BA%E3%81%8C%E3%81%84%E3%82%8B',
    '%E5%A4%A7%E5%88%87%E3%81%AA%E7%B4%84%E6%9D%9F%E3%82%92%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E5%A4%A7%E7%97%85%E3%82%92%E6%82%A3%E3%81%A3%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E3%81%8B%E3%81%A4%E3%81%A6%E4%BF%A1%E9%A0%BC%E3%81%A7%E3%81%8D%E3%82%8B%E5%8F%8B%E4%BA%BA%E3%81%8C%E3%81%84%E3%81%9F',
    '%E7%95%B0%E7%A8%AE%E6%97%8F%E3%81%AE%E8%A1%97%E3%81%A7%E8%82%B2%E3%81%A3%E3%81%9F',
    '%E5%90%8C%E3%81%98%E5%A4%A2%E3%82%92%E4%BD%95%E5%BA%A6%E3%82%82%E8%A6%8B%E3%81%A6%E3%81%84%E3%82%8B',
    '%E7%94%B0%E8%88%8E%E3%81%A7%E8%82%B2%E3%81%A3%E3%81%9F',
    '%E7%AB%B6%E3%81%84%E5%90%88%E3%81%86%E5%8F%8B%E4%BA%BA%E3%81%8C%E3%81%84%E3%81%9F',
    '%E9%AD%94%E7%89%A9%E3%81%AB%E8%A5%B2%E3%82%8F%E3%82%8C%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E6%9C%AC%E3%81%8B%E3%82%89%E5%A4%A7%E3%81%8D%E3%81%AA%E5%BD%B1%E9%9F%BF%E3%82%92%E5%8F%97%E3%81%91%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E5%91%8A%E7%99%BD%E3%81%95%E3%82%8C%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E4%BD%95%E3%81%8B%E3%81%AE%E5%A4%A7%E4%BC%9A%E3%81%A7%E5%84%AA%E5%8B%9D%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E8%BF%91%E6%89%80%E3%81%A7%E3%81%AF%E4%B8%80%E7%95%AA%E3%81%AE%E7%89%A9%E7%9F%A5%E3%82%8A%E3%81%A0%E3%81%A3%E3%81%9F',
    '%E5%BF%98%E3%82%8C%E3%82%89%E3%82%8C%E3%81%AA%E3%81%84%E3%81%BB%E3%81%A9%E7%BE%8E%E5%91%B3%E3%81%97%E3%81%84%E7%89%A9%E3%82%92%E7%9F%A5%E3%81%A3%E3%81%A6%E3%81%84%E3%82%8B',
    '%E5%B9%B4%E3%81%AE%E9%9B%A2%E3%82%8C%E3%81%9F%E5%8F%8B%E4%BA%BA%E3%81%8C%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E7%88%B6%E8%A6%AA%E3%81%8C%E6%97%85%E3%81%AB%E5%87%BA%E3%81%A6%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E5%95%86%E5%A3%B2%E3%82%92%E6%89%8B%E4%BC%9D%E3%81%A3%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E5%A4%A7%E3%82%B2%E3%83%B3%E3%82%AB%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E8%BF%91%E6%89%80%E3%81%AB%E8%8A%B8%E8%A1%93%E5%AE%B6%E3%81%8C%E4%BD%8F%E3%82%93%E3%81%A7%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E5%A4%A7%E5%88%87%E3%81%AA%E7%B4%84%E6%9D%9F%E3%82%92%E3%81%97%E3%81%A6%E3%81%84%E3%82%8B',
    '%E6%AF%92%E3%82%92%E9%A3%B2%E3%82%93%E3%81%A0%EF%BC%88%E9%A3%9F%E3%81%B9%E3%81%9F%EF%BC%89%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E7%9F%A5%E3%82%8A%E5%90%88%E3%81%84%E3%81%AB%E7%94%9F%E3%81%8D%E8%BF%94%E3%81%A3%E3%81%9F%E4%BA%BA%E3%81%8C%E3%81%84%E3%82%8B',
    '%E7%95%B0%E7%A8%AE%E6%97%8F%E3%82%92%E6%80%96%E3%81%8C%E3%81%A3%E3%81%A6%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E9%AD%94%E7%89%A9%E3%82%92%E5%80%92%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E5%A4%A7%E5%88%87%E3%81%AA%E4%BA%BA%E3%81%A8%E7%94%9F%E3%81%8D%E5%88%A5%E3%82%8C%E3%81%A6%E3%81%84%E3%82%8B',
    '%E5%BD%B9%E3%81%AB%E7%AB%8B%E3%81%9F%E3%81%AA%E3%81%84%E5%BE%97%E6%84%8F%E6%8A%80%E3%81%8C%E3%81%82%E3%82%8B',
    '%E9%81%8E%E5%8E%BB%E3%81%AB%E4%BB%95%E3%81%88%E3%81%9F%E4%B8%BB%E3%81%8C%E3%81%84%E3%81%9F',
    '%E7%B5%B6%E5%AF%BE%E3%81%AB%E7%9F%A5%E3%82%89%E3%82%8C%E3%81%9F%E3%81%8F%E3%81%AA%E3%81%84%E7%A7%98%E5%AF%86%E3%81%8C%E3%81%82%E3%82%8B',
    '%E6%81%A5%E3%81%9A%E3%81%8B%E3%81%97%E3%81%84%E7%99%96%E3%82%92%E6%8C%81%E3%81%A3%E3%81%A6%E3%81%84%E3%82%8B',
    '%E8%87%AA%E5%88%86%E3%81%AB%E3%81%9D%E3%81%A3%E3%81%8F%E3%82%8A%E3%81%AA%E4%BA%BA%E7%89%A9%E3%82%92%E7%9F%A5%E3%81%A3%E3%81%A6%E3%81%84%E3%82%8B',
    '%E5%91%BD%E3%82%92%E5%8A%A9%E3%81%91%E3%82%89%E3%82%8C%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E7%89%B9%E5%AE%9A%E3%81%AE%E7%95%B0%E7%A8%AE%E6%97%8F%E3%82%92%E5%A5%BD%E3%82%93%E3%81%A7%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E5%BC%95%E3%81%8D%E3%81%93%E3%82%82%E3%81%A3%E3%81%A6%E3%81%84%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E5%A7%8B%E3%81%BE%E3%82%8A%E3%81%AE%E5%89%A3%E3%82%92%E6%B1%82%E3%82%81%E3%81%A6%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E4%BC%B4%E4%BE%B6%E3%81%8C%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E6%95%B5%E5%AF%BE%E3%81%99%E3%82%8B%E8%80%85%E3%81%8C%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E7%9B%AE%E6%A8%99%E3%81%A8%E3%81%97%E3%81%A6%E3%81%84%E3%82%8B%E4%BA%BA%E3%81%8C%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E3%81%8B%E3%81%A4%E3%81%A6%E5%BE%93%E8%80%85%E3%81%8C%E3%81%84%E3%81%9F',
    '%E6%9C%AA%E3%81%A0%E5%8F%B6%E3%82%8F%E3%81%AA%E3%81%84%E5%A4%A2%E3%81%8C%E3%81%82%E3%82%8B',
    '%E7%B4%94%E6%BD%94%E3%81%A7%E3%81%82%E3%82%8B',
    '%E8%A6%8F%E5%BE%8B%E3%81%AB%E5%8E%B3%E3%81%97%E3%81%84%E7%92%B0%E5%A2%83%E3%81%A7%E8%82%B2%E3%81%A3%E3%81%9F',
    '%E5%AE%B6%E6%97%8F%E3%81%8B%E3%82%89%E6%8E%A2%E3%81%95%E3%82%8C%E3%81%A6%E3%81%84%E3%82%8B',
    '%E6%97%85%E3%82%92%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%AA%E3%81%84',
    '%E8%BA%AB%E4%BD%93%E3%81%AB%E5%82%B7%E7%97%95%E3%81%8C%E3%81%82%E3%82%8B',
    '%E5%8D%B5%E3%82%92%E6%B8%A9%E3%82%81%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E6%AD%8C%E3%82%92%E8%A4%92%E3%82%81%E3%82%89%E3%82%8C%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%AA%E3%81%84',
    '%E5%A4%A7%E3%81%8D%E3%81%AA%E5%98%98%E3%82%92%E3%81%A4%E3%81%84%E3%81%A6%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E5%A4%A7%E5%A5%BD%E3%81%8D%E3%81%AA%E9%A3%9F%E3%81%B9%E7%89%A9%E3%81%8C%E3%81%82%E3%82%8B%EF%BC%88%E3%81%82%E3%81%A3%E3%81%9F%EF%BC%89',
    '%E8%8B%A6%E6%89%8B%E3%81%AA%E5%8B%95%E7%89%A9%E3%81%8C%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E6%81%A5%E3%81%9A%E3%81%8B%E3%81%97%E3%81%84%E4%BA%8C%E3%81%A4%E5%90%8D%E3%82%92%E6%8C%81%E3%81%A3%E3%81%A6%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E8%87%AA%E6%85%A2%E3%81%AB%E5%87%BA%E6%9D%A5%E3%82%8B%E4%BA%8C%E3%81%A4%E5%90%8D%E3%82%92%E6%8C%81%E3%81%A3%E3%81%A6%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E5%B7%B1%E3%81%AB%E4%BD%95%E3%82%89%E3%81%8B%E3%81%AE%E8%AA%93%E3%82%92%E7%AB%8B%E3%81%A6%E3%81%A6%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E5%AE%B6%E6%97%8F%E3%81%AB%E9%AD%94%E6%B3%95%E4%BD%BF%E3%81%84%E3%81%8C%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E7%9B%A3%E7%A6%81%E3%81%95%E3%82%8C%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E3%80%8C%E8%B2%A0%E3%81%91%E3%81%9A%E5%AB%8C%E3%81%84%E3%80%8D%E3%81%A8%E8%A9%95%E3%81%95%E3%82%8C%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E5%86%92%E9%99%BA%E3%81%AB%E8%AA%98%E3%82%8F%E3%82%8C%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E6%BF%A1%E3%82%8C%E8%A1%A3%E3%82%92%E7%9D%80%E3%81%9B%E3%82%89%E3%82%8C%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E9%AB%98%E3%83%AC%E3%83%99%E3%83%AB%E3%81%AE%E9%AD%94%E6%B3%95%E3%82%92%E3%81%8B%E3%81%91%E3%82%89%E3%82%8C%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E7%89%A9%E5%BF%83%E3%81%8C%E3%81%A4%E3%81%84%E3%81%9F%E6%99%82%E3%81%AB%E3%81%AF%E7%8B%AC%E3%82%8A%E3%81%A0%E3%81%A3%E3%81%9F',
    '5%E4%BA%BA%E4%BB%A5%E4%B8%8A%E3%81%AE%E5%85%84%E5%BC%9F%E5%A7%89%E5%A6%B9%E3%81%8C%E3%81%84%E3%82%8B',
    '%E5%AE%B6%E6%97%8F%E3%81%AB%E5%86%92%E9%99%BA%E8%80%85%E3%81%8C%E3%81%84%E3%82%8B%EF%BC%88%E3%81%84%E3%81%9F%EF%BC%89',
    '%E9%AD%94%E5%89%A3%E3%81%AE%E8%BF%B7%E5%AE%AE%E3%81%A7%E8%BF%B7%E5%AD%90%E3%81%AB%E3%81%AA%E3%81%A3%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E5%90%8C%E6%80%A7%E3%81%AE%E5%AE%B6%E6%97%8F%E3%81%8C%E3%81%84%E3%81%AA%E3%81%84',
    '%E7%95%B0%E6%80%A7%E3%81%AE%E5%AE%B6%E6%97%8F%E3%81%8C%E3%81%84%E3%81%AA%E3%81%84',
    '%E5%AE%88%E3%82%8A%E3%81%AE%E5%89%A3%E3%82%92%E6%89%8B%E3%81%AB%E6%8C%81%E3%81%A3%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E4%B8%80%E6%89%80%E3%81%AB5%E6%97%A5%E4%BB%A5%E4%B8%8A%E6%BB%9E%E5%9C%A8%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%AA%E3%81%84',
    '%E5%9B%BD%E7%8E%8B%E3%81%AB%E4%BC%9A%E3%81%A3%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E7%A9%BA%E8%85%B9%E3%81%AE%E3%81%82%E3%81%BE%E3%82%8A%E3%81%AB%E5%A4%B1%E7%A5%9E%E3%81%97%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E9%A3%9B%E7%A9%BA%E8%89%87%E3%81%AB%E4%B9%97%E3%81%A3%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E8%87%AA%E6%AE%BA%E3%82%92%E8%A9%A6%E3%81%BF%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    
    '%e9%ad%94%e7%a5%9e%e3%82%92%e8%a6%8b%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e9%ad%94%e7%a5%9e%e3%81%ae%e7%94%9f%e3%81%91%e8%b4%84%e3%81%ab%e3%81%95%e3%82%8c%e3%81%9f%ef%bc%88%e3%81%95%e3%82%8c%e3%81%9d%e3%81%86%e3%81%ab%e3%81%aa%e3%81%a3%e3%81%9f%ef%bc%89%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e5%a6%96%e7%b2%be%e3%81%a8%e5%8f%8b%e9%81%94%e3%81%a0%e3%81%a3%e3%81%9f',
    '%e5%a4%a7%e3%81%8d%e3%81%aa%e5%8b%98%e9%81%95%e3%81%84%e3%82%92%e3%81%97%e3%81%a6%e3%81%84%e3%82%8b%ef%bc%88%e3%81%97%e3%81%a6%e3%81%84%e3%81%9f%ef%bc%89',
    '%e8%98%87%e3%81%a3%e3%81%9f%e6%ad%bb%e8%80%85%e3%82%92%e3%81%bf%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e6%ad%bb%e8%80%85%e3%81%a8%e4%bc%9a%e8%a9%b1%e3%81%97%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e3%81%8b%e3%81%a4%e3%81%a6%e5%a4%a7%e5%ab%8c%e3%81%84%e3%81%a0%e3%81%a3%e3%81%9f%e3%82%82%e3%81%ae%e3%81%8c%e4%bb%8a%e3%81%af%e5%a4%a7%e5%a5%bd%e3%81%8d',
    '%e3%81%8b%e3%81%a4%e3%81%a6%e5%a4%a7%e5%a5%bd%e3%81%8d%e3%81%a0%e3%81%a3%e3%81%9f%e3%82%82%e3%81%ae%e3%81%8c%e4%bb%8a%e3%81%af%e5%a4%a7%e5%ab%8c%e3%81%84',
    '%e6%b1%82%e5%a9%9a%e3%81%95%e3%82%8c%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e6%80%a7%e5%88%a5%e3%82%92%e9%96%93%e9%81%95%e3%82%8f%e3%82%8c%e3%81%a6%e3%81%84%e3%82%8b%e6%9c%9f%e9%96%93%e3%81%8c%e3%81%82%e3%81%a3%e3%81%9f',
    '%e8%9b%ae%e6%97%8f%e3%81%a8%e9%96%93%e9%81%95%e3%82%8f%e3%82%8c%e3%81%a6%e3%81%84%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e6%ad%bb%e3%82%92%e6%81%90%e3%82%8c%e3%81%a6%e3%81%84%e3%81%aa%e3%81%84%ef%bc%88%e6%81%90%e3%82%8c%e3%81%a6%e3%81%84%e3%81%aa%e3%81%8b%e3%81%a3%e3%81%9f%ef%bc%89',
    '5%e3%81%a4%e4%bb%a5%e4%b8%8a%e3%81%ae%e5%9c%b0%e6%96%b9%e3%81%ab%e8%a1%8c%e3%81%a3%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e6%9c%89%e5%90%8d%e4%ba%ba%e3%81%8b%e3%82%89%e8%a4%92%e3%82%81%e3%82%89%e3%82%8c%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e6%9c%89%e5%90%8d%e4%ba%ba%e3%81%8b%e3%82%89%e8%b2%b6%e3%81%95%e3%82%8c%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e8%87%aa%e5%88%86%e3%81%ae%e3%83%a2%e3%83%8e%e3%81%a7%e3%81%af%e3%81%aa%e3%81%84%e8%a8%98%e6%86%b6%e3%81%8c%e3%81%82%e3%82%8b',
    '%e7%89%b9%e5%ae%9a%e3%81%ae%e8%89%b2%e3%81%ab%e5%bc%b7%e3%81%84%e6%80%9d%e3%81%84%e5%85%a5%e3%82%8c%e3%81%8c%e3%81%82%e3%82%8b%ef%bc%88%e3%81%82%e3%81%a3%e3%81%9f%ef%bc%89',
    '%e7%89%b9%e5%ae%9a%e3%81%ae%e8%89%b2%e3%82%92%e6%bf%80%e3%81%97%e3%81%8f%e5%ab%8c%e3%81%a3%e3%81%a6%e3%81%84%e3%82%8b%ef%bc%88%e5%ab%8c%e3%81%a3%e3%81%a6%e3%81%84%e3%81%9f%ef%bc%89',
    '%e6%b4%be%e6%89%8b%e3%81%aa%e8%a6%8b%e6%a0%84%e3%82%92%e5%bc%b5%e3%81%a3%e3%81%a6%e3%81%84%e3%82%8b%ef%bc%88%e5%bc%b5%e3%81%a3%e3%81%a6%e3%81%84%e3%81%9f%ef%bc%89',
    '%e3%81%b2%e3%81%bf%e3%81%a4%e5%9f%ba%e5%9c%b0%e3%82%92%e6%8c%81%e3%81%a3%e3%81%a6%e3%81%84%e3%82%8b%ef%bc%88%e6%8c%81%e3%81%a3%e3%81%a6%e3%81%84%e3%81%9f%ef%bc%89',
    '%e4%bb%8a%e3%81%a7%e3%82%82%e4%bd%bf%e3%81%86%e6%b1%ba%e3%82%81%e3%83%9d%e3%83%bc%e3%82%ba%e3%82%92%e6%8c%81%e3%81%a3%e3%81%a6%e3%81%84%e3%82%8b',
    '%e4%bb%8a%e3%81%a7%e3%82%82%e4%bd%bf%e3%81%86%e6%b1%ba%e3%82%81%e5%8f%b0%e8%a9%9e%e3%82%92%e6%8c%81%e3%81%a3%e3%81%a6%e3%81%84%e3%82%8b',
    '%e7%95%b0%e6%80%a7%e3%82%92%e5%8f%a3%e8%aa%ac%e3%81%8f%e3%81%ae%e3%81%8c%e5%a5%bd%e3%81%8d',
    '%e3%81%82%e3%82%8b%e5%9b%a3%e4%bd%93%e3%81%ae%e4%bb%a3%e8%a1%a8%e3%81%a0%e3%81%a3%e3%81%9f',
    '%e9%95%b7%e3%81%84%e8%88%b9%e6%97%85%e3%82%92%e3%81%97%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e7%a5%9e%e5%99%a8%e3%82%92%e8%a6%8b%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e7%a5%9e%e3%81%ab%e5%85%a5%e4%bf%a1%e3%82%92%e8%bf%ab%e3%82%89%e3%82%8c%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e5%bc%b1%e3%81%bf%e3%82%92%e6%8f%a1%e3%82%89%e3%82%8c%e3%81%a6%e3%81%84%e3%82%8b%ef%bc%88%e3%81%84%e3%81%9f%ef%bc%89',
    '%e6%b1%ba%e3%81%97%e3%81%a6%e5%8f%b6%e3%82%8f%e3%81%aa%e3%81%84%e9%a1%98%e3%81%84%e3%81%8c%e3%81%82%e3%82%8b',
    '%e9%8a%83%e3%81%a7%e6%92%83%e3%81%9f%e3%82%8c%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e7%a9%ba%e3%82%92%e9%a3%9b%e3%82%93%e3%81%a0%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e6%84%9b%e8%aa%ad%e6%9b%b8%e3%82%92%e6%8c%81%e3%81%a1%e6%ad%a9%e3%81%84%e3%81%a6%e3%81%84%e3%82%8b%ef%bc%88%e3%81%84%e3%81%9f%ef%bc%89',
    '%e6%9b%b8%e3%81%8d%e5%87%ba%e3%81%97%e9%83%a8%e5%88%86%e3%82%92%e6%9a%97%e5%94%b1%e3%81%a7%e3%81%8d%e3%82%8b%e6%9b%b8%e7%89%a9%e3%81%8c%e3%81%84%e3%81%8f%e3%81%a4%e3%81%8b%e3%81%82%e3%82%8b%e3%80%82',
    '%e5%90%8d%e8%aa%89%e3%82%92%e5%a4%b1%e3%81%a3%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e6%a3%b2%e3%81%bf%e3%81%8b%e3%81%8c%e7%87%83%e3%81%88%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e6%81%8b%e4%ba%ba%e3%81%ae%ef%bc%88%e6%81%8b%e4%ba%ba%e3%81%a0%e3%81%a3%e3%81%9f%e4%ba%ba%e3%81%ae%ef%bc%89%e5%a4%a7%e5%88%87%e3%81%aa%e3%82%82%e3%81%ae%e3%82%92%e6%8c%81%e3%81%a6%e3%81%84%e3%82%8b',
  );
  my @result;
  if($quant > 5) { $quant = 5; }
  for (my $i=0; $i < $quant; $i++) {
    my $number = int(rand(@line));
    if (!$line[$number]) { $i--; }
    else {
      push(@result, dice_deco($line[$number]));
      $line[$number] = '';
    }
  }
  return "<span style=\"color:$color_hisA;font-size:83%;\">「".join('」「',@result).'」</span>';
}

sub sw2_historyBT {
  my $quant = $_[0];
  $quant = 1 if(!$quant);
  my @line = (
    '%E4%BA%BA%E6%97%8F%E3%81%AB%E6%8B%BE%E3%82%8F%E3%82%8C%E3%81%9F',
    '%E8%A6%AA%E3%81%AB%E6%8D%A8%E3%81%A6%E3%82%89%E3%82%8C%E3%81%9F',
    '%E7%BD%AA%E3%82%92%E7%8A%AF%E3%81%97%E3%81%A6%E8%BF%BD%E6%94%BE%E3%81%95%E3%82%8C%E3%81%9F',
    '%E5%84%AA%E3%81%97%E3%81%95%E3%81%AB%E7%9B%AE%E8%A6%9A%E3%82%81%E3%81%9F',
    '%E7%AC%AC%E4%B8%80%E3%81%AE%E7%A5%9E%E3%81%AE%E5%A3%B0%E3%81%8C%E8%81%9E%E3%81%93%E3%81%88%E3%81%9F',
    '%E5%90%8C%E6%97%8F%E3%81%AB%E9%A6%B4%E6%9F%93%E3%82%81%E3%81%AA%E3%81%84%E7%89%B9%E5%BE%B4%E3%81%8C%E3%81%82%E3%81%A3%E3%81%9F',
    '%E5%B9%BC%E5%B0%91%E6%99%82%E3%80%81%E8%BA%AB%E4%BD%93%E8%83%BD%E5%8A%9B%E3%81%8C%E8%91%97%E3%81%97%E3%81%8F%E5%8A%A3%E3%81%A3%E3%81%A6%E3%81%84%E3%81%9F',
    '%E4%BA%BA%E6%97%8F%E3%81%AE%E7%94%9F%E3%81%8D%E6%96%B9%E3%81%AB%E6%84%9F%E9%8A%98%E3%82%92%E5%8F%97%E3%81%91%E3%81%9F',
    '%E6%AE%BA%E6%88%AE%E3%81%AB%E9%A3%BD%E3%81%8D%E3%81%9F',
    '%E6%88%A6%E5%A0%B4%E3%81%AB%E7%BD%AE%E3%81%8D%E5%8E%BB%E3%82%8A%E3%81%AB%E3%81%95%E3%82%8C%E3%81%9F',
    '%E4%BA%BA%E6%97%8F%E3%81%AE%E6%96%87%E5%8C%96%E3%81%8C%E5%A5%BD%E3%81%8D',
    '%E7%89%87%E8%A6%AA%E3%80%81%E3%81%82%E3%82%8B%E3%81%84%E3%81%AF%E5%85%88%E7%A5%96%E3%81%8C%E4%BA%BA%E6%97%8F',
    '%E4%BA%BA%E6%97%8F%E3%81%A8%E3%81%97%E3%81%A6%E8%82%B2%E3%81%A6%E3%82%89%E3%82%8C%E3%81%9F',
    '%E4%B8%80%E6%97%8F%E3%81%AB%E8%BF%BD%E3%82%8F%E3%82%8C%E3%81%A6%E3%81%84%E3%82%8B',
    '%E7%89%B9%E5%AE%9A%E3%81%AE%E7%9B%B8%E6%89%8B%E3%81%AB%E6%81%A8%E3%81%BF%E3%82%92%E3%81%8B%E3%81%A3%E3%81%A6%E3%81%84%E3%82%8B',
    '%E4%BA%BA%E6%97%8F%E3%81%AE%E9%96%93%E3%81%A7%E6%9C%89%E5%90%8D',
    '%E4%BA%BA%E6%97%8F%E3%82%92%E5%8A%A9%E3%81%91%E3%81%9F%E3%81%93%E3%81%A8%E3%81%8C%E3%81%82%E3%82%8B',
    '%E4%BA%BA%E6%97%8F%E3%81%AB%E6%81%A9%E3%81%8C%E3%81%82%E3%82%8B',
    '%E4%BA%BA%E6%97%8F%E3%81%AB%E4%B8%80%E7%9B%AE%E7%BD%AE%E3%81%8B%E3%82%8C%E3%81%A6%E3%81%84%E3%82%8B',
    '%E4%B8%80%E6%97%8F%E3%81%8C%E6%98%94%E3%81%8B%E3%82%89%E4%BA%BA%E6%97%8F%E3%81%A8%E4%BB%B2%E8%89%AF%E3%81%97',
    '%E4%BA%BA%E6%97%8F%E3%81%AB%E6%87%90%E6%9F%94%EF%BC%88%E8%B2%B7%E5%8F%8E%EF%BC%89%E3%81%95%E3%82%8C%E3%81%9F',
    '%E8%9B%AE%E6%97%8F%E3%81%AE%E3%82%B9%E3%83%91%E3%82%A4%E3%81%A7%E3%81%82%E3%82%8B',
    '%E6%AD%A6%E8%80%85%E4%BF%AE%E8%A1%8C%E3%81%AE%E3%81%9F%E3%82%81%E3%81%AB%E4%BA%BA%E6%97%8F%E7%A4%BE%E4%BC%9A%E3%81%B8%E6%9D%A5%E3%81%9F',
    '%E8%B2%A7%E5%BC%B1%E3%81%AA%E4%BA%BA%E6%97%8F%E8%BB%8D%E3%82%88%E3%82%8A%E3%80%81%E8%9B%AE%E6%97%8F%E8%BB%8D%E3%81%A8%E6%88%A6%E3%81%84%E3%81%9F%E3%81%84',
    '%E8%A8%98%E6%86%B6%E3%81%8C%E3%81%AA%E3%81%84',
    '%E4%BA%BA%E6%97%8F%E3%81%AE%E8%A6%AA%E3%81%8B%E3%82%89%E7%94%9F%E3%81%BE%E3%82%8C%E3%81%9F%E5%85%88%E7%A5%96%E3%81%8C%E3%81%88%E3%82%8A',
    '%E4%BA%BA%E6%97%8F%E3%81%AB%E6%81%8B%E3%82%92%E3%81%97%E3%81%9F',
    '%E8%9B%AE%E6%97%8F%E3%81%AB%E5%BF%98%E3%82%8C%E3%82%89%E3%82%8C%E3%81%AA%E3%81%84%E5%82%B7%E3%82%92%E3%81%A4%E3%81%91%E3%82%89%E3%82%8C%E3%81%9F',
    '%E5%89%B5%E9%80%A0%E6%80%A7%E3%81%AB%E7%9B%AE%E8%A6%9A%E3%82%81%E3%81%9F',
    '%E4%BA%BA%E6%97%8F%E7%A0%94%E7%A9%B6%E3%82%92%E3%81%97%E3%81%A6%E3%81%84%E3%82%8B%EF%BC%8F%E3%81%84%E3%81%9F',
    '%E4%BA%BA%E6%97%8F%E3%81%AB%E5%BC%B1%E3%81%BF%E3%82%92%E6%8F%A1%E3%82%89%E3%82%8C%E3%81%A6%E3%81%84%E3%82%8B',
    '%E6%83%85%E3%81%AB%E3%81%BB%E3%81%A0%E3%81%95%E3%82%8C%E3%81%9F',
    '%E4%BA%BA%E6%97%8F%E3%81%AB%E6%86%A7%E3%82%8C%E3%81%A6%E3%81%84%E3%82%8B%EF%BC%88%E3%81%AA%E3%82%8A%E3%81%9F%E3%81%84%EF%BC%89',
    '%E4%BA%BA%E6%97%8F%E3%81%AE%E6%8D%95%E8%99%9C%E3%81%AB%E3%81%95%E3%82%8C%E3%81%A6%E3%81%84%E3%82%8B%EF%BC%8F%E3%81%84%E3%81%9F',
    '%E4%BA%BA%E8%82%89%E3%81%8C%E9%A3%9F%E3%81%B9%E3%82%89%E3%82%8C%E3%81%AA%E3%81%84',
    '%E8%9B%AE%E6%97%8F%E3%81%AE%E5%B0%86%E6%9D%A5%E3%82%92%E6%82%B2%E8%A6%B3%E3%81%97%E3%81%A6%E3%81%84%E3%82%8B',
    
    '%e8%9b%ae%e6%97%8f%e3%81%ae%e5%90%8d%e8%aa%89%e3%82%92%e6%b1%9a%e3%81%95%e3%82%8c%e3%81%9f',
    '%e8%a8%b1%e3%81%9b%e3%81%aa%e3%81%84%e8%9b%ae%e6%97%8f%e3%81%8c%e3%81%84%e3%82%8b',
    '%e4%ba%ba%e6%97%8f%e3%81%ab%e8%b2%a0%e3%81%91%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e4%b8%80%e6%97%8f%e3%82%92%e6%bb%85%e3%81%bc%e3%81%95%e3%82%8c%e3%81%9f',
    '%e5%ae%88%e3%82%8a%e3%81%ae%e5%89%a3%e3%81%ae%e5%bd%b1%e9%9f%bf%e3%82%92%e5%8f%97%e3%81%91%e3%82%8b%e3%81%a8%e3%83%8f%e3%82%a4%e3%81%ab%e3%81%aa%e3%82%8b',
    '%e4%ba%ba%e6%97%8f%e3%82%92%e5%ba%87%e8%ad%b7%e5%af%be%e8%b1%a1%e3%81%a8%e3%81%97%e3%81%a6%e8%80%83%e3%81%88%e3%81%a6%e3%81%84%e3%82%8b',
    '%e4%ba%ba%e6%97%8f%e3%81%ae%e6%96%87%e5%8c%96%e3%82%92%e5%b4%87%e6%8b%9d%e3%81%97%e3%81%a6%e3%81%84%e3%82%8b',
    '%e7%ac%ac%e4%b8%89%e3%81%ae%e5%89%a3%e3%81%ae%e7%a5%9e%e3%81%ab%e5%85%a5%e4%bf%a1%e3%82%92%e8%bf%ab%e3%82%89%e3%82%8c%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e4%ba%ba%e6%97%8f%e3%82%92%e6%81%8b%e6%84%9b%e3%81%ae%e5%af%be%e8%b1%a1%e3%81%ab%e3%81%97%e3%81%a6%e3%81%84%e3%82%8b',
    '%e4%ba%ba%e6%97%8f%e3%81%ae%e7%89%b9%e5%ae%9a%e3%81%ae%e7%a8%ae%e6%97%8f%e3%82%92%e5%a5%bd%e3%82%93%e3%81%a7%e3%81%84%e3%82%8b',
    '%e4%ba%ba%e6%97%8f%e3%81%a8%e5%a4%a7%e5%88%87%e3%81%aa%e7%b4%84%e6%9d%9f%e3%82%92%e3%81%97%e3%81%a6%e3%81%84%e3%82%8b',
    '%e4%ba%ba%e6%97%8f%e3%81%ae%e7%8e%8b%e3%81%ab%e4%bb%95%e3%81%88%e3%81%a6%e3%81%84%e3%82%8b',
    '%e4%ba%ba%e6%97%8f%e3%81%a0%e3%81%a3%e3%81%9f%e5%89%8d%e4%b8%96%e3%81%ae%e8%a8%98%e6%86%b6%e3%81%8c%e3%81%82%e3%82%8b',
    '%e5%90%8c%e8%83%9e%e3%82%92%e5%82%b7%e3%81%a4%e3%81%91%e3%81%a6%e3%81%97%e3%81%be%e3%81%a3%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e5%90%8c%e8%83%9e%e3%81%ab%e5%ae%b6%e6%97%8f%e3%82%92%e5%82%b7%e3%81%a4%e3%81%91%e3%82%89%e3%82%8c%e3%81%9f',
    '%e4%ba%ba%e6%97%8f%e3%81%ab%e3%81%8f%e3%81%a0%e3%82%89%e3%81%aa%e3%81%84%e8%b3%ad%e3%81%91%e4%ba%8b%e3%81%a7%e8%b2%a0%e3%81%91%e3%81%a6%e3%81%97%e3%81%be%e3%81%a3%e3%81%9f',
    '%e4%ba%ba%e6%97%8f%e3%81%ae%e5%91%bd%e3%82%92%e5%8a%a9%e3%81%91%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e4%ba%ba%e6%97%8f%e3%81%ae%e5%88%a9%e7%9b%8a%e3%81%ab%e3%81%aa%e3%82%8b%e3%81%93%e3%81%a8%e3%82%92%e3%81%97%e3%81%a6%e3%81%84%e3%82%8b%ef%bc%88%e3%81%97%e3%81%a6%e3%81%84%e3%81%9f%ef%bc%89',
    '%e4%ba%ba%e6%97%8f%e3%81%ae%e7%a0%94%e7%a9%b6%e6%9d%90%e6%96%99%e3%81%ab%e3%81%aa%e3%81%a3%e3%81%a6%e3%81%84%e3%82%8b%ef%bc%88%e3%81%aa%e3%81%a3%e3%81%a6%e3%81%84%e3%81%9f%ef%bc%89',
    '%e8%9b%ae%e6%97%8f%e3%81%ae%e4%b8%ad%e3%81%ae%e7%89%b9%e5%ae%9a%e3%81%ae%e7%a8%ae%e6%97%8f%e3%81%8c%e5%ab%8c%e3%81%84',
    '%e5%a7%8b%e3%81%be%e3%82%8a%e3%81%ae%e5%89%a3%e3%82%92%e6%8e%a2%e3%81%97%e3%81%a6%e3%81%84%e3%82%8b',
    '%e5%a7%8b%e3%81%be%e3%82%8a%e3%81%ae%e5%89%a3%e3%81%ab%e8%a7%a6%e3%82%8c%e3%81%9f%e3%81%93%e3%81%a8%e3%81%8c%e3%81%82%e3%82%8b',
    '%e4%ba%ba%e6%97%8f%e3%81%ae%e9%85%8d%e4%b8%8b%e3%81%8c%e3%81%84%e3%82%8b%ef%bc%88%e3%81%84%e3%81%9f%ef%bc%89',
    '%e4%ba%ba%e6%97%8f%e3%81%a8%e8%9b%ae%e6%97%8f%e3%81%ae%e9%81%95%e3%81%84%e3%81%8c%e3%82%88%e3%81%8f%e5%88%86%e3%81%8b%e3%82%89%e3%81%aa%e3%81%84',
    '%e4%ba%ba%e6%97%8f%e3%81%a8%e8%9b%ae%e6%97%8f%e3%81%ae%e4%ba%89%e3%81%84%e3%82%92%e6%ad%a2%e3%82%81%e3%82%88%e3%81%86%e3%81%a8%e3%81%97%e3%81%a6%e3%81%84%e3%82%8b%ef%bc%88%e3%81%84%e3%81%9f%ef%bc%89',
    '%e4%ba%ba%e6%97%8f%e3%81%ab%e3%81%aa%e3%82%8b%e3%81%93%e3%81%a8%e3%82%92%e5%a4%a2%e8%a6%8b%e3%81%a6%e3%81%84%e3%82%8b',
    '%e5%90%8c%e8%83%9e%e3%80%81%e3%82%82%e3%81%97%e3%81%8f%e3%81%af%e6%81%8b%e4%ba%ba%e3%81%8c%e4%ba%ba%e6%97%8f%e3%82%92%e5%a5%bd%e3%82%93%e3%81%a7%e3%81%84%e3%82%8b',
    '%e5%bc%b7%e5%a4%a7%e3%81%aa%e6%95%b5%e3%81%ae%e6%b0%97%e9%85%8d%e3%82%92%e6%84%9f%e3%81%98%e3%81%a6%e3%81%84%e3%82%8b%ef%bc%88%e3%81%84%e3%81%9f%ef%bc%89',
    '%e9%ad%94%e7%a5%9e%e3%82%92%e5%8d%b1%e9%99%ba%e8%a6%96%e3%81%97%e3%81%a6%e3%81%84%e3%82%8b',
    '%e5%a6%96%e7%b2%be%e3%82%92%e5%8d%b1%e9%99%ba%e8%a6%96%e3%81%97%e3%81%a6%e3%81%84%e3%82%8b',
    '%e8%81%b7%e4%ba%ba%e3%82%92%e7%9b%ae%e6%8c%87%e3%81%97%e3%81%a6%e3%81%84%e3%82%8b%ef%bc%88%e3%81%84%e3%81%9f%ef%bc%89',
    '%e5%95%86%e4%ba%ba%e3%82%92%e7%9b%ae%e6%8c%87%e3%81%97%e3%81%a6%e3%81%84%e3%82%8b%ef%bc%88%e3%81%84%e3%81%9f%ef%bc%89',
    '%e4%ba%ba%e6%97%8f%e3%81%ae%e6%ad%b4%e5%8f%b2%e3%81%ab%e8%88%88%e5%91%b3%e3%81%8c%e3%81%82%e3%82%8b',
    '%e4%ba%ba%e6%97%8f%e3%81%ae%e7%a4%be%e4%bc%9a%e6%a7%8b%e9%80%a0%e3%81%ab%e8%88%88%e5%91%b3%e3%81%8c%e3%81%82%e3%82%8b',
    '%e4%ba%ba%e6%97%8f%e3%81%8c%e8%9b%ae%e6%97%8f%e3%81%ab%e5%8b%9d%e5%88%a9%e3%81%99%e3%82%8b%e3%81%a8%e6%80%9d%e3%81%a3%e3%81%a6%e3%81%84%e3%82%8b',
    '%e4%ba%ba%e6%97%8f%e3%81%ab%e5%b8%8c%e6%9c%9b%e3%82%92%e6%8c%81%e3%81%a3%e3%81%a6%e3%81%84%e3%82%8b',
  );
  my @result;
  if($quant > 5) { $quant = 5; }
  for (my $i=0; $i < $quant; $i++) {
    my $number = int(rand(@line));
    if (!$line[$number]) { $i--; }
    else {
      push(@result, dice_deco($line[$number]));
      $line[$number] = '';
    }
  }
  return '<span style="color:'.$color_hisB.';font-size:83%;">「'.join('」「',@result).'」</span>';
}

sub sw2_job {
  my $quant = $_[0];
  $quant = 1 if(!$quant);
  my @line = (
    '%E9%98%B2%E5%85%B7%E8%81%B7%E4%BA%BA%EF%BC%8F%E3%82%A2%E3%83%BC%E3%83%9E%E3%83%A9%E3%83%BC',
    '%E7%99%BA%E6%98%8E%E5%AE%B6%EF%BC%8F%E3%82%A4%E3%83%B3%E3%83%99%E3%83%B3%E3%82%BF%E3%83%BC',
    '%E7%B9%94%E3%82%8A%E5%AD%90%EF%BC%8F%E3%82%A6%E3%82%A3%E3%83%BC%E3%83%90%E3%83%BC',
    '%E7%A5%88%E7%A5%B7%E5%B8%AB%EF%BC%8F%E3%82%A6%E3%82%A3%E3%83%83%E3%83%81%E3%83%89%E3%82%AF%E3%82%BF%E3%83%BC',
    '%E7%B5%A6%E4%BB%95%EF%BC%8F%E3%82%A6%E3%82%A7%E3%82%A4%E3%82%BF%E3%83%BC%E3%83%BB%E3%82%A6%E3%82%A7%E3%82%A4%E3%83%88%E3%83%AC%E3%82%B9',
    '%E5%A4%A9%E5%80%99%E4%BA%88%E5%A0%B1%E5%A3%AB%EF%BC%8F%E3%82%A6%E3%82%A7%E3%82%B6%E3%83%BC%E3%83%9E%E3%83%B3',
    '%E6%AD%A6%E5%99%A8%E8%81%B7%E4%BA%BA%EF%BC%8F%E3%82%A6%E3%82%A7%E3%83%9D%E3%83%B3%E3%82%B9%E3%83%9F%E3%82%B9',
    '%E6%9C%A8%E5%B7%A5%E8%81%B7%E4%BA%BA%EF%BC%8F%E3%82%A6%E3%83%83%E3%83%89%E3%82%AF%E3%83%A9%E3%83%95%E3%83%88%E3%83%9E%E3%83%B3',
    '%E4%BB%98%E4%B8%8E%E8%A1%93%E5%B8%AB%EF%BC%8F%E3%82%A8%E3%83%B3%E3%83%81%E3%83%A3%E3%83%B3%E3%82%BF%E3%83%BC',
    '%E4%BD%9C%E5%AE%B6%EF%BC%8F%E3%82%AA%E3%83%BC%E3%82%B5%E3%83%BC',
    '%E5%BD%B9%E4%BA%BA%EF%BC%8F%E3%82%AA%E3%83%95%E3%82%A3%E3%82%B7%E3%83%A3%E3%83%AB',
    '%E5%A4%A7%E5%B7%A5%EF%BC%8F%E3%82%AB%E3%83%BC%E3%83%9A%E3%83%B3%E3%82%BF%E3%83%BC',
    '%E7%B5%B5%E5%85%B7%E5%B8%AB%EF%BC%8F%E3%82%AB%E3%83%A9%E3%83%BC%E3%83%9E%E3%83%B3',
    '%E5%BA%AD%E5%B8%AB%EF%BC%8F%E3%82%AC%E3%83%BC%E3%83%87%E3%83%8A%E3%83%BC',
    '%E9%8D%B5%E5%B1%8B%EF%BC%8F%E3%82%AD%E3%83%BC%E3%82%B9%E3%83%9F%E3%82%B9',
    '%E8%81%96%E8%81%B7%E8%80%85%EF%BC%8F%E3%82%AF%E3%83%AC%E3%83%AA%E3%83%83%E3%82%AF',
    '%E5%A2%93%E5%AE%88%EF%BC%8F%E3%82%B0%E3%83%AC%E3%82%A4%E3%83%96%E3%82%AD%E3%83%BC%E3%83%91%E3%83%BC',
    '%E5%BE%A1%E8%80%85%EF%BC%8F%E3%82%B3%E3%83%BC%E3%83%81%E3%83%9E%E3%83%B3',
    '%E9%AB%98%E7%B4%9A%E5%A8%BC%E5%A9%A6%E3%83%BB%E7%94%B7%E5%A8%BC%EF%BC%8F%E3%82%B3%E3%83%BC%E3%83%86%E3%82%A3%E3%82%B6%E3%83%B3',
    '%E6%96%99%E7%90%86%E4%BA%BA%EF%BC%8F%E3%82%B3%E3%83%83%E3%82%AF',
    '%E4%BD%9C%E6%9B%B2%E5%AE%B6%EF%BC%8F%E3%82%B3%E3%83%B3%E3%83%9D%E3%83%BC%E3%82%B6%E3%83%BC',
    '%E5%A4%96%E7%A7%91%E5%8C%BB%EF%BC%8F%E3%82%B5%E3%83%BC%E3%82%B8%E3%83%A7%E3%83%B3',
    '%E9%9D%B4%E8%81%B7%E4%BA%BA%EF%BC%8F%E3%82%B7%E3%83%A5%E3%83%BC%E3%83%A1%E3%82%A4%E3%82%AB%E3%83%BC',
    '%E6%AD%8C%E6%89%8B%EF%BC%8F%E3%82%B7%E3%83%B3%E3%82%AC%E3%83%BC',
    '%E5%AE%9D%E9%A3%BE%E5%B8%AB%EF%BC%8F%E3%82%B8%E3%83%A5%E3%82%A8%E3%83%A9%E3%83%BC',
    '%E5%AD%A6%E7%94%9F%E3%83%BB%E5%AD%A6%E8%80%85%EF%BC%8F%E3%82%B9%E3%82%AB%E3%83%A9%E3%83%BC',
    '%E5%BD%AB%E5%88%BB%E5%AE%B6%EF%BC%8F%E3%82%B9%E3%82%AB%E3%83%AB%E3%83%97%E3%82%BF%E3%83%BC',
    '%E7%AD%86%E8%80%85%E4%BA%BA%EF%BC%8F%E3%82%B9%E3%82%AF%E3%83%A9%E3%82%A4%E3%83%96',
    '%E6%B0%B4%E5%A4%AB%EF%BC%8F%E3%82%BB%E3%82%A4%E3%83%A9%E3%83%BC',
    '%E5%85%B5%E5%A3%AB%EF%BC%8F%E3%82%BD%E3%83%AB%E3%82%B8%E3%83%A3%E3%83%BC',
    '%E9%AB%98%E6%89%80%E4%BD%9C%E6%A5%AD%E5%93%A1%EF%BC%8F%E3%82%BF%E3%83%AF%E3%83%BC%E3%83%9E%E3%83%B3',
    '%E8%B8%8A%E3%82%8A%E5%AD%90%EF%BC%8F%E3%83%80%E3%83%B3%E3%82%B5%E3%83%BC',
    '%E8%AA%BF%E6%95%99%E5%B8%AB%EF%BC%8F%E3%83%86%E3%82%A4%E3%83%9E%E3%83%BC',
    '%E4%BB%95%E7%AB%8B%E3%81%A6%E5%B1%8B%EF%BC%8F%E3%83%86%E3%82%A4%E3%83%A9%E3%83%BC',
    '%EF%BC%88%E8%92%B8%E7%95%99%EF%BC%89%E9%85%92%E9%80%A0%E5%AE%B6%EF%BC%8F%E3%83%87%E3%82%A3%E3%82%B9%E3%83%86%E3%82%A3%E3%83%A9%E3%83%BC',
    '%E5%8C%BB%E8%80%85%EF%BC%8F%E3%83%89%E3%82%AF%E3%82%BF%E3%83%BC',
    '%E8%96%AC%E5%89%A4%E5%B8%AB%EF%BC%8F%E3%83%89%E3%83%A9%E3%83%83%E3%82%B0%E3%83%A1%E3%82%A4%E3%82%AB%E3%83%BC',
    '%E7%9C%8B%E8%AD%B7%E5%B8%AB%EF%BC%8F%E3%83%8A%E3%83%BC%E3%82%B9',
    '%E8%88%AA%E6%B5%B7%E5%A3%AB%EF%BC%8F%E3%83%8A%E3%83%93%E3%82%B2%E3%83%BC%E3%82%BF%E3%83%BC',
    '%E8%B2%B4%E6%97%8F%EF%BC%8F%E3%83%8E%E3%83%BC%E3%83%96%E3%83%AB',
    '%E7%89%A7%E7%AB%A5%EF%BC%8F%E3%83%8F%E3%83%BC%E3%82%BA%E3%83%9E%E3%83%B3',
    '%E5%AE%B6%E6%94%BF%E5%A9%A6%EF%BC%88%E5%A4%AB%EF%BC%89%EF%BC%8F%E3%83%8F%E3%82%A6%E3%82%B9%E3%82%AD%E3%83%BC%E3%83%91%E3%83%BC',
    '%E7%8B%A9%E4%BA%BA%EF%BC%8F%E3%83%8F%E3%83%B3%E3%82%BF%E3%83%BC',
    '%E9%AB%AA%E7%B5%90%E3%81%84%E3%83%BB%E7%90%86%E9%AB%AA%E5%B8%AB%EF%BC%8F%E3%83%90%E3%83%BC%E3%83%90%E3%83%BC',
    '%E7%94%A8%E5%BF%83%E6%A3%92%EF%BC%8F%E3%83%90%E3%82%A6%E3%83%B3%E3%82%B5%E3%83%BC',
    '%E5%9F%B7%E4%BA%8B%EF%BC%8F%E3%83%90%E3%83%88%E3%83%A9%E3%83%BC',
    '%E8%AA%BF%E9%A6%99%E5%B8%AB%EF%BC%8F%E3%83%91%E3%83%92%E3%83%A5%E3%83%BC%E3%83%9E%E3%83%BC',
    '%E8%8A%B8%E4%BA%BA%EF%BC%8F%E3%83%91%E3%83%95%E3%82%A9%E3%83%BC%E3%83%9E%E3%83%BC',
    '%E8%BE%B2%E5%A4%AB%EF%BC%8F%E3%83%95%E3%82%A1%E3%83%BC%E3%83%9E%E3%83%BC',
    '%E6%BC%81%E5%B8%AB%EF%BC%8F%E3%83%95%E3%82%A3%E3%83%83%E3%82%B7%E3%83%A3%E3%83%BC%E3%83%9E%E3%83%B3',
    '%E5%8D%A0%E3%81%84%E5%B8%AB%EF%BC%8F%E3%83%95%E3%82%A9%E3%83%BC%E3%83%81%E3%83%A5%E3%83%B3%E3%83%86%E3%83%A9%E3%83%BC',
    '%E9%8D%9B%E5%86%B6%E5%B1%8B%EF%BC%8F%E3%83%96%E3%83%A9%E3%83%83%E3%82%AF%E3%82%B9%E3%83%9F%E3%82%B9',
    '%E9%86%B8%E9%80%A0%E5%AE%B6%EF%BC%8F%E3%83%96%E3%83%AB%E3%83%AF%E3%83%BC',
    '%E5%A8%BC%E5%A9%A6%E3%83%BB%E7%94%B7%E5%A8%BC%EF%BC%8F%E3%83%97%E3%83%AD%E3%82%B9%E3%83%86%E3%82%A3%E3%83%81%E3%83%A5%E3%83%BC%E3%83%88',
    '%E7%89%A9%E4%B9%9E%E3%81%84%EF%BC%8F%E3%83%99%E3%82%AC%E3%83%BC',
    '%E7%B5%B5%E5%B8%AB%EF%BC%8F%E3%83%9A%E3%82%A4%E3%83%B3%E3%82%BF%E3%83%BC',
    '%E7%B4%8B%E7%AB%A0%E5%AD%A6%E8%80%85%EF%BC%8F%E3%83%98%E3%83%A9%E3%83%AB%E3%83%87%E3%82%A3%E3%82%B9%E3%83%88',
    '%E9%AA%A8%E7%B4%B0%E5%B7%A5%E5%B8%AB%EF%BC%8F%E3%83%9C%E3%83%BC%E3%83%B3%E3%82%AB%E3%83%BC%E3%83%90%E3%83%BC',
    '%E5%95%86%E4%BA%BA%EF%BC%8F%E3%83%9E%E3%83%BC%E3%83%81%E3%83%A3%E3%83%B3%E3%83%88',
    '%E6%8A%97%E5%A4%AB%EF%BC%8F%E3%83%9E%E3%82%A4%E3%83%8A%E3%83%BC',
    '%E7%B2%BE%E8%82%89%E6%A5%AD%E8%80%85%EF%BC%8F%E3%83%9F%E3%83%BC%E3%83%88%E3%83%91%E3%83%83%E3%82%AB%E3%83%BC',
    '%E7%94%A3%E5%A9%86%EF%BC%8F%E3%83%9F%E3%83%83%E3%83%89%E3%83%AF%E3%82%A4%E3%83%95',
    '%E6%BC%94%E5%A5%8F%E5%AE%B6%EF%BC%8F%E3%83%9F%E3%83%A5%E3%83%BC%E3%82%B8%E3%82%B7%E3%83%A3%E3%83%B3',
    '%E7%9F%B3%E5%B7%A5%EF%BC%8F%E3%83%A1%E3%83%BC%E3%82%BD%E3%83%B3',
    '%E5%8F%B8%E6%9B%B8%EF%BC%8F%E3%83%A9%E3%82%A4%E3%83%96%E3%83%A9%E3%83%AA%E3%82%A2%E3%83%B3',
    '%E6%9C%A8%E3%81%93%E3%82%8A%EF%BC%8F%E3%83%A9%E3%83%B3%E3%83%90%E3%83%BC%E3%82%B8%E3%83%A3%E3%83%83%E3%82%AF',
    '%E5%BE%A9%E5%85%83%E5%B8%AB%EF%BC%8F%E3%83%AA%E3%83%9A%E3%82%A2%E3%83%A9%E3%83%BC',
    '%E9%80%9A%E8%A8%B3%EF%BC%8F%E3%83%AA%E3%83%B3%E3%82%AE%E3%82%B9%E3%83%88',
    '%E8%82%89%E4%BD%93%E5%8A%B4%E5%83%8D%E8%80%85%EF%BC%8F%E3%83%AC%E3%82%A4%E3%83%90%E3%83%BC',
    '%E7%9A%AE%E9%9D%A9%E8%81%B7%E4%BA%BA%EF%BC%8F%E3%83%AC%E3%82%B6%E3%83%BC%E3%83%AF%E3%83%BC%E3%82%AB%E3%83%BC',
    '%E9%A6%AC%E5%85%B7%E8%81%B7%E4%BA%BA%EF%BC%8F%E3%83%AD%E3%83%BC%E3%83%AA%E3%83%9E%E3%83%BC',
    '%E8%9D%8B%E7%87%AD%E8%81%B7%E4%BA%BA%EF%BC%8F%E3%83%AF%E3%83%83%E3%82%AF%E3%82%B9%E3%83%81%E3%83%A3%E3%83%B3%E3%83%89%E3%83%A9%E3%83%BC',
  );
  my @result;
  if($quant > @line) { $quant = @line; }
  for (my $i=0; $i < $quant; $i++) {
    my $number = int(rand(@line));
    if (!$line[$number]) { $i--; }
    else {
      push(@result, dice_deco($line[$number]));
    $line[$number] = '';
    }
  }
  return "<span style=\"color:$color_job;font-size:83%;\">".join(' , ',@result).'</span>';
}

sub dx3_emo {
  my $out;
  if   ($_[0] =~ /^(emop|感情p)/i){ $out = 'P:'.&dx_emo_p; }
  elsif($_[0] =~ /^(emon|感情n)/i){ $out = 'N:'.&dx_emo_n; }
  else {
    my $c = int(rand(2));
    $out = 'P:'.($c?"\x{2611}":'□').&dx_emo_p.' ／ N:'.($c?'□':"\x{2611}").&dx_emo_n;
  }
  return '<span style="color:'.$color_emo.';">'.$out.'</span>';
}

sub dx_emo_p {
  my @line = (
    '好奇心','憧憬','尊敬','連帯感','慈愛','感服','純愛','友情','慕情','同情',
    '遺志','庇護','幸福感','信頼','執着','親近感','誠意','好意','有為','尽力',
  );
  return $line[int(rand(@line))]
}
sub dx_emo_n {
  my @line = (
    '食傷','脅威','嫉妬','悔悟','恐怖','不安','劣等感','疎外感','恥辱','憐憫',
    '偏愛','憎悪','隔意','嫌悪','猜疑心','厭気','不信感','不快感','憤懣','敵愾心',
  );
  return $line[int(rand(@line))]
}

sub number {
  my ($or_quant,$quant,$faces) = @_;
  my $out;
  $quant = 1 if(!$quant);
  if   ($quant < 1 || $quant > 200) { return $or_quant.'@'.$faces.' → 1～200@の間に収めてください'; }
  elsif($faces < 2 || $faces > 1000){ return $or_quant.'@'.$faces.' → @2～1000の間に収めてください'; }
  my @line = &shuffle(1..$faces);
  $quant = @line if($quant > @line);
  $out = $or_quant.'@'.$faces.' → ';
  for (1..$quant) {
    $out .= $line[$_-1];
    last if $_ >= $quant;
    $out .= ' , ';
  }
  $out .= '</span>';
  return $out;
}

sub shuffle {
  my @list = @_;
  for my $i (0..$#list) {
    my $rand = int(rand(@list));
    my $tmp = $list[$i];
    $list[$i] = $list[$rand];
    $list[$rand] = $tmp;
  }
  return @list;
}

sub dice_deco {
  my $text = shift;
  $text =~ tr/+/ /;
  $text =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $text  = Encode::decode('utf8', $text);
  return $text;
}

1;