#use strict;
#use warnings;
use utf8;
use open ":utf8";
use open ":std";

require './pl/colors.pl';

my @faces = split(/,/, $set::dice_faces);

my $wide  = $::in{'wide'};
my $gm    = $::in{'gm'};
my $simple= $::in{'simple'};
my $game;
my $upper;

if($gm) {
  $set::dice_lines_def = $set::dice_lines_gm;
  $set::rate_lines_def = $set::rate_lines_gm;
}

my $name; my $color; my $reload; my $font;
if($::co{'name'})  { $name  = $::co{'name'}; }
if($::co{'color'}) { $color = $::co{'color'}; } else { $color = $set::color_name_def; }
if($::co{'game'})  { $game  = $::co{'game'};  } else { $game = $set::gamesystem }
if($::co{'upper'}) { $upper = $::co{'upper'}; }

print "Content-type: text/html\n\n";
print <<"HTML";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <title>$set::title</title>
  <link rel="stylesheet" type="text/css" href="./css/form.css">
  <style type="text/css">
  body  { margin:0px; padding:5px 5px 5px 15px; background-color:$set::color_back; color:$set::color_font; font-size:13px; line-height:13px; }
  table,tr,td,th,p
        { margin:0px; padding:0px; border:0px; }
  table { border-collapse:collapse; }
  form  { margin:0px; display:inline; }
  input,select
        { margin:1px; padding:0px 1px; vertical-align:middle; }
  h1    { margin:0px 0px 5px 0px; padding:0px 0px 5px 0px; border-bottom:1px dotted $set::color_font; font-size:16px; color:$set::color_title; font-weight:bold; }
  p.line{ margin:0px 0px 5px 0px; padding:0px 0px 5px 0px; border-bottom:1px dotted $set::color_font; }
  a:link   { color:$set::color_a_link; text-decoration:none; }
  a:visited{ color:$set::color_a_visited; text-decoration:none; }
  a:hover  { color:$set::color_a_hover; }
  </style>
  <script language="JavaScript">
  function colorchange(num){
    if(!num){
      self.document.getElementById("c_view"+num).style.color = self.document.send.elements["color"].value;
    } else {
      self.document.getElementById("c_view"+num).style.color = self.document.send.elements["n_color"+num].value;
    }
  }
  function colorselect(opt,num){
    if(!num){
      self.document.send.color.value = opt.options[opt.selectedIndex].value;
    } else {
      self.document.send.elements["n_color"+num].value = opt.options[opt.selectedIndex].value;
    }
    opt.style.color = opt.options[opt.selectedIndex].value;
    colorchange(num);
  }
  function selectboxadd(num){
    self.document.getElementById("c_select_area"+num).innerHTML = '<select id="colorbox'+num+'" onChange="colorselect(this,'+num+')" style="background-color:$set::color_back;color:$set::color_font;@{[($gm)?'margin-bottom:6px':'']}">@{[&colorbox]}</select><input type="button" onclick="selectboxdel('+num+')" value="×" style="width:20px;@{[($gm)?'margin-bottom:6px':'']}">';
    var Color;
    if(!num){
      Color = self.document.send.elements["color"].value;
    } else {
      Color = self.document.send.elements["n_color"+num].value;
    }
    for (i = 0; i < self.document.getElementById("colorbox"+num).options.length; i++) {
        if (self.document.getElementById("colorbox"+num).options[i].value == Color) {
            self.document.getElementById("colorbox"+num).selectedIndex = i;
            break;
        }
    }
    self.document.getElementById("colorbox"+num).style.color = self.document.getElementById("colorbox"+num).options[self.document.getElementById("colorbox"+num).selectedIndex].value;
  }
  function selectboxdel(num){
    self.document.getElementById("c_select_area"+num).innerHTML = '';
  }
  function refresh(){
   parent.logs.location.href = "${set::chat}?mode=view";
  }
  </script>
</head>
<body>
  <h1@{[ $simple ? ' style="float:left;margin-right:10px;padding-right:10px;border-right:1px dotted '.$set::color_font.';"':'' ]}>$set::title</h1>
HTML
  if($_[0] eq 'leave') { print "  <p class=\"line\"><b style=\"color:$set::color_dice\">退室しました。</b><p>\n"; }
  print <<"HTML";
  <p class="line">
    [ <a href="$set::url_home" target="_top">HOME</a> ] 
HTML
  if(!$wide && !$simple){ print " [ 上下分割 ] "; } else { print " [ <a href=\"$set::url_frame\" target=\"_top\">上下分割</a> ] "; }
  if( $wide){ print " [ 左右分割 ] "; } else { print " [ <a href=\"$set::url_frame?wide=1\" target=\"_top\">左右分割</a> ] "; }
  if($simple){ print " [ 簡易 ] "; } else { print " [ <a href=\"$set::url_frame?simple=1\" target=\"_top\">簡易</a> ] "; }
  print <<"HTML";
    [ <a href="./help.html" target="logs">取扱説明書</a> ] 
    [ <a href="./$set::col_cgi" target="_blank">色一覧</a> ]
  <p>
  <form method="POST" name="send" action="$set::cgifile">
    <input type="hidden" name="mode" value="enter">
    <input type="hidden" name="wide" value="$wide">
    <input type="hidden" name="gm" value="$gm">
    <input type="hidden" name="simple" value="$simple">
    <table style="float:left;margin:0px 5px 20px 0px;">
      <tr>
        <th>名前</th><td> : <input type="text" name="name" style="width:130px" value="$name"></td>
      @{[ !$wide ? '  <td>　</td>' : '</tr><tr>' ]}
        <th>名前色</th><td> : <span class="c_view" id="c_view0" style="color:$color;">◆</span><input type="text" name="color" value="$color" onChange="colorchange(0)" class="text" style="width:96px;"><input type="button" onclick="selectboxadd(0)" value="▼" style="width:20px;"></td>
      </tr>
      <tr><td colspan="2" @{[ !$wide ? '' : ' id="c_select_area0"' ]} style="text-align:right;"></td></tr>
      <tr>
        <th>システム</th>
        <td colspan="2"> : 
          <select name="game">
          <option value="non" @{[ $game eq 'non' ? 'selected' : '' ]}>なし</option>
          <option value="sw2" @{[ $game eq 'sw2' ? 'selected' : '' ]}>ソードワールド2.0</option>
          <option value="dx3" @{[ $game eq 'dx3' ? 'selected' : '' ]}>ダブルクロス3rd</option>
          <option value="s-f" @{[ $game eq 's-f' ? 'selected' : '' ]}>セブンフォートレス</option>
          <option value="ang" @{[ $game eq 'ang' ? 'selected' : '' ]}>エンゼルギアなど</option>
          <option value="geh" @{[ $game eq 'geh' ? 'selected' : '' ]}>ゲヘナ</option>
          </select>
        </td>
        <td colspan="2" @{[ !$wide ? ' id="c_select_area0"' : '' ]} style="text-align:right;"></td>
        <td style="text-align:right;vertical-align:bottom; @{[ $wide ? 'padding-left:1em;' : '' ]}"><input type="checkbox" name="upper" value="1" @{[ $upper ? 'checked' : '' ]} style="vertical-align:bottom;">ダイスコード版</td>
        <td style="text-align:right;"><input type="submit" value=" 入室 "></td>
      </tr>
    </table>
  </form>
  <noscript>
    <table style="width:400px;height:50px;"><tr><td style="color:red;">このチャットはJavaScript必須です</td></tr>
  </noscript>
</body>
</html>
HTML

sub colorbox {
  my $box;
  for(@::colors) {
    $box .= "<option value=\"@$_[0]\" style=\"color:@$_[0];\"";
      @$_[1] =~ s/\'/’/g;
    $box .= ">@$_[1]</option>";
  }
  return $box;
}

1;