#use strict;
#use warnings;
use utf8;
use open ":utf8";
use open ":std";

require './pl/colors.pl';

$::in{'name'} =~ s/"/&quot;/g;

my @faces = split(/,/, $set::dice_faces);

my $wide  = $::in{'wide'};
my $gm    = $::in{'gm'};
my $simple= $::in{'simple'};
my $upper = $::in{'upper'};
my $game  = $::in{'game'};

if($simple){
  $::in{'dice_lines'} = 0;
  $::in{'npc_lines'}  = 0;
  $::in{'npc_lines'}  = 1;
} elsif($game && $set::lines_def{$game}) {
  $::in{'dice_lines'} = $set::lines_def{$game}[0];
  $::in{'rate_lines'} = $set::lines_def{$game}[1];
  $::in{'npc_lines'}  = $set::npc_lines_def;
} else {
  $::in{'dice_lines'} = $set::lines_def{'non'}[0];
  $::in{'rate_lines'} = $set::lines_def{'non'}[1];
  $::in{'npc_lines'}  = $set::npc_lines_def;
}

$::in{'dice_lines'} = $::in{'dice_lines'} ? $::in{'dice_lines'} : 1;
$::in{'rate_lines'} = $::in{'rate_lines'} ? $::in{'rate_lines'} : 1;
$::in{'npc_lines'}  = $::in{'npc_lines'}  ? $::in{'npc_lines'}  : 1;

if   ($game eq 'sw2'){ $set::dice_quan_def = 2; $set::dice_face_def = 6;  }
elsif($game eq 'dx3'){ $set::dice_quan_def = 1; $set::dice_face_def = 10; }

my $upper_def1 = ($game eq 'dx3' ? '[1d10]' : $game eq 'sw2' ? '[2d6]' : '[]');
my $upper_def2 = ($game eq 'dx3' ? '[1R10]' : $game eq 'sw2' ? '[R0]'  : '[]');

my $dnum = $::in{'dice_lines'};
my $rnum = $::in{'dice_lines'} + $::in{'rate_lines'};
   $rnum-- if $rnum > 5;
if($simple){ $dnum = $rnum = 0; }
my $code_line = $rnum;

print "Content-type: text/html\n\n";
print <<"HTML";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <title>$set::title</title>
  <link rel="stylesheet" type="text/css" href="./css/form.css">
  <style type="text/css">
  body {
    background-color:$set::color_back;
    color:$set::color_font;
  }
  a:link   { color:$set::color_a_link; }
  a:visited{ color:$set::color_a_visited; }
  a:hover  { color:$set::color_a_hover; }
  #npc_line .colorbox select {
    background-color:$set::color_back;
  }
  </style>
  <script language="JavaScript">
  var Game = '$game';
  
  var DiceQuant= $set::dice_quan_def;
  var DiceFace = $set::dice_face_def;
  
  var CodeLine = $code_line;
  var DiceLine = $::in{'dice_lines'};
  var RateLine = $::in{'rate_lines'};
  var DxdcLine = $::in{'rate_lines'};
  var AgdcLine = $::in{'rate_lines'};
  var GeheLine = $::in{'rate_lines'};
  var SfdcLine = $::in{'rate_lines'};
  var NpcLine = $::in{'npc_lines'};
  
  var Upper    = @{[ $upper ? 1 : 0 ]};
  var NpcOn    = @{[ $gm ? 1 : 0 ]};
  var StatusOn = @{[ $simple ? 0 : 1 ]};
  var Memo1On  = @{[ $simple ? 0 : 1 ]};
  var Memo1Ht  = @{[ $simple ? 1 : $wide ? 6 : 4 ]}
  var Memo2On  = @{[ $simple ? 0 : 1 ]};
  var Memo2Ht  = @{[ $simple ? 1 : $wide ? 4 : 1 ]}
  var Position = @{[ $simple ? 12 : $wide ? 22 : 10 ]};
  var TextArea = 0;
  var ColorBox = new Array();
  function selectboxadd(num){
    if(ColorBox[num]){
      ColorBox[num] = 0;
      self.document.getElementById("c_select_area"+num).innerHTML = '';
    } else {
      ColorBox[num] = 1;
      self.document.getElementById("c_select_area"+num).innerHTML = '<select id="colorbox'+num+'" onChange="colorselect(this,'+num+')">@{[&colorbox]}</select>';
      var Color;
      if(!num){
        Color = self.document.send.elements["color"].value;
      } else {
        Color = self.document.send.elements["n_color"+num].value;
      }
      for (i = 0; i < self.document.getElementById("colorbox"+num).options.length; i++) {
          if (self.document.getElementById("colorbox"+num).options[i].value == Color) {
              self.document.getElementById("colorbox"+num).selectedIndex = i;
              break;
          }
      }
      self.document.getElementById("colorbox"+num).style.color = self.document.getElementById("colorbox"+num).options[self.document.getElementById("colorbox"+num).selectedIndex].value;
    }
  }
  function refresh(){
   var Name = "$::in{'name'}";
   Name = encodeURIComponent(Name);
   var Status;
   var Game = "&game=" + self.document.send.game.value;
   var Hp = self.document.send.hp.value;
   var Mp = self.document.send.mp.value;
   var Gp = self.document.send.gp.value;
   var Pp = self.document.send.pp.value;
   Hp = encodeURIComponent(Hp);
   Mp = encodeURIComponent(Mp);
   Gp = encodeURIComponent(Gp);
   Pp = encodeURIComponent(Pp);
   var Nb = (parent.logs.NewBottom == 1 ? "&nb=1" : "");
   if(self.document.send.stt_on.checked){
    Status = "&stt_on=1&hp=" + Hp + "&mp=" + Mp + "&gp=" + Gp + "&pp=" + Pp;
   } else {
    Status = '';
   }
   var Select = parent.logs.document.getElementById("font_size");
   var Font;
   try {
    Font = "&font=" + Select.options[Select.selectedIndex].value;
   } catch(e) { }
   parent.logs.location.href = "${set::chat}?mode=view&name="+Name+Game+Status+Font+Nb;
  }
  </script>
</head>
<body>
<iframe src="about:blank" style="margin:0;padding:0;width:0;height:0;display:none" name="submit"></iframe>

<div id="contents">
<form name="send" method="POST" action="./chat.cgi" target="submit" autocomplete="off" onSubmit="return submit_check();">
<input type="hidden" name="mode" value="regist">
<input type="hidden" name="name" value="$::in{'name'}">
<input type="hidden" name="game" value="$game">
<input type="hidden" name="act">
<input type="hidden" name="dq0"><input type="hidden" name="df0"><input type="hidden" name="dc0" value="0x"><input type="hidden" name="da0x">
<input type="hidden" name="rt0"><input type="hidden" name="ra0"><input type="hidden" name="rh0"><input type="hidden" name="rp0"><input type="hidden" name="cr0"><input type="hidden" name="ca0"><input type="hidden" name="cy0">
<input type="hidden" name="dxq0"><input type="hidden" name="dxc0"><input type="hidden" name="dxr0" value="0x"><input type="hidden" name="dxa0x">
<input type="hidden" name="sfc0"><input type="hidden" name="sff0"><input type="hidden" name="sfr0" value="0x"><input type="hidden" name="sfa0x">
<input type="hidden" name="agq0"><input type="hidden" name="ags0"><input type="hidden" name="agr0" value="0x"><input type="hidden" name="aga0x">
<input type="hidden" name="geq0"><input type="hidden" name="geb0"><input type="hidden" name="ger0" value="0x"><input type="hidden" name="gea0x">


<div class="left" id="main">
  <input type="submit" value="発言" tabindex="2" style="float:left;"><input type="button" value="修復" style="float:right;width:32px;" onClick="restore()"><input type="button" value="複数行" style="float:right;width:45px;" onClick="txtarea()">
  <div id="commarea"><input type="text" name="comm" tabindex="2" style="width:100%;"></div>
  <div id="dice_upper">
    <table id="code_line">
    <tr><td>
HTML
  for(my $i = 1;       $i <= $dnum; $i++) { print "    <tr><td>".&makecodebox($i,$upper_def1,3)."</td></tr>\n"; }
  for(my $i = $dnum+1; $i <= $rnum; $i++) { print "    <tr><td>".&makecodebox($i,$upper_def2,3)."</td></tr>\n"; }
print <<"HTML";
    </td></tr>
    </table>
  </div>
  <div id="dice_lower">
    <table id="dice_line">
    <tr><td>
HTML
  for(my $i = 1; $i <= $::in{'dice_lines'}; $i++) { print "    <tr><td>".&makedice($i,3)."</td></tr>\n"; }
print <<"HTML";
    </td></tr>
    </table>
    <table id="rate_line">
    <tr><td>
HTML
  for(my $i = 1; $i <= $::in{'rate_lines'}; $i++) { print "    <tr><td>".&makerate($i)."</td></tr>\n"; }
print <<"HTML";
    </td></tr>
    </table>
    <table id="dxdc_line">
    <tr><td>
HTML
  for(my $i = 1; $i <= $::in{'rate_lines'}; $i++) { print "    <tr><td>".&makedxdc($i)."</td></tr>\n"; }
print <<"HTML";
    </td></tr>
    </table>
    <table id="sfdc_line">
    <tr><td>
HTML
  for(my $i = 1; $i <= $::in{'rate_lines'}; $i++) { print "    <tr><td>".&makesfdc($i)."</td></tr>\n"; }
print <<"HTML";
    </td></tr>
    </table>
    <table id="agdc_line">
    <tr><td>
HTML
  for(my $i = 1; $i <= $::in{'rate_lines'}; $i++) { print "    <tr><td>".&makeagdc($i)."</td></tr>\n"; }
print <<"HTML";
    </td></tr>
    </table>
    <table id="gehe_line">
    <tr><td>
HTML
  for(my $i = 1; $i <= $::in{'rate_lines'}; $i++) { print "    <tr><td>".&makegehe($i)."</td></tr>\n"; }
print <<"HTML";
    </td></tr>
    </table>
  </div>
</div>

<div class="center" id="npc">
  <table id="npc_line">
  <tr><td>
    <table>
    <tr>
    <td style="width:13px;"><input type="radio" name="n_check" value="0" class="radi" checked></td>
    <td><input type="text" name="name" value="$::in{'name'}" class="text" style="border-color:$set::color_back;background-color:$set::color_back;color:$set::color_font;" readonly></td>
    <td class="c_view" id="c_view0" style="color:$::in{'color'};width:13px;">◆</td>
    <td style="width:66px;"><input type="text" name="color" value="$::in{'color'}" onChange="colorchange(0)"></td>
    <td style="width:20px;"><input type="button" onclick="selectboxadd(0)" value="▼"></td>
    </tr>
    </table>
    <div class="colorbox" id="c_select_area0"></div>
HTML
  for(my $i = 1; $i <= $::in{'npc_lines'}; $i++) { print "    <tr><td>".&makenpc($i)."</td></tr>\n"; }
  print <<"HTML";
  </td></tr>
  </table>
</div>

<div class="right" id="status">
  <table>
  <tr>
    <td style="width:13px;" id="st_check"><input type="checkbox" name="stt_on" value="1"></td>
    <td style="width:20px;" id="hp_th">HP</td><td id="hp_td"><input type="text" name="hp" value="$::in{'hp'}"></td>
HTML
  if($game eq 'sw2'){
  print <<"HTML";
    <td style="width:20px;" id="mp_th">MP</td><td id="mp_td"><input type="text" name="mp" value="$::in{'mp'}"></td>
    <td style="width:15px;" id="gp_th">防</td><td id="gp_td"><input type="text" name="gp" value="$::in{'gp'}"></td>
    <td style="width:0;" id="pp_th"></td><td style="width:0;" id="pp_td"><input type="hidden" name="pp" value="$::in{'pp'}"></td>
HTML
  }
  elsif($game eq 'dx3'){
  print <<"HTML";
    <td style="width:26px;" id="mp_th">行動</td><td id="mp_td"><input type="text" name="mp" value="$::in{'mp'}"></td>
    <td style="width:26px;" id="gp_th">侵蝕</td><td id="gp_td"><input type="text" name="gp" value="$::in{'gp'}"></td>
    <td style="width:0;" id="pp_th"></td><td style="width:0;" id="pp_td"><input type="hidden" name="pp" value="$::in{'pp'}"></td>
HTML
  }
  elsif($game eq 's-f'){
  print <<"HTML";
    <td style="width:26px;" id="mp_th">MP</td><td id="mp_td"><input type="text" name="mp" value="$::in{'mp'}"></td>
    <td style="width:26px;" id="gp_th">プラ</td><td id="gp_td"><input type="text" name="gp" value="$::in{'gp'}"></td>
    <td style="width:26px;" id="pp_th">行動</td><td id="pp_td"><input type="text" name="pp" value="$::in{'pp'}"></td>
HTML
  }
  else {
  print <<"HTML";
    <td style="width:20px;" id="mp_th">MP</td><td id="mp_td"><input type="text" name="mp" value="$::in{'mp'}"></td>
    <td style="width:15px;" id="gp_th">他</td><td id="gp_td"><input type="text" name="gp" value="$::in{'gp'}"></td>
    <td style="width:0;" id="pp_th"></td><td style="width:0;" id="pp_td"><input type="hidden" name="pp" value="$::in{'pp'}"></td>
HTML
  }
  print <<"HTML";
  </tr>
  </table>
  <table style="position:relative;"><tr><td style="width:55px;" id="st_th">他</td><td id="st_td"><input type="text" name="st" value="$::in{'st'}"></td><td style="width:28px"><input type="button" value="更新" onClick="parent.logs.mem_check(0)"></td></tr></table>
</div>
<div class="right" id="memo1">
  <input type="checkbox" name="sup_on1" value="1" style="position:relative;">メモ<br>
  <textarea name="supp1" id="supp1" style="width:100%;"></textarea>
</div>
<div class="right" id="memo2">
  <div style="float:left;"><input type="checkbox" name="sup_on2" value="1" style="position:relative;">メモ</div>
  <div style="margin-left:40px;"><textarea name="supp2" id="supp2" style="width:100%;"></textarea></div>
</div>

</form>
</div>

<div id="side">
  <form id="leave" name="leave" action="$set::cgifile" method="POST" target="_top">
    <input type="submit" value="退室" style="width:50px;">
    <input type="hidden" name="mode" value="leave">
    <input type="hidden" name="name" value="$::in{'name'}">
    <input type="hidden" name="color" value="$::in{'color'}">
    <input type="hidden" name="wide" value="$::in{'wide'}">
    <input type="hidden" name="gm" value="$::in{'gm'}">
  </form>
  <input id="refresh" type="button" value="refresh" style="width:50px" onClick="refresh()" title="下部フレームをリフレッシュ">
</div>

<script src="./js/form.js?." type="text/javascript"></script>

</body>
</html>
HTML


sub makecodebox {
  my $i = shift;
  my $j = shift;
  my $k = shift;
  my $out;
  $out .= '<table><tr>';
  $out .= '<td style="width:23px;"><input type="button" value="D" tabindex="3" class="dice" onClick=dice("DC'.$i.'a");></td><td><input type="text" id="DC'.$i.'a" value="'.$j.'"></td>';
  $out .= '<td style="width:23px;"><input type="button" value="D" tabindex="3" class="dice" onClick=dice("DC'.$i.'b");></td><td><input type="text" id="DC'.$i.'b" value="'.$j.'"></td>' if $k >= 2;
  $out .= '<td style="width:23px;"><input type="button" value="D" tabindex="3" class="dice" onClick=dice("DC'.$i.'c");></td><td><input type="text" id="DC'.$i.'c" value="'.$j.'"></td>' if $k >= 3;
  $out .= '<td style="width:23px;"><input type="button" value="D" tabindex="3" class="dice" onClick=dice("DC'.$i.'d");></td><td><input type="text" id="DC'.$i.'d" value="'.$j.'"></td>' if $k >= 4;
  $out .= '<td style="width:23px;"><input type="button" value="D" tabindex="3" class="dice" onClick=dice("DC'.$i.'e");></td><td><input type="text" id="DC'.$i.'e" value="'.$j.'"></td>' if $k >= 5;
  $out .= '</tr></table>';
  return $out;
}

sub makedice {
  my $i = shift;
  my $j = shift;
  my $out;
  $out .= '<table><tr>';
  $out .= '<td style="width:52px;"><input type="button" value="ダイス'.$i.'" tabindex="3" class="dice" onClick="action_dice('.$i.')"></td>';
  $out .= '<td style="width:10%;"><input type="text" id="D_quant'.$i.'" value="'.$set::dice_quan_def.'"></td>';
  $out .= '<td style="width:11px;"><b>D</b></td>';
  $out .= '<td style="width:50px;"><input type="text" id="D_face'.$i.'" value="'.$set::dice_face_def.'"></td>';
  $out .= '<td style="width:25px;"> +<input type="radio" name="D_radio'.$i.'" value="'.$i.'a"></td><td><input type="text" id="D_add'.$i.'a"></td>';
  $out .= '<td style="width:28px;">or<input type="radio" name="D_radio'.$i.'" value="'.$i.'b"></td><td><input type="text" id="D_add'.$i.'b"></td>' if $j >= 2;
  $out .= '<td style="width:28px;">or<input type="radio" name="D_radio'.$i.'" value="'.$i.'c"></td><td><input type="text" id="D_add'.$i.'c"></td>' if $j >= 3;
  $out .= '<td style="width:28px;">or<input type="radio" name="D_radio'.$i.'" value="'.$i.'d"></td><td><input type="text" id="D_add'.$i.'d"></td>' if $j >= 4;
  $out .= '<td style="width:28px;">or<input type="radio" name="D_radio'.$i.'" value="'.$i.'e"></td><td><input type="text" id="D_add'.$i.'e"></td>' if $j >= 5;
  $out .= '</tr></table>';
  return $out;
}
sub makerate {
  my $i = shift;
  my $out;
  $out .= '<table><tr>';
  $out .= '<td style="width:52px;"><input type="button" value="威力表'.$i.'" tabindex="4" class="rate" onClick="action_rate('.$i.')"></td>';
  $out .= '<td style="width:50px;"><select id="Rt_power'.$i.'">';
  for(0..100) { $out .= '<option>'.$_.'</option>'; }
  $out .= '</select></td>';
  $out .= '<td style="width:13px;">+</td><td><input type="text" id="Rt_add'.$i.'"></td>';
  $out .= '<td style="width:40px;">半減<input type="checkbox" id="Rt_half'.$i.'"></td>';
  $out .= '<td style="width:13px;">+</td><td><input type="text" id="Rt_plus'.$i.'"></td>';
  $out .= '<td style="width:22px;">C値</td><td style="width:40px;"><select id="Rt_crit'.$i.'">';
  for(7..12) { $out .= '<option>'.$_.'</option>'; }
  $out .= '<option value="13" selected>-</option>';
  $out .= '</select></td>';
  $out .= '<td style="width:26px;">必殺</td><td style="width:45px;"><select id="Rt_catk'.$i.'">';
  for(0..9) { $out .= '<option value="'.$_.'">+'.$_.'</option>'; }
  $out .= '</select></td>';
  $out .= '<td style="width:35px;">Cレイ</td><td style="width:45px;"><select id="Rt_cray'.$i.'">';
  for(0..9) { $out .= '<option value="'.$_.'">+'.$_.'</option>'; }
  $out .= '</select></td>';
  $out .= '</tr></table>';
  return $out;
}
sub makedxdc {
  my $i = shift;
  my $out;
  $out .= '<table><tr>';
  $out .= '<td style="width:52px;"><input type="button" value="DX'.$i.'" tabindex="4" class="dxdc" onClick="action_dxdc('.$i.')"></td>';
  $out .= '<td><input type="text" id="DX_quant'.$i.'"></td>';
  $out .= '<td style="width:11px;"><b>R</b></td><td><input type="text" id="DX_crit'.$i.'" value="10"></td>';
  $out .= '<td style="width:25px;"> +<input type="radio" name="DX_radio'.$i.'" value="'.$i.'a"></td><td><input type="text" id="DX_add'.$i.'a"></td>';
  $out .= '<td style="width:28px;">or<input type="radio" name="DX_radio'.$i.'" value="'.$i.'b"></td><td><input type="text" id="DX_add'.$i.'b"></td>';
  $out .= '</select></td>';
  $out .= '</tr></table>';
  return $out;
}
sub makesfdc {
  my $i = shift;
  my $out;
  $out .= '<table><tr>';
  $out .= '<td style="width:52px;"><input type="button" value="S=F'.$i.'" tabindex="4" class="sfdc" onClick="action_sfdc('.$i.')"></td>';
  $out .= '<td style="width:20px;">C値</td><td><input type="text" id="SF_crit'.$i.'" value=""></td>';
  $out .= '<td style="width:20px;">F値</td><td><input type="text" id="SF_fumb'.$i.'" value=""></td>';
  $out .= '<td style="width:25px;"> +<input type="radio" name="SF_radio'.$i.'" value="'.$i.'a"></td><td><input type="text" id="SF_add'.$i.'a"></td>';
  $out .= '<td style="width:28px;">or<input type="radio" name="SF_radio'.$i.'" value="'.$i.'b"></td><td><input type="text" id="SF_add'.$i.'b"></td>';
  $out .= '<td style="width:28px;">or<input type="radio" name="SF_radio'.$i.'" value="'.$i.'c"></td><td><input type="text" id="SF_add'.$i.'c"></td>';
  $out .= '</select></td>';
  $out .= '</tr></table>';
  return $out;
}
sub makeagdc {
  my $i = shift;
  my $out;
  $out .= '<table><tr>';
  $out .= '<td style="width:52px;"><input type="button" value="AG'.$i.'" tabindex="4" class="agdc" onClick="action_agdc('.$i.')"></td>';
  $out .= '<td><input type="text" id="AG_quant'.$i.'"></td>';
  $out .= '<td style="width:11px;"><b>C</b></td><td style="width:10%;"><input type="text" id="AG_skill'.$i.'" value="1"></td>';
  $out .= '<td style="width:25px;"> +<input type="radio" name="AG_radio'.$i.'" value="'.$i.'a"></td><td><input type="text" id="AG_add'.$i.'a"></td>';
  $out .= '<td style="width:28px;">or<input type="radio" name="AG_radio'.$i.'" value="'.$i.'b"></td><td><input type="text" id="AG_add'.$i.'b"></td>';
  $out .= '<td style="width:28px;">or<input type="radio" name="AG_radio'.$i.'" value="'.$i.'c"></td><td><input type="text" id="AG_add'.$i.'c"></td>';
  $out .= '</tr></table>';
  return $out;
}
sub makegehe {
  my $i = shift;
  my $out;
  $out .= '<table><tr>';
  $out .= '<td style="width:52px;"><input type="button" value="ゲヘナ'.$i.'" tabindex="4" class="gedc" onClick="action_gehe('.$i.')"></td>';
  $out .= '<td><input type="text" id="Ge_quant'.$i.'"></td>';
  $out .= '<td style="width:11px;"><b>G</b></td><td style="width:10%;"><input type="text" id="Ge_base'.$i.'" value="4"></td>';
  $out .= '<td style="width:25px;"> +<input type="radio" name="Ge_radio'.$i.'" value="'.$i.'a"></td><td><input type="text" id="Ge_add'.$i.'a"></td>';
  $out .= '<td style="width:28px;">or<input type="radio" name="Ge_radio'.$i.'" value="'.$i.'b"></td><td><input type="text" id="Ge_add'.$i.'b"></td>';
  $out .= '<td style="width:28px;">or<input type="radio" name="Ge_radio'.$i.'" value="'.$i.'c"></td><td><input type="text" id="Ge_add'.$i.'c"></td>';
  $out .= '</tr></table>';
  return $out;
}

sub makenpc {
  my $i = shift;
  my $out;
  my $color = $::colors[int(rand(@::colors))][0];
  $out .= '<table><tr>';
  $out .= '<td style="width:13px;"><input type="radio" name="n_check" value="'.$i.'"></td>';
  $out .= '<td><input type="text" name="n_name'.$i.'"></td>';
  $out .= '<td style="width:13px;color:'.$color.'" class="c_view" id="c_view'.$i.'">◆</td>';
  $out .= '<td style="width:66px;"><input type="text" name="n_color'.$i.'" value="'.$color.'" onChange="colorchange('.$i.')"></td>';
  $out .= '<td style="width:20px;"><input type="button" onclick="selectboxadd('.$i.')" value="▼"></td>';
  $out .= '</tr></table><div class="colorbox" id="c_select_area'.$i.'"></div>';
  return $out;
}

sub colorbox {
  my $box;
  for(@::colors) {
    $box .= '<option value="'.@$_[0].'" style="color:'.@$_[0].';"';
      @$_[1] =~ s/\'/’/g;
    $box .= '>'.@$_[1].'</option>';
  }
  return $box;
}

1;